<?php
//crmv@start

require_once('config.inc.php');
/** Verify the script call is from trusted place. */
global $application_unique_key;
if($_REQUEST['app_key'] != $application_unique_key) {
	echo "Access denied!";
	exit;
}

/**
 * Check if instance of this service is already running?
 */
$svcname = $_REQUEST['service'];
// We need to make sure the PIDfile name is unqique
$servicePIDFile = "logs/$svcname-service.pid";

if(file_exists($servicePIDFile)) {
	if (filemtime($servicePIDFile) <= strtotime('-1 hour')) {
		@unlink($servicePIDFile);
		$servicePIDFp = fopen($servicePIDFile, 'a');
	} else {
		echo "Service $svcname already running! Check $servicePIDFile";
		exit;
	}
} else {
	$servicePIDFp = fopen($servicePIDFile, 'a');
}

/**
 * Turn-off PHP error reporting.
 */
//try { error_reporting(0); } catch(Exception $e) { }
//crmv@36796
/**
 * Set time limit to 1 hour default.
 */
try { set_time_limit(3600); } catch(Exception $e) { }
//crmv@36796 e

require_once('include/utils/utils.php');
require_once('include/logging.php');

// Get the list of Invoice for which Recurring is enabled.

global $adb, $log, $current_user,$table_prefix;
$log =& LoggerManager::getLogger('ModNotifications');
$log->debug("invoked ModNotifications");

$focus = CRMEntity::getInstance('ModNotifications');
$query = "SELECT id FROM ".$table_prefix."_users WHERE notify_me_via = 'ModNotifications' AND notify_summary NOT IN ('','Never') AND deleted = 0 AND status = 'Active'"; //crmv@33465
$result = $adb->query($query);
if ($result && $adb->num_rows($result) > 0) {
	while($row=$adb->fetchByAssoc($result)) {
		$focus->sendNotificationSummary($row['id']);
	}
}

checkAllListNotificationCount();

$log->debug("end ModNotifications procedure");
/** Close and remove the PID file. */
if($servicePIDFp) {
	fclose($servicePIDFp);
	unlink($servicePIDFile);
}

//crmv@end
?>