<?php
/*+***********************************************************************************
 * The contents of this file are subject to the vtiger CRM Public License Version 1.0
 * ("License"); You may not use this file except in compliance with the License
 * The Original Code is:  vtiger CRM Open Source
 * The Initial Developer of the Original Code is vtiger.
 * Portions created by vtiger are Copyright (C) vtiger. All Rights Reserved.
 * Contributor(s): Valmir Carlos Trindade/Translate to Brazilian Portuguese|30/03/2012|Curitiba/Paran/Brasil.|www.ttcasolucoes.com.br
 *************************************************************************************/

$mod_strings = array (
	'Import' => 'Importar',
	'LBL_IMPORT_STEP_1' => 'Passo 1',
	'LBL_IMPORT_STEP_2' => 'Passo 2',
	'LBL_IMPORT_STEP_3' => 'Passo 3',
	'LBL_IMPORT_STEP_4' => 'Passo 4',
	'LBL_IMPORT_STEP_1_DESCRIPTION' => 'Selecione o Arquivo',
	'LBL_IMPORT_STEP_2_DESCRIPTION' => 'Defina no Formato',
	'LBL_IMPORT_STEP_3_DESCRIPTION' => 'Manipulao de Registros Duplicados',
	'LBL_IMPORT_STEP_4_DESCRIPTION' => 'Mapear as Colunas dos Campos do Mdulo',
	'Skip' => 'Pular',
	'Overwrite' => 'Sobrescrever',
	'Merge' => 'Mesclar',
	'LBL_IMPORT_SUPPORTED_FILE_TYPES' => 'Tipo(s) de Arquivos Suportados: .CSV, .VCF',
	'LBL_IMPORT_STEP_3_DESCRIPTION_DETAILED' => 'Selecionar esta opo para habilitar e definir o critrio para mesclar registros duplicados',
	'LBL_CHARACTER_ENCODING' => 'Codificao do Caracter',
	'LBL_DELIMITER' => 'Delimitador',
	'LBL_HAS_HEADER' => 'Tem Cabealho',
	'LBL_SPECIFY_MERGE_TYPE' => 'Selecione como os registros duplicados devem ser manuseados',
	'LBL_SELECT_MERGE_FIELDS' => 'SSelecione os campos correspondentes para encontrar registros duplicados',
	'LBL_AVAILABLE_FIELDS' => 'Campos Disponveis',
	'LBL_SELECTED_FIELDS' => 'Campos para serem encontrados em',
	'UTF-8' => 'UTF-8',
	'ISO-8859-1' => 'ISO-8859-1',
	'comma' => ', (vrgula)',
	'semicolon' => '; (ponto e vrgula)',
	'LBL_USE_SAVED_MAPPING' => 'Utilizar Mapeamento Salvo',
	'LBL_SAVE_AS_CUSTOM_MAPPING' => 'Salvar como Mapeamento Customizado',
	'LBL_FILE_COLUMN_HEADER' => 'Cabealho',
	'LBL_ROW_1' => 'Linha 1',
	'LBL_CRM_FIELDS' => 'Campos do CRM',
	'LBL_DEFAULT_VALUE' => 'Valores Padres',
	'LBL_IMPORT_BUTTON_LABEL' => 'Importar',
	'LBL_TOTAL_RECORDS_IMPORTED' => 'Nmero total de registros importados',
	'LBL_TOTAL_RECORDS_FAILED' => 'Nmero toral de registros falhos',
	'LBL_NUMBER_OF_RECORDS_CREATED' => 'Nmero de registros criados',
	'LBL_NUMBER_OF_RECORDS_UPDATED' => 'Nmero de registros sobrescritos',
	'LBL_NUMBER_OF_RECORDS_SKIPPED' => 'Nmero de registros pulados',
	'LBL_UNDO_LAST_IMPORT' => 'Desfazer ltima Importao',
	'LBL_VIEW_LAST_IMPORTED_RECORDS' => 'ltimos Registros Importados',
	'LBL_IMPORT_MORE' => 'Importar Mais',
	'LBL_FINISH_BUTTON_LABEL' => 'Final',
	'LBL_RESULT' => 'Resultado',
	'ERR_FILE_DOESNT_EXIST' => "O arquivo no existe",
	'ERR_CANT_OPEN_FILE' => "No  possvel abrir o arquivo para leitura",
	'ERR_UNIMPORTED_RECORDS_IN_QUEUE' => 'O Usurio ainda tem registros no importados na fila',
	'ERR_FILE_READ_FAILED' => 'Falha ao ler o arquivo',
	'LBL_IMPORT_SCHEDULED' => 'Importao Agendada',
	'LBL_SCHEDULED_IMPORT_DETAILS' => 'Sua importao foi agendada e voc receber um email assim que a importao for concluda.<br>Por favor, certifique-se de que o Servidor de Envio de Mensagens e seu endereo de email estejam configurados para receber notificao por email',
	'ERR_DETAILS_BELOW' => 'Os detalhes encontram-se listados abaixo',
	'LBL_ERROR' => 'Erro',
	'LBL_OK_BUTTON_LABEL' => 'OK',
	'TOTAL_RECORDS' => 'Nmero total de registros',
	'LBL_NUMBER_OF_RECORDS_DELETED' => 'Nmero de registros apagados',
	'LBL_NUMBER_OF_RECORDS_MERGED' => 'Nmero de registros mesclados',
	'LBL_TOTAL_RECORDS' => 'Nmero Total de Registros',
	'LBL_UNDO_RESULT' => 'Desfazer Resultado da Importao',
	'LBL_LAST_IMPORTED_RECORDS' => 'ltimos Registros Importados',
	'LBL_NO_ROWS_FOUND' => 'Nenhuma Linha Encontrada',
	'ERR_UNIMPORTED_RECORDS_EXIST' => 'Existem alguns registros no importados na fila de importao bloqueando a importao de mais dados.<br>Limpe os dados para comear nova importao',
	'ERR_FAILED_TO_LOCK_MODULE' => 'Falha ao bloquear o mdulo para importao. Tente novamente mais tarde',
	'LBL_RUNNING' => 'Executando',
	'LBL_CLEAR_DATA' => 'Limpar Dados',
	'ERR_MODULE_IMPORT_LOCKED' => 'Voc no tem permisso para importar para este mdulo agora, uma outra importao enconta-se em andamento. Tente novamente mais tarde.',
	'LBL_MODULE_NAME' => 'Mdulo',
	'LBL_USER_NAME' => 'Usurio',
	'LBL_LOCKED_TIME' => 'Data Bloqueada',
	'LBL_CANCEL_IMPORT' => 'Cancelar Importao',
	'ERR_IMPORT_INTERRUPTED' => 'A importao atual foi interrompida. Por favor, tente novamente mais tarde.',
	'LBL_INVALID_FILE' => 'Arquivo Invlido',
	'LBL_FILE_TYPE' => 'Tipo Arquivo',
	'csv' => 'CSV',
	'vcf' => 'VCard',
	'LBL_NEXT_BUTTON_LABEL'=>'Prximo',
	'LBL_FILE_UPLOAD_FAILED'=>'Encontrou problemas em carregar o arquivo CSV. Verifique os permiss permisses de pasta de cache.',
);
?>