<?php
//crmv@start
function getFollowImg($record,$type='') {
	global $current_user;
	$focus = CRMEntity::getInstance('ModNotifications');
	if (in_array($record,$focus->getFollowedRecords($current_user->id,$type))) {
		return 'modules/ModNotifications/img/follow_on.png';
	} else {
		return 'modules/ModNotifications/img/follow_off.png';
	}
}
function getNotificationsModuleSettings($record) {
	$focus = CRMEntity::getInstance('ModNotifications');
	return $focus->getModuleSettings($record);
}
function getPortalAvatar() {
	global $theme;
	return vtiger_imageurl('portal_avatar.png',$theme);
}
function checkListNotificationCount($list_query_count,$userid,$viewid,$new_count) {  
	global $adb, $current_user,$table_prefix;
	$result = $adb->pquery('SELECT vte_modnot_follow_cv.cvid, vte_modnot_follow_cv.userid, vte_modnot_follow_cv.count, vte_modnot_follow_cv.modifiedtime, '.$table_prefix.'_customview.entitytype FROM vte_modnot_follow_cv INNER JOIN '.$table_prefix.'_customview ON '.$table_prefix.'_customview.cvid = vte_modnot_follow_cv.cvid WHERE vte_modnot_follow_cv.cvid = ? AND vte_modnot_follow_cv.userid = ?',array($viewid,$userid));
	if ($result && $adb->num_rows($result) > 0) {
		$count = $adb->query_result($result,0,'count');
		$modifiedtime = $adb->query_result($result,0,'modifiedtime');
		$module = $adb->query_result($result,0,'entitytype');
		if($_SESSION['lv_user_id'] == "all" || $_SESSION['lv_user_id'] == "") {
			//uso la query in sessione
		} else {
			//ricreo la query perch ha dei controlli anche sull'assegnatario
			$current_user_tmp = $current_user;
			
			$current_user = CRMEntity::getInstance('Users');
			$current_user->retrieve_entity_info($userid,'Users');
			$queryGenerator = QueryGenerator::getInstance($module, $current_user);
			$queryGenerator->initForCustomViewById($viewid);
			$list_query_count = $adb->query($queryGenerator->getQuery());
			$new_count = $adb->num_rows($list_query_count);
			
			$current_user = $current_user_tmp;
		}
		return updateListNotificationCount($list_query_count,$userid,$viewid,$new_count,$count,$modifiedtime);
	}
	return false;
}
function checkAllListNotificationCount() {
	global $adb, $current_user,$table_prefix;
	$result = $adb->query('select vte_modnot_follow_cv.cvid, vte_modnot_follow_cv.userid, vte_modnot_follow_cv.count, vte_modnot_follow_cv.modifiedtime, '.$table_prefix.'_customview.entitytype from vte_modnot_follow_cv inner join '.$table_prefix.'_customview on '.$table_prefix.'_customview.cvid = vte_modnot_follow_cv.cvid order by vte_modnot_follow_cv.userid, vte_modnot_follow_cv.cvid');
	if ($result && $adb->num_rows($result) > 0) {
		while($row=$adb->fetchByAssoc($result)) {
			$viewid = $row['cvid'];
			$userid = $row['userid'];
			$module = $row['entitytype'];
			$count = $row['count'];
			$modifiedtime = $row['modifiedtime'];
			
			$current_user = CRMEntity::getInstance('Users');
			$current_user->retrieve_entity_info($userid,'Users');
			$queryGenerator = QueryGenerator::getInstance($module, $current_user);
			$queryGenerator->initForCustomViewById($viewid);
			$list_query_count = $adb->query($queryGenerator->getQuery());
			if ($list_query_count) {
				updateListNotificationCount($list_query_count->sql,$userid,$viewid,$adb->num_rows($list_query_count),$count,$modifiedtime);
			}
		}
	}
}
function updateListNotificationCount($list_query_count,$userid,$viewid,$new_count,$count,$modifiedtime) {
	global $adb,$table_prefix;
	$now = date('Y-m-d H:i:s');
	if ($new_count > $count) {
		$adb->pquery('update vte_modnot_follow_cv set count = ?, modifiedtime = ? where cvid = ? and userid= ?',array($new_count,$now,$viewid,$userid));
		if ($count != -1) {
			if (stripos($list_query_count,'order by') !== false) {
				$list_query_count = substr($list_query_count,0,stripos($list_query_count,'order by'));
			}
			$list_query_count .= " and ".$table_prefix."_crmentity.modifiedtime > '$modifiedtime'";
			$res = $adb->query(replaceSelectQuery($list_query_count,$table_prefix.'_crmentity.crmid'));
			$ids = array();
			if ($res && $adb->num_rows($res) > 0) {
				while($row=$adb->fetchByAssoc($res)) {
					$ids[] = $row['crmid'];
				}
			}
			if (!empty($ids)) {
				$obj = CRMEntity::getInstance('ModNotifications');
				$obj->saveFastNotification(
					array(
						'assigned_user_id' => $userid,
						'createdtime' => $now,
						'mod_not_type' => 'ListView changed',
						'related_to' => $viewid,
						'description' => implode(',',$ids),
					),false
				);
				return true;
			}
		}
	} elseif ($new_count < $count) {
		$adb->pquery('update vte_modnot_follow_cv set count = ?, modifiedtime = ? where cvid = ? and userid= ?',array($new_count,$now,$viewid,$userid));
	}
	return false;
}
//crmv@end
?>