<?php 
/***************************************************************************************
 * The contents of this file are subject to the CRMVILLAGE.BIZ VTECRM License Agreement
 * ("licenza.txt"); You may not use this file except in compliance with the License
 * The Original Code is:  CRMVILLAGE.BIZ VTECRM
 * The Initial Developer of the Original Code is CRMVILLAGE.BIZ.
 * Portions created by CRMVILLAGE.BIZ are Copyright (C) CRMVILLAGE.BIZ.
 * All Rights Reserved.
 ***************************************************************************************/
//crmv@35153
$installation_mode = false;
if ($_REQUEST['morph_mode'] == 'installation' || $_SESSION['morph_mode'] == 'installation') {
	$installation_mode = true;
	if (!isset($root_directory)) {
		require_once('../../config.inc.php');
	}
	chdir($root_directory);
	require_once('include/utils/utils.php');
	if (isMorphsuitActive()) {
		exit;
	}
	include('vtigerversion.php');
	session_start();
	$_SESSION['morph_mode'] = 'installation';
}
$update_mode = false;
if (file_exists('modules/Update/free_changes') && getUserName(1) == 'admin') {
	$update_mode = true;
} elseif (getUserName(1) != 'admin') {
	$username_free = getUserName(1);
}
//crmv@35153e

include('modules/Morphsuit/HeaderMorphsuit.php');
$focus = CRMEntity::getInstance('Morphsuit');
?>

<body class="morphsuitactivationbody">
<div align="center">
<div class="small" style="width:500px;padding-top:5px;">
	<?php if ($installation_mode) { ?>
	<form action="SendMorphsuit.php" method="post" id="MorphsuitForm">
	<?php } else { ?>
	<form action="index.php" method="post" id="MorphsuitForm">
	<?php } ?>
	<input type="hidden" name="module" value="Morphsuit">
	<input type="hidden" name="action" value="MorphsuitAjax">
	<input type="hidden" name="file" value="SendMorphsuit">
	<input type="hidden" name="type" value="<?php echo $_REQUEST['type']; ?>">
	<input type="hidden" name="vte_user_info" value="">
	
	<div class="small" style="width:500px; padding-top:5px;">
		<table class="small morphsuittab" width="100%" cellspacing="0" cellpadding="0">
			<tr>
				<td width="20px"></td>
				<td width="68px" class="morphsuitlink" id="tabFree" onClick="changeTab('Free');" align="center" style="background: url(<?php echo $path; ?>themes/softed/images/bgmorphsuittab.png) no-repeat;"><?php echo $mod_strings['LBL_FREE']; ?></td>
				<td width="68px" class="morphsuitlink" id="tabStandard" onClick="changeTab('Standard');" align="center">Business<br />On site</td>
				<td width="344px"></td>
			</tr>
		</table>
		<table id="Standard" class="small morphsuittable" width="500" style="display: none;" cellpadding="3">
			<tr height="10">
				<td width="180"></td>
				<td width="320"></td>
			</tr>
			<tr><td class="dvHeaderText" align="center" colspan="2">
				<?php echo $mod_strings['LBL_MORPHSUIT_ACTIVATION']." $enterprise_mode $enterprise_current_version"; ?>
			</td></tr>
			<tr><td class="small" align="center" colspan="2">
				<?php echo $mod_strings['LBL_MORPHSUIT_TIME_EXPIRED'].'<br />'.$mod_strings['LBL_MORPHSUIT_SITE_LOGIN']; ?>&nbsp;your VTECRM LTD Partner Account.
			</td></tr>
			<tr>
				<td align="right">Username: </td>
				<td align="left"><input id="username_std" name="username_std" class="small" value="" size="23" type="text" /></td>
			</tr>
			<tr>
				<td align="right">Password: </td>
				<td align="left"><input id="password_std" name="password_std" class="small" value="" size="23" type="password" /></td>
			</tr>
			<tr height="20px"><td align="center" colspan="2"></td></tr>
			<tr>
				<td align="right"><?php echo $mod_strings['LBL_MORPHSUIT_INSTALLATION_TYPE']; ?>: </td>
				<td align="left">
					<select id="tipo_installazione" name="tipo_installazione" class="small">
						<option value="produzione"><?php echo $mod_strings['LBL_MORPHSUIT_PROD']; ?></option>
						<option value="test"><?php echo $mod_strings['LBL_MORPHSUIT_TEST']; ?></option>
						<option value="demo"><?php echo $mod_strings['LBL_MORPHSUIT_DEMO']; ?></option>
					</select>
				</td>
			</tr>
			<tr>
				<td align="right"><?php echo $mod_strings['LBL_MORPHSUIT_INSTALLATION_LENGTH']; ?>: </td>
				<td align="left">
					<select id="durata_installazione" name="durata_installazione" class="small">
						<option value="1 year"><?php echo $mod_strings['LBL_MORPHSUIT_1Y']; ?></option>
						<option value="6 months"><?php echo $mod_strings['LBL_MORPHSUIT_6M']; ?></option>
						<option value="30 days"><?php echo $mod_strings['LBL_MORPHSUIT_30D']; ?></option>
						<option value="15 days"><?php echo $mod_strings['LBL_MORPHSUIT_15D']; ?></option>
						<option value="1 day"><?php echo $mod_strings['LBL_MORPHSUIT_1D']; ?></option>
					</select>
				</td>
			</tr>
			<tr>
				<td align="right"><?php echo $mod_strings['LBL_MORPHSUIT_USER_NUMBER']; ?>: </td>
				<td align="left">
					<select id="numero_utenti" name="numero_utenti" class="small">
						<option value="9"><?php echo $mod_strings['LBL_MORPHSUIT_USER_NUMBER_10']; ?></option>
						<option value="19"><?php echo $mod_strings['LBL_MORPHSUIT_USER_NUMBER_20']; ?></option>
						<option value="49"><?php echo $mod_strings['LBL_MORPHSUIT_USER_NUMBER_50']; ?></option>
						<option value="99"><?php echo $mod_strings['LBL_MORPHSUIT_USER_NUMBER_100']; ?></option>
						<option value=""><?php echo $mod_strings['LBL_MORPHSUIT_USER_NUMBER_UNLIMITED']; ?></option>
					</select>
				</td>
			</tr>
			<tr><td colspan="2">&nbsp;</td></tr>
			<tr>
				<td colspan="2" align="center">
					<textarea class="small" readonly><?php echo getTranslatedString('LBL_PRIVACY_DESC','Settings'); ?></textarea>
				</td>
			</tr>
			<tr>
				<td colspan="2" align="left" style="padding-left: 15px;">
					<input type="checkbox" id="privacy_flag_std" name="privacy_flag_std" />&nbsp;<label for="privacy_flag_std"><?php echo getTranslatedString('LBL_PRIVACY_FLAG','Settings'); ?></label>
				</td>
			</tr>
			<tr><td colspan="2">&nbsp;</td></tr>
			<tr><td colspan="2" align="center">
				<?php if ($_REQUEST['type'] == 'time_expired') { ?>
				<input type="button" onClick="zombieMorph();" class="crmbutton small delete" value="<?php echo getTranslatedString('LBL_ZOMBIE_MODE','Morphsuit'); ?>" />
				<?php } ?>
				<input type="button" onClick="if (validate()) submitStd();" class="crmbutton small edit" value="<?php echo $mod_strings['LBL_MORPHSUIT_NEXT']; ?>" />
			</td></tr>
		</table>
		<table id="Free" class="small morphsuittable" width="500" style="display: block;" cellpadding="3">
			<tr height="10">
				<td width="180"></td>
				<td width="320"></td>
			</tr>
			<tr><td class="dvHeaderText" align="center" colspan="2">
				<?php echo $mod_strings['LBL_MORPHSUIT_ACTIVATION']." $enterprise_mode $enterprise_current_version"; ?>
			</td></tr>
			<tr><td class="small" align="center" colspan="2">
				<?php echo $mod_strings['LBL_MORPHSUIT_TIME_EXPIRED'].'&nbsp;'.$mod_strings['LBL_MORPHSUIT_SITE_LOGIN']; ?>&nbsp;<a href="http://www.vtecrm.com" target="_blank">vtecrm.com</a>.
				<?php if ($update_mode) {
					echo "<br /><b>".$mod_strings['LBL_MORPHSUIT_OVERWRITE_CREDENTIALS']."</b>";
				} ?>
			</td></tr>
			<tr>
				<td align="right">Username: </td>
				<? ?>
				<td align="left"><input id="username_free" name="username_free" class="small" value="<?php echo $username_free; ?>" size="23" type="text" <?php if (!empty($username_free)) echo 'readonly'; ?>/></td>
			</tr>
			<tr>
				<td align="right">Password: </td>
				<td align="left"><input id="password_free" name="password_free" class="small" value="" size="23" type="password" /></td>
			</tr>
			<tr>
				<td align="right"></td>
				<td align="left"><?php echo $mod_strings['LBL_MORPHSUIT_SITE_REGISTRATION']; ?>&nbsp;<a href="http://www.vtecrm.com/en/component/comprofiler/registers.html" target="_blank"><?php echo $app_strings['LBL_HERE']; ?></a></td>
			</tr>
			<tr><td colspan="2">&nbsp;</td></tr>
			<tr>
				<td colspan="2" align="center">
					<textarea class="small" readonly><?php echo getTranslatedString('LBL_PRIVACY_DESC','Settings'); ?></textarea>
				</td>
			</tr>
			<tr>
				<td colspan="2" align="left" style="padding-left: 15px;">
					<input type="checkbox" id="privacy_flag_free" name="privacy_flag_free" />&nbsp;<label for="privacy_flag_free"><?php echo getTranslatedString('LBL_PRIVACY_FLAG','Settings'); ?></label>
				</td>
			</tr>
			<tr><td colspan="2">&nbsp;</td></tr>
			<tr>
				<td colspan="2" align="center">
					<?php if ($_REQUEST['type'] == 'time_expired') { ?>
					<input type="button" onClick="zombieMorph();" class="crmbutton small delete" value="<?php echo getTranslatedString('LBL_ZOMBIE_MODE','Morphsuit'); ?>" />
					<?php } ?>
					<input type="button" onClick="if (validate()) submitFree();" class="crmbutton small edit" value="<?php echo $mod_strings['LBL_MORPHSUIT_ACTIVATE']; ?>" />
				</td>
			</tr>
		</table>
	</div>
	</form>
</div>
</div>

<div id="divId" class="veil_new" style="position:absolute;width:100%;display:none;top:0px;left:0px;">
<table border="5" cellpadding="0" cellspacing="0" align="center" style="vertical-align:middle;width:100%;height:100%;">
<tbody><tr>
		<td class="big" align="center">
		    <img src="<?php echo $path.vtiger_imageurl('plsWaitAnimated.gif',$theme); ?>">
		</td>
	</tr>
</tbody>
</table>
</div>

<script type="text/javascript">
var currentTab;
currentTab = 'Free';

function changeTab(tab) {
	currentTab = tab;
	if (tab == 'Free') {
		getObj('Free').style.display = 'block';
		getObj('Standard').style.display = 'none';
		getObj('tabStandard').style.background = 'none';
	} else {
		getObj('Free').style.display = 'none';
		getObj('Standard').style.display = 'block';
		getObj('tabFree').style.background = 'none';
	}
	getObj('tab'+tab).style.background = 'url(<?php echo $path; ?>themes/softed/images/bgmorphsuittab.png) no-repeat';
}

function validate() {
	if (currentTab == 'Free') {
		if (!emptyCheck('username_free','Username',getObj('username_free').type))
			return false;
		if (!emptyCheck('password_free','Password',getObj('password_free').type))
			return false;
		if (!emptyCheck('privacy_flag_free','<?php echo getTranslatedString('LBL_PRIVACY_FLAG','Settings'); ?> ',getObj('privacy_flag_free').type))
			return false;
		return true;
	} else {
		if (!emptyCheck('username_std','Username',getObj('username_std').type))
			return false;
		if (!emptyCheck('password_std','Password',getObj('password_std').type))
			return false;
		if (!emptyCheck('privacy_flag_std','<?php echo getTranslatedString('LBL_PRIVACY_FLAG','Settings'); ?> ',getObj('privacy_flag_std').type))
			return false;
		//login
		pleaseWait('enable');
		var url = '<?php echo $focus->vteFreeServer; ?>';
		var params = {
			'method' : 'checkUserCredentials'
		};
		jQuery.ajax({
			url:'<?php echo $path; ?>modules/Morphsuit/MorphParam.php',type:'POST',data:{'value':getObj('username_std').value},async:false,
			complete  : function(res, status) { params['username'] = res.responseText; }
		});
		jQuery.ajax({
			url:'<?php echo $path; ?>modules/Morphsuit/MorphParam.php',type:'POST',data:{'value':getObj('password_std').value},async:false,
			complete  : function(res, status) { params['password'] = res.responseText; }
		});
		var result = '';
		jQuery.ajax({
			url : url,
			type: 'POST',
			data: params,
			complete  : function(res, status) {
				if (status != 'success') {
					alert('Connection with VTECRM Network failed ('+status+')');
					pleaseWait('disable');
					return false;
				} else {
					result = res.responseText;
					if (result == false) {
						alert('Login failed');
						pleaseWait('disable');
						return false;
					} else {
						getObj('vte_user_info').value = result;
						document.forms['MorphsuitForm'].submit();
					}
				}
			}
		});
	}
}

function submitStd() {
	document.forms['MorphsuitForm'].submit();
}

function success(response) {
	jQuery('#checkDataMorphsuit').html(response);
	placeAtCenter(getObj('checkDataMorphsuit'));
	getObj('checkDataMorphsuit').style.top = '0px';
}

function zombieMorph() {
	window.location.href = "index.php?module=Morphsuit&action=MorphsuitAjax&file=Zombie";
}

function submitFree() {
	pleaseWait('enable');
	
	<?php if ($installation_mode) { ?>
		var key = getFile('<?php echo $path; ?>modules/Morphsuit/SendMorphsuit.php?tipo_installazione=Free');
	<?php } else { ?>
		var key = getFile('index.php?module=Morphsuit&action=MorphsuitAjax&file=SendMorphsuit&tipo_installazione=Free');
	<?php } ?>
	var url = '<?php echo $focus->vteFreeServer; ?>';
	var params = {
		'method' : 'generateMorphsuit',
		'revision' : '<?php echo $enterprise_current_build; ?>',
		'subversion' : '<?php echo $enterprise_subversion; ?>',
		<?php
		$saved_morphsuit = getSavedMorphsuit();
		if (!empty($saved_morphsuit)) {
			$saved_morphsuit = urldecode(trim($saved_morphsuit));
			$private_key = substr($saved_morphsuit,0,strpos($saved_morphsuit,'-----'));
			$enc_text = substr($saved_morphsuit,strpos($saved_morphsuit,'-----')+5);
			$saved_morphsuit = @decrypt_morphsuit($private_key,$enc_text);
			$saved_morphsuit = Zend_Json::decode($saved_morphsuit);
			$saved_morphsuit_id = $saved_morphsuit['id'];
			echo "'id' : '{$saved_morphsuit_id}',";
		}
		?>
		'key' : key
	};
	jQuery.ajax({
		url:'<?php echo $path; ?>modules/Morphsuit/MorphParam.php',type:'POST',data:{'value':getObj('username_free').value},async:false,
		complete  : function(res, status) { params['username'] = res.responseText; }
	});
	jQuery.ajax({
		url:'<?php echo $path; ?>modules/Morphsuit/MorphParam.php',type:'POST',data:{'value':getObj('password_free').value},async:false,
		complete  : function(res, status) { params['password'] = res.responseText; }
	});
	var result = '';
	jQuery.ajax({
		url : url,
		type: 'POST',
		data: params,
		complete  : function(res, status) {
			if (status != 'success') {
				alert('Connection with VTECRM Network failed ('+status+')');
				pleaseWait('disable');
			} else {
				result = res.responseText;
				if (result == 'LOGIN_FAILED') {
					alert('Login failed (err 1)');
					pleaseWait('disable');
				} else if (result == 'USER_NOT_IMPORTED') {
					alert('Login failed (err 2)');
					pleaseWait('disable');
				} else if (result == 'VERSION_NOT_ACTIVABLE') {
					alert('<?php echo addslashes($mod_strings['LBL_ERROR_VTE_FREE_NOT_ACTIVABLE']); ?>');
					pleaseWait('disable');
				} else if (result.indexOf('ERROR: The requested URL could not be retrieved')>-1) {
					alert('Connection with VTECRM Network failed (err 3)');
					pleaseWait('disable');
				} else if (result == '') {
					alert('VTECRM Network service fails to create your license (err 4)');
					pleaseWait('disable');
				} else {
					result = eval('('+result+')');
					var new_key = result['new_key'];
					var user_info = {
						'username' : getObj('username_free').value,
						'password' : getObj('password_free').value,
						'email' : result['email'],
						'name' : result['name']
					};
					<?php if ($installation_mode) { ?>
						var url1 = '<?php echo $path; ?>modules/Morphsuit/CheckMorphsuit.php';
					<?php } else { ?>
						var url1 = 'index.php?module=Morphsuit&action=MorphsuitAjax&file=CheckMorphsuit';
					<?php } ?>
					var params1 = {
						'valida_chiave' : new_key,
						'user_info' : JSON.stringify(user_info)
					};
					jQuery.ajax({
						url : url1,
						type: 'POST',
						data: params1,
						complete  : function(res1, status1) {
							var check = res1.responseText;
							if (check != 'yes') {
								alert('VTECRM Network service fails to create your license (err 5)');
							} else if (check == 'yes') {
								var res1 = getFile('<?php echo $path; ?>index.php?module=Morphsuit&action=MorphsuitAjax&file=CheckSMTP');
								if (res1 != 'ok') {
									if(confirm("<?php echo $mod_strings['LBL_ERROR_SMTP']; ?>")) {
										window.location.href = "<?php echo $path; ?>index.php?module=Settings&action=EmailConfig&parenttab=Settings";
										return true;
									}
								}
							}
							window.location.href = "<?php echo $path; ?>index.php";
						}
					});
				}
			}
		}
	});
}

function pleaseWait(status) {
	if (status == 'enable') {
		var oDivfreeze = $('divId');
		oDivfreeze.style.height = jQuery(document).height() + 'px';
		$('divId').style.display = 'block';
	} else {
		$('divId').style.display = 'none';
	}
}
</script>
</body>
</html>
<?php die; ?>