<?php
/***************************************************************************************
 * The contents of this file are subject to the CRMVILLAGE.BIZ VTECRM License Agreement
 * ("licenza.txt"); You may not use this file except in compliance with the License
 * The Original Code is:  CRMVILLAGE.BIZ VTECRM
 * The Initial Developer of the Original Code is CRMVILLAGE.BIZ.
 * Portions created by CRMVILLAGE.BIZ are Copyright (C) CRMVILLAGE.BIZ.
 * All Rights Reserved.
 ***************************************************************************************/
include('modules/Morphsuit/HeaderMorphsuit.php');

$saved_morphsuit = getSavedMorphsuit();
$saved_morphsuit = urldecode(trim($saved_morphsuit));
$private_key = substr($saved_morphsuit,0,strpos($saved_morphsuit,'-----'));
$enc_text = substr($saved_morphsuit,strpos($saved_morphsuit,'-----')+5);
$saved_morphsuit = @decrypt_morphsuit($private_key,$enc_text);
if ($saved_morphsuit == '') return false;
$saved_morphsuit = Zend_Json::decode($saved_morphsuit);

$limit_exceeded_mapping = array(
	'users'=>$mod_strings['LBL_MORPHSUIT_USER_NUMBER_EXCEEDED'],
	'roles'=>$mod_strings['LBL_MORPHSUIT_ROLE_NUMBER_EXCEEDED'],
	'profiles'=>$mod_strings['LBL_MORPHSUIT_PROFILE_NUMBER_EXCEEDED'],
	'pdf'=>$mod_strings['LBL_MORPHSUIT_PDF_NUMBER_EXCEEDED'],
	'adv_sharing_rules'=>$mod_strings['LBL_MORPHSUIT_ADV_SHARING_RULE_NUMBER_EXCEEDED'],
	'sharing_rules_user'=>$mod_strings['LBL_MORPHSUIT_SHARING_RULE_USER_NUMBER_EXCEEDED'],
);
$limit = $_REQUEST['limit_exceeded'];
if (in_array($limit,array_keys($limit_exceeded_mapping))) {
	$update_msg = $limit_exceeded_mapping[$limit];
} else {
	$update_msg = $mod_strings['LBL_MORPHSUIT_UPDATE'];
}
?>
<body class="morphsuitactivationbody">
<div align="center">
<div class="small" style="width:500px;padding-top:5px;">
	<form action="index.php" method="post" id="MorphsuitForm">
	<input type="hidden" name="module" value="Morphsuit">
	<input type="hidden" name="action" value="MorphsuitAjax">
	<input type="hidden" name="file" value="CheckMorphsuit">
	
	<div class="small" style="width:500px; padding-top:5px;">
    <!-- aggiunge header -->
    <table class="small morphsuittab" width="100%" cellspacing="0" cellpadding="10">
			<tr>
				<td></td>
			</tr>
		</table>
        <!-- end header -->
		<table class="small morphsuittable" align="center" width="100%" style="border:1px solid #525d95;">
			<tr height="10"><td></td></tr>
			<tr><td class="dvHeaderText" align="center" width="400">
				<?php echo $mod_strings['LBL_MORPHSUIT_ACTIVATION']." $enterprise_mode $enterprise_current_version"; ?>
			</td></tr>
			<tr><td class="small" align="center" width="400">
				<?php echo $update_msg ?>
			</td></tr>
			<tr height="20px"><td align="center" width="400"></td></tr>
			<tr><td align="center" width="400">
				<?php echo $mod_strings['LICENSE_ID'].': <b>'.$saved_morphsuit['id'].'</b>'; ?>
			</td></tr>
			<tr height="20px"><td align="center" width="400"></td></tr>
			<tr><td align="center" width="400">
				<?php echo $mod_strings['LBL_MORPHSUIT_CODE']; ?><br />
				<textarea class="small" id="valida_chiave" name="valida_chiave"></textarea>
			</td></tr>
			<tr><td align="center" width="400">
				<?php if ($limit != '') { ?>
					<input type="button" onclick="zombieMorph();" class="crmbutton small delete" value="<?php echo getTranslatedString('LBL_ZOMBIE_MODE','Morphsuit'); ?>" />
				<?php } else { ?>
					<input type="button" onclick="history.back();" class="crmbutton small delete" value="<?php echo getTranslatedString('LBL_CANCEL_BUTTON_LABEL'); ?>" />
				<?php } ?>
				<input type="submit" class="crmbutton small create" value="<?php echo $mod_strings['LBL_MORPHSUIT_ACTIVATE']; ?>" />
			</td></tr>
		</table>
	</div>
	</form>
</div></div>

<div id="divId" class="veil_new" style="position:absolute;width:100%;display:none;top:0px;left:0px;">
<table border="5" cellpadding="0" cellspacing="0" align="center" style="vertical-align:middle;width:100%;height:100%;">
<tbody><tr>
		<td class="big" align="center">
		    <img src="<?php echo $path.vtiger_imageurl('plsWaitAnimated.gif',$theme); ?>">
		</td>
	</tr>
</tbody>
</table>
</div>

<script type="text/javascript">
function zombieMorph() {
	window.location.href = "index.php?module=Morphsuit&action=MorphsuitAjax&file=Zombie";
}

function validateChiave() {
	pleaseWait('enable');
	if (jQuery('#valida_chiave').val() == '') {
		alert('<?php echo $mod_strings['LBL_MORPHSUIT_CODE_EMPTY']; ?>');
		pleaseWait('disable');
		return false;
	}
	return true;
}

function checkMorphsuit(res) {
	if (res == 'yes') {
		alert('<?php echo $mod_strings['LBL_MORPHSUIT_CODE_RIGHT']; ?>');
		window.location.href = "index.php";
	} else {
		alert('<?php echo $mod_strings['LBL_MORPHSUIT_CODE_WRONG']; ?>');
		pleaseWait('disable');
	}
}

function pleaseWait(status) {
	if (status == 'enable') {
		var oDivfreeze = $('divId');
		oDivfreeze.style.height = jQuery(document).height() + 'px';
		$('divId').style.display = 'block';
	} else {
		$('divId').style.display = 'none';
	}
}

var options = {
	beforeSubmit:	validateChiave,  	// pre-submit callback 
    success:		checkMorphsuit,  	// post-submit callback 
    dataType:		'script'			// 'xml', 'script', or 'json' (expected server response type) 
};
jQuery('#MorphsuitForm').ajaxForm(options);
</script>
</body>
</html>
<?php die; ?>