<?php
// Turn on debugging level
include_once('vtlib/Vtiger/Utils.php');
include_once('vtlib/Vtiger/Menu.php');
include_once('vtlib/Vtiger/Module.php');

	function setTicketStatusPicklistValues($values) {
		global $adb;
		global $table_prefix;
		$picklist_table = $table_prefix.'_ticketstatus';
		$picklist_idcol = 'ticketstatus_id';

		$new_picklistid = $adb->query_result(
			$adb->query("SELECT picklistid FROM ".$table_prefix."_picklist WHERE name='ticketstatus'"), 0, 'picklistid');

		// Add value to picklist now
		$sortid = 0; // TODO To be set per role
		foreach($values as $value) {
			$new_picklistvalueid = getUniquePicklistID();
			$presence = 1; // 0 - readonly, Refer function in include/ComboUtil.php
			$new_id = $adb->getUniqueID($picklist_table);
			$adb->pquery("INSERT INTO $picklist_table($picklist_idcol, ticketstatus, presence, picklist_valueid) VALUES(?,?,?,?)",
				Array($new_id, $value, $presence, $new_picklistvalueid));
			++$sortid;

			// Associate picklist values to all the role
			$adb->query("INSERT INTO ".$table_prefix."_role2picklist(roleid, picklistvalueid, picklistid, sortid) SELECT roleid, 
				$new_picklistvalueid, $new_picklistid, $sortid FROM ".$table_prefix."_role");
		}
	}
setTicketStatusPicklistValues( Array ('Maintain') );

$moduleHD = Vtiger_Module::getInstance('HelpDesk');
$moduleTC = Vtiger_Module::getInstance('Timecards');
$moduleHD->setRelatedList($moduleTC, 'Timecards', Array('ADD'),'get_timecards');

//$moduleAccounts = Vtiger_Module::getInstance('Accounts');
//$moduleAccounts->setRelatedList($module, 'Timecards', Array('ADD','SELECT'));

$moduleHD->addLink(
'DETAILVIEW',
'LBL_PDF_WITH_COMMENTS',
'index.php?module=HelpDesk&action=chatHDTicket&record=$RECORD$&return_module=HelpDesk&return_action=DetailView&return_id=$RECORD$&hdticketcomments=yes'
);
$moduleHD->addLink(
'DETAILVIEW',
'LBL_PDF_WITHOUT_COMMENTS',
'index.php?module=HelpDesk&action=chatHDTicket&record=$RECORD$&return_module=HelpDesk&return_action=DetailView&return_id=$RECORD$&hdticketcomments=no'
);
$moduleHD->addLink(
'DETAILVIEW',
'LBL_HelpDesk_Receipt',
'index.php?module=HelpDesk&action=chatHDReceipt&record=$RECORD$&return_module=HelpDesk&return_action=DetailView&return_id=$RECORD$'
);
$moduleHD->addLink(
'DETAILVIEW',
'sortWO',
'index.php?module=HelpDesk&action=chatSortTT&return_module=HelpDesk&return_action=index'
);
//crmv fix ticketstatus
$adb->pquery("update ".$table_prefix."_field set uitype = ? where tablename = ? and fieldname = ?",
				Array(15, $table_prefix.'_timecards', 'ticketstatus'));
?>