<?php
/* crmv@31780 - TODO: paginazione*/
/* crmv@33097 */

global $login, $userId, $currentModule, $current_user, $list_max_entries_per_page;

// parametri
$module = $_REQUEST['module'];
$recordid = intval($_REQUEST['recordid']);
$relationId = intval($_REQUEST['relationid']);
$actions = $_REQUEST['actions'];


if(!$login || empty($userId)) {
	echo 'Login Failed';
} elseif (in_array($module, $touchInst->excluded_modules)) {
	echo "Module not permitted";
} else {

	// utente
	$current_user = new Users();
	$current_user->id = $userId;
	$current_user->retrieveCurrentUserInfoFromFile($userId);

	$currentModule = $module;

	// disabilito azioni per la lista
	global $PERFORMANCE_CONFIG;
	$PERFORMANCE_CONFIG['LISTVIEW_RECORD_CHANGE_INDICATOR'] = false;

	// imposto il massimo numero di elementi
	$list_max_entries_per_page = $touchInst->listPageLimit;
	// e l'inizio
	unset($_REQUEST['limit']);
	$_REQUEST['start'] = $_REQUEST['page'];
	unset($_REQUEST['page']);


	$outdata = array();
	$total = 0;
	if ($recordid > 0) {


		// prendo la lista
		$modObj = CRMEntity::getInstance($currentModule);
		$modObj->retrieve_entity_info($recordid,$currentModule);
		$modObj->id = $recordid;

		$relationInfo = getRelatedListInfoById($relationId);
		$function_name = $relationInfo['functionName'];
		$relatedModule = vtlib_getModuleNameById($relationInfo['relatedTabId']);

		$relatedListData = $modObj->$function_name($recordid, getTabid($currentModule),$relationInfo['relatedTabId'], $actions);
		$total = intval($relatedListData['count']);

		// prendo i campi
		$relatedFields = getRelatedFields($userId, $module, $relatedModule, $relationId, $recordid);


		// formatto nel formato nome->valore

		$relatedInst = CRMEntity::getInstance($relatedModule);

		if (is_array($relatedListData['entries'])) {
			foreach ($relatedListData['entries'] as $relcrmid => $relfields) {
				$i = 0;
				$crmid = 0;
				$fielddata = array();

				// recupero il crmid
				foreach ($relfields as $fieldval) {
					if($crmid == 0 && preg_match('/vtrecordid=[\'"](\d+)[\'"]/', $fieldval, $matches) > 0) {
						$crmid = $matches[1];
						break;
					}
				}

				if (empty($crmid)) continue;

				// recupero i valori dei campi in modo decente
				$relatedInst->retrieve_entity_info_no_html($crmid, $relatedModule, false);
				$record = $relatedInst->column_fields;

				// e faccio il merge
				foreach ($relfields as $fieldval) {
					// nome del campo
					if (preg_match('/vtfieldname=[\'"]([a-zA-Z0-9_]+)[\'"]/', $fieldval, $matches) > 0) {
						$fldname = $matches[1];
					}
					if (empty($fldname)) $fldname = $relatedFields[$i++]['name']; // vado in ordine
					// valore
					if (array_key_exists($fldname, $record)) $fielddata[$fldname] = $touchInst->field2touch($relatedModule, $fldname, $record[$fldname], false, $relatedInst);
				}

				$entname = getEntityName($relatedModule, array($crmid));
				if (is_array($entname) && count($entname) > 0) $entname = $entname[$crmid]; else $entname = '';
				$outdata[] = array(
					'crmid' => $crmid,
					'tabid' => $relationInfo['relatedTabId'],
					'setype' => $relatedModule,
					'entityname' => $entname,
					'fields' => Zend_Json::encode($fielddata),

				);
			}
		}
	}

	$response = Zend_Json::encode(array('entries'=>$outdata, 'total'=>$total));
	echo $response;
}
?>
