<?php
/* crmv@31780 - fix vari */
/* crmv@33097 - fix vari */
global $login, $userId, $current_user, $currentModule;

$module = $_REQUEST['module'];
$recordid = intval($_REQUEST['record']);
$values = vtlib_purify($_REQUEST['values']);

if (!$login || empty($userId)) {
	echo 'Login Failed';
} elseif (in_array($module, $touchInst->excluded_modules)) {
	echo "Module not permitted";
} else {

	$currentModule = $module;

	$returnok = true;
	$returndata = null;
	$errormsg = '';

	if ($recordid > 0) {
		// UPDATE

		$wsrecordid = vtws_getWebserviceEntityId($module, $recordid);

		$wsname = 'retrieve';
		if (isInventoryModule($module)) $wsname = 'retrieveInventory';
		$response = wsRequest($userId,$wsname, array('id'=>$wsrecordid)	);

		if (!empty($response['error'])) {
			$returnok = false;
			$errormsg = $response['error']->message;
			//die();
		}

		$record = $response['result'];

		$newRecord = Zend_Json::decode($values);
		if (is_array($newRecord) && is_array($record)) {
			// aggiungo blocco prodotti se manca
			if (!array_key_exists('product_block', $record) && !empty($newRecord['product_block'])) $record['product_block'] = array();
			foreach ($newRecord as $fldname => $fldval) {
				if (array_key_exists($fldname, $record)) {
					// to prevent notes html content from being stripped out
					if ($module == 'Documents' && $fldname == 'notecontent') {
						$newRecord2 = Zend_Json::decode($_REQUEST['values']);
						if (is_array($newRecord2)) {
							$fldval = $newRecord2[$fldname];
						}
						unset($newRecord2);
					}
					$fldval = $touchInst->touch2Field($module, $fldname, $fldval);
					$record[$fldname] = $fldval;
				}
			}
		}

		$response = wsRequest($userId,'update', array('element'=>$record) );
		$returnok = ($response['success'] == 1);

	} else {
		// CREATE

		$newRecord = Zend_Json::decode($values);
		$updateRecord = array();
		if (is_array($newRecord)) {
			foreach ($newRecord as $fldname => $fldval) {
				$fldval = $touchInst->touch2Field($module, $fldname, $fldval);
				if ($fldval == '') continue;
				$updateRecord[$fldname] = $fldval;
			}
			// aggiunta campi per calendario
			if ($module == 'Calendar') {
				$updateRecord['activitytype'] = 'Task';
				$updateRecord['visibility'] = 'Standard';
			}
		}

		$response = wsRequest($userId,'create',
			array(
				'elementType'=>$module,
				'element'=>$updateRecord,
			)
		);
		//$record = $response['result'];

		// in caso di creazione ritorno il record appena creato
		if ($response['success'] === true) {
			list($modid, $recordid) = explode('x', $response['result']['id'], 2);

			$focus = CRMEntity::getInstance($module);
			$focus->retrieve_entity_info($recordid, $module);
			$record = $focus->column_fields;
			foreach ($record as $fldname=>$fldvalue) {
				$record[$fldname] = $touchInst->field2Touch($module, $fldname, $fldvalue);
			}

			$record['crmid'] = $recordid;
			$returndata = $record;
		}

	}

	if ($response['success'] !== true) {
		$returnok = false;
		$errormsg = $response['error']->message;
	}

	echo Zend_Json::encode(array('success' => $returnok, 'result' => $returndata, 'error' => $errormsg));
}
?>