<?php
/*********************************************************************************
** The contents of this file are subject to the vtiger CRM Public License Version 1.0
 * ("License"); You may not use this file except in compliance with the License
 * The Original Code is:  vtiger CRM Open Source
 * The Initial Developer of the Original Code is vtiger.
 * Portions created by vtiger are Copyright (C) vtiger.
 * All Rights Reserved.
*
 ********************************************************************************/

$mod_strings = array(

"LBL_WORKFLOW_INFO"=>"Informação Workflow",
"LBL_CUSTOM_INFO"=>"Informação Personalizada",
"LBL_DESCRIPTION_INFO"=>"Informação Descrição",

"Name"=>"Nome Workflow",
"Description"=>"Descrição",
"Created Time"=>"Data e Hora de Criação",
"Modified Time"=>"Data e Hora de Modificação",
"LBL_ACTION"=>"Ação",
"Workflow"=>"Workflow",

'Workflow Name' => 'Nome Workflow',
'Module'=>'Módulo',
'Field'=>'Campo',

'LBL_EDIT_VIEW'=>'Editar ',
// 'LBL_EDIT_VIEW'=>'Modifica dettagli utente',
'LBL_CREATE_NEW_USER'=>'Criar novo Workflow',
// 'LBL_CREATE_NEW_USER'=>'Crea Nuovo Utente',

'LBL_NEW_WORKFLOW_BUTTON_LABEL' => 'Novo Workflow',
'LBL_NEW_WORKFLOW_BUTTON_TITLE' => 'Novo Workflow',
'LBL_NEW_WORKFLOW_BUTTON_KEY' => '',

'LBL_WORKFLOW_NAME'=>'Nome Workflow',
'LBL_MODULE_NAME'=>'1. Escolher Módulo',
'LBL_FIELD_NAME'=>'2. Escolher Campo',
'LBL_CRITERIA_NAME'=>'3. Critério',
'LBL_ACTION_NAME'=>'4. Ação',
'LBL_EXTENDED_PARAMETERS' => '5. Paramêtros extensos',
'LBL_CRITERIA_VALUE_NAME' => 'Valor',
'LBL_CRITERIA_ACTION_FIELD_NAME' => 'Campo:',
'LBL_CRITERIA_ACTION_FIELD_VALUE' => 'Novo Valor:',
'LBL_TASK_USER_NAME' => 'Recebedor:',
'LBL_TASK_SUBJECT' => 'Assunto:',
'LBL_TASK_TEXT' => 'Texto:',
'LBL_TASK_TODO_TYPE' => 'Tipo:',
'LBL_TASK_EMAIL_TEMPLATE' => 'Adicionar Modelo Email :',
'LBL_TASK_TODO_TYPE_CALL' => 'Chamada',
'LBL_TASK_TODO_TYPE_MEETING' => 'Reunião',
'LBL_ACTION_TYPE_NONE' => '-- nenhum --',
'LBL_ACTION_TYPE_FIELD_CHANGE' => 'Modificar outro campo do Módulo',
'LBL_ACTION_TYPE_CREATE_TASK' => 'Criar Tarefa',
'LBL_ACTION_TYPE_CREATE_CALL_MEETING' => 'Criar Chamada/ Reunião',
'LBL_ACTION_TYPE_CREATE_EMAIL' => 'Criar Email',
'LBL_ACTION_TYPE_CREATE_NOTE' => 'Criar Documento',

'LBL_CRITERIA_VALUE_LESS_EQUAL' => 'Menor ou igual (<=)',
'LBL_CRITERIA_VALUE_LESS_THAN' => 'Maior que (<)',
'LBL_CRITERIA_VALUE_MORE_EQUAL' => 'Maior ou igual (>=)',
'LBL_CRITERIA_VALUE_MORE_THAN' => 'Maior que(>)',
'LBL_CRITERIA_VALUE_EQUAL' => 'Igual (=)',
'LBL_CRITERIA_VALUE_NOT_EQUAL' => 'Não igual (!=)',
'LBL_CRITERIA_VALUE_INCLUDES' => 'inclue',
'LBL_WORKFLOW_RUN_ONCE' => 'Lançar Workflow somente uma vez',
'LBL_WORKFLOW_ACTIVE' => 'O Workflow é ativo',

'LBL_ERR_WORKFLOW_NAME' => 'Falta nome do Workflow',
'LBL_ERR_CRITERIA_VALUE' => 'Faltam os valores de critérios',
'LBL_ERR_LIST_USER_NAME' => 'Especificar o destinatário',

'Action_none' => 'Nenhum',
'Action_FieldChange' => 'Modificar outro campo',
'Action_ToDo' => 'Criar Tarefa',
'Action_CallMeeting' => 'Criar Chamada/Reunião',
'Action_EMail' => 'Criar Email',
'Action_Note' => 'Criar Documento',

// local language line strings

'Account Name'=>'Nome Conta',
'Phone'=>'Telefone',
'Office Phone'=>'Telefone Escritório',
'Website'=>'Website',
'Fax'=>'Fax',
'Ticker Symbol'=>'Cod. Bolsa',
'Other Phone'=>'Telefone Alternativo',
'Member Of'=>'Membro de',
'Email'=>'Email',
'Employees'=>'Empregados',
'Other Email'=>'Email Alternativa',
'Ownership'=>'Responsável',
'Rating'=>'Avaliação',
'industry'=>'Setor',
'SIC Code'=>'Código SIC',
'Type'=>'Tipo',
'Annual Revenue'=>'Receita Anual',
'Assigned To'=>'Atribuído à',
'Billing Address'=>'Endereço Faturamento',
'Shipping Address'=>'Endereço Entrega',
'Billing City'=>'Cidade Faturamento',
'Shipping City'=>'Cidade Entrega',
'Billing State'=>'País Faturamento',
'Shipping State'=>'País Entrega',
'Billing Code'=>'CEP Faturamento',
'Shipping Code'=>'CEP Entrega',
'Billing Country'=>'Estado Faturamento',
'Shipping Country'=>'Estado Entrega',
'Created Time'=>'Data e Hora de Criação',
'Modified Time'=>'Data e Hora de Modificação',
'Description'=>'Descrição',
'Shipping Po Box'=>'Cx Postal Entrega',
'Billing Po Box'=>'Cx Postal Faturamento',

'Salutation'=>'Saudação',
'First Name'=>'Nome',
'Phone'=>'Telefone',
'Last Name'=>'Sobrenome',
'Mobile'=>'Celular',
'Company'=>'Empresa',
'Fax'=>'Fax',
'Designation'=>'Títolo',
'Email'=>'Email',
'Lead Source'=>'Origem Lead',
'Website'=>'Website',
'Annual Revenue'=>'Receita Anual',
'Lead Status'=>'Lead Status',
'Industry'=>'Setor',
'Rating'=>'Avaliação',
'No Of Employees'=>'Número de Empregados',
'Assigned To'=>'Atribuído à',
'Yahoo Id'=>'Yahoo Id',
'Created Time'=>'Data e Hora de Criação',
'Modified Time'=>'Data e Hora de Modificação',
'Street'=>'Rua',
'Postal Code'=>'CEP',
'City'=>'Cidade',
'Country'=>'País',
'State'=>'Estado',
'Description'=>'Descrição',
'Po Box'=>'Cx Postal',
'Campaign Source'=>'Origem Campanha',
//Added for CustomView 4.2 Release
'Name'=>'Nome', 

'Potential Name'=>'Nome Oportunidade',
'Amount'=>'Valor',
'Account Name'=>'Nome Conta',
'Currency'=>'Moeda',
'Expected Close Date'=>'Data Expectativa Fechamento',
'Opportunity Type'=>'Tipo Oportunidade',
'Type'=>'Tipo',
'Next Step'=>'Próximo Passo',
'Lead Source'=>'Origem Lead',
'Sales Stage'=>'Estágio Vendas',
'Assigned To'=>'Atribuído à',
'Probability'=>'Probabilidade(%)',
'Campaign Source'=>'Origem Campanha',
'Description'=>'Descrição',
'Created Time'=>'Data e Hora de Criação',
'Modified Time'=>'Data e Hora de Modificação',
//Added for 4.2 Release -- CustomView
'Potential'=>'Oportunidade',
'Expected Close'=>'Expectativa Fechamento',

'Subject'=>'Assunto',
'Potential Name'=>'Nome Oportunidade',
'Quote Stage'=>'Estágio Cotação',
'Valid Till'=>'Válido até',
'Team'=>'Equipe',
'Contact Name'=>'Nome Contato',
'Currency'=>'Moeda',
'Carrier'=>'Transportador',
'Sub Total'=>'Sub Total',
'Shipping'=>'Entrega',
'Inventory Manager'=>'Responsável Estoque',
'Type'=>'Tipo',
'Tax'=>'Imposto',
'Total'=>'Total',
'Product Name'=>'Nome Produto',
'Assigned To'=>'Atribuído à',
'Billing Address'=>'Endereço Faturamento',
'Shipping Address'=>'Endereço Entrega',
'Billing City'=>'Cidade Faturamento',
'Billing State'=>'País Faturamento',
'Billing Code'=>'CEP Faturamento',
'Billing Country'=>'Estado Faturamento',
'Billing Po Box'=>'Cx Postal Faturamento',
'Shipping Po Box'=>'Cx Postal Entrega',
'Shipping City'=>'Cidade Entrega',
'Shipping State'=>'País Entrega',
'Shipping Code'=>'CEP Entrega',
'Shipping Country'=>'Estado Entrega',
'Created Time'=>'Data e Hora de Criação',
'Modified Time'=>'Data e Hora de Modificação',
'Description'=>'Descrição',
'Account Name'=>'Nome Conta',
'Terms & Conditions'=>'Prazos e Condições',

'Subject'=>'Assunto',
'Quote Name'=>'Nome Cotação',
'Vendor Name'=>'Nome Fornecedor',
'Invoice Terms'=>'Prazos Faturamento',
'Contact Name'=>'Nome Contato',//to include contact name vtiger_field in Invoice
'Invoice Date'=>'Data Faturamento',
'Sub Total'=>'Subtotal',
'Due Date'=>'Data Vencimento',
'Carrier'=>'Transportador',
'Type'=>'Tipo',
'Sales Tax'=>'Imposto Vendas',
'Sales Commission'=>'Comissões Vendas',
'Excise Duty'=>'Imposto',
'Total'=>'Total',
'Product Name'=>'Nome Produto',
'Assigned To'=>'Atribuído à',
'Billing Address'=>'Endereço de Faturamento',
'Shipping Address'=>'Endereço de Entrega',
'Billing City'=>'Cidade Faturamento',
'Billing State'=>'País Faturamento',
'Billing Code'=>'CEP Faturamento',
'Billing Country'=>'Estado Faturamento',
'Billing Po Box'=>'Cx Postal Faturamento',
'Shipping Po Box'=>'Cx Postal Entrega',
'Shipping City'=>'Cidade Entrega',
'Shipping State'=>'País Entrega',
'Shipping Code'=>'CEP Entrega',
'Shipping Country'=>'Estado Entrega',
'City'=>'Cidade',
'State'=>'País',
'Code'=>'Código',
'Country'=>'Estado',
'Created Time'=>'Data e Hora de Criação',
'Modified Time'=>'Data e Hora de Modificação',
'Description'=>'Descrição',
'Potential Name'=>'Nome Oportunidade',
'Customer No'=>'Número Cliente',
'Sales Order'=>'Pedido Vendas',
'Notes'=>'Documento',
'Pending'=>'Pendente',
'Account Name'=>'Nome Conta',
'Terms & Conditions'=>'Prazos e Condições', 

'Product Name'=>'Nome Produto',
//'Product Code'=>'Numero Parti',
'Part Number'=>'Número Partes',
'Product Active'=>'Produto Ativo',
'Commission Rate'=>'Percentual de Comissão (%)',
'Qty/Unit'=>'Quantitadade/Unidade',
'Unit Price'=>'Preço Unitário',
'Manufacturer'=>'Fabricante',
'Product Category'=>'Categoria Produto',
'Support Start Date'=>'Data Início Suporte',
'Support Expiry Date'=>'Data Final Suporte',
'Purchase Date'=>'Data Compra',
'Sales Start Date'=>'Data Início Vendas',
'Sales End Date'=>'Data Final Vendas',
'Created Time'=>'Data e Hora de Criação',
'Modified Time'=>'Data e Hora de Modificação',
'Related To'=>'Relacionado à',
'Usage Unit'=>'Unidade de uso',
'Handler'=>'Gerenciador',
'Contact Name'=>'Nome Contato',
'Currency'=>'Moeda',
'Reorder Level'=>'Nível Reordinamento',
'Tax Class'=>'Imposto',
'Mfr PartNo'=>'Número Série Fabricante',
'Vendor PartNo'=>'Número Série Fornecedor',
'Serial No'=>'Número Série',
'Qty In Stock'=>'Qtd. em Estoque',
'Product Sheet'=>'Estrutura Produto',
'Qty In Demand'=>'Qtd. em Demanda',
'GL Account'=>'Conta Plano Contas',
'Vendor Name'=>'Nome Fornecedor', 
'Product Image'=>'Imagem Produto',
'Campaign Name'=>'Nome Campanha',
'Campaign Type'=>'Tipo Campanha',
'Campaign Status'=>'Status Campanha',
'Campaign ID'=>'ID Campagna',
'Expected Close Date'=>'Data Expectativa Fechamento',
'Expected Revenue'=>'Expectativa Faturado',
'Budget Cost'=>'Custo Orçamento',
'Actual Cost'=>'Custo Atual',
'Expected Response'=>'Expectativa Resposta',
'Assigned To'=>'Atribuído à',
'Num Sent'=>'Num Envio',
'Created Time'=>'Data e Hora de Criação',
'Modified Time'=>'Data e Hora de Modificação',
'Description'=>'Descrição',
'Product'=>'Produto',
'Target Audience'=>'Público Alvo',
'TargetSize'=>'Tamanho Alvo',
'Sponsor'=>'Patrocinador',

'Expected Sales Count'=>'Expectativa Vendas',
'Expected Response Count'=>'Expectativa Resposta',
'Expected ROI'=>' Expectativa ROI',

'Actual Sales Count'=>'Vendas Atual',
'Actual Response Count'=>'Resposta Atual',
'Actual ROI'=>'ROI Atual',
'Select One'=>'Selecione Um', 

'Assigned To'=>'Atribuído à',
'Contact Name'=>'Nome Contato',
'Priority'=>'Gravidade',
'Status'=>'Status',
'Category'=>'Categoria',
'Update History'=>'Histórico Atualização',
'Created Time'=>'Data e Hora de Criação',
'Modified Time'=>'Data e Hora de Modificação',
'Title'=>'Título',
'Description'=>'Descrição', 
'Attachment'=>'Anexo',
'Add Comment'=>'Adicionar Comentário',

'Subject'=>'Assunto',
'Quote Name'=>'Nome Cotação',
'Vendor Name'=>'Nome Fornecedor',
'Requisition No'=>'Número Requisição',
'Tracking Number'=>'Número Rastreamento',
'Contact Name'=>'Nome Contato',
'Due Date'=>'Data Vencimento',
'Carrier'=>'Transportador',
'Type'=>'Tipo',
'Sales Tax'=>'Imposto Vendas',
'Sales Commission'=>'Commissão Vendas',
'Excise Duty'=>'IPI',
'Total'=>'Total',
'Product Name'=>'Nome Produto',
'Assigned To'=>'Atribuído à',
'Billing Address'=>'Endereço Faturamento',
'Shipping Address'=>'Endereço Entrega',
'Billing City'=>'Cidade Faturamento',
'Billing State'=>'País Faturamento',
'Billing Code'=>'CEP Faturamento',
'Billing Country'=>'País Faturamento',
'Billing Po Box'=>'Cx Postal Faturamento',
'Shipping Po Box'=>'Cx Postal Entrega',
'Shipping City'=>'Cidade Entrega',
'Shipping State'=>'País Entrega',
'Shipping Code'=>'CEP Entrega',
'Shipping Country'=>'Estado Faturamento',
'City'=>'Cidade',
'State'=>'Estado',
'Code'=>'CEP',
'Country'=>'País',
'Created Time'=>'Data e Hora de Criação',
'Modified Time'=>'Data e Hora de Modificação',
'Description'=>'Descrição',
'Potential Name'=>'Nome Oportunidade',
'Customer No'=>'Código Cliente',
'Purchase Order'=>'Pedido de Compra',
'Vendor Terms'=>'Prazos Fornecedor',
'Pending'=>'Pendente',
'Account Name'=>'Nome Conta',
'Terms & Conditions'=>'Prazos e Condições', 

// ***
'Po Box'=>'Cx Postal',
'Postal Code'=>'CEP',
'Street'=>'Rua',
'Industry'=>'Setor',
'Tax Type'=>'Tipo Imposto',
'Discount Percent'=>'Percentual Desconto',
'Discount Amount'=>'Valor Desconto',
'Terms & Conditions'=>'Prazos e Condições',
'Adjustment'=>'Ajuste',
'S&H Amount'=>'Valor S&H',

// picklist values
'--None--'=>'-- nenhum --',

'Acquired'=>'Acquisido',
'Active'=>'Ativo',
'Market Failed'=>'Mercado Falido',
'Project Cancelled'=>'Projeto Cancelado',
'Shutdown'=>'Cancelação',

'Apparel'=>'Vestiário',
'Banking'=>'Bancos',
'Biotechnology'=>'Biotecnologia',
'Chemicals'=>'Química',
'Communications'=>'Comunicações',
'Construction'=>'Costrução',
'Consulting'=>'Consultoria',
'Education'=>'Educação',
'Electronics'=>'Eletrônica',
'Energy'=>'Energia',
'Engineering'=>'Engenharia',
'Entertainment'=>'Entretenimento',
'Environmental'=>'Meio Ambiente',
'Finance'=>'Finanças',
'Food & Beverage'=>'Alimentos e Bebidas',
'Government'=>'Governo',
'Healthcare'=>'Saúde',
'Hospitality'=>'Hotéis',
'Insurance'=>'Seguros',
'Machinery'=>'Máquinas',
'Manufacturing'=>'Artesanato',
'Media'=>'Mídia',
'Not For Profit'=>'ONG',
'Recreation'=>'Recreação',
'Retail'=>'Comércio',
'Shipping'=>'Transporte Marítimo',
'Technology'=>'Tecnologia',
'Telecommunications'=>'Telecomunicações',
'Transportation'=>'Transportes',
'Utilities'=>'Serviço Público',
'Other'=>'Outro',

'Analyst'=>'Analista',
'Competitor'=>'Concorrente',
'Customer'=>'Cliente',
'Integrator'=>'Integrador',
'Investor'=>'Investidor',
'Partner'=>'Parceiro',
'Press'=>'Imprensa',
'Prospect'=>'Potenciais',
'Reseller'=>'Revendedor', 

'Mr.'=>'Sr',
'Ms.'=>'Sra',
'Mrs.'=>'Srta',
'Dr.'=>'Dr',
'Prof.'=>'Professor',

'Cold Call'=>'Cold Call',
'Existing Customer'=>'Cliente Existente',
'Self Generated'=>'Auto Gerado',
'Employee'=>'Empregado',
'Partner'=>'Parceiro',
'Public Relations'=>'Relações públicas',
'Direct Mail'=>'Mala Direta',
'Conference'=>'Conferência',
'Trade Show'=>'Feira Negócios',
'Web Site'=>'Website',
'Word of mouth'=>'Boca à Boca',

'Attempted to Contact'=>'Tentativa de Contato',
'Cold'=>'Frio',
'Contact in Future'=>'Contatar Futuramente',
'Contacted'=>'Contatado',
'Hot'=>'Quente',
'Junk Lead'=>'Lead Lixeira',
'Lost Lead'=>'Lead Perdido',
'Not Contacted'=>'Não Contatado',
'Pre Qualified'=>'Pré Qualificado',
'Qualified'=>'Qualificado',
'Warm'=>'Quentíssimo',

'Existing Business'=>'Negócio Existente',
'New Business'=>'Novo Negócio',

'Prospecting'=>'Prospectivando',
'Qualification'=>'Qualificar',
'Needs Analysis'=>'Análises das Necessidades',
'Value Proposition'=>'Proposição de Valor',
'Id. Decision Makers'=>'Decisor Principal',
'Perception Analysis'=>'Análises de Percepção',
'Proposal/Price Quote'=>'Cotação',
'Negotiation/Review'=>'Negociação/Revisão',
'Closed Won'=>'Fechado Vencido',
'Closed Lost'=>'Fechado Perdido',

'Created'=>'Criado',
'Delivered'=>'Enviado',
'Reviewed'=>'Revisionado',
'Accepted'=>'Aceitado',
'Rejected'=>'Rejeitado',

'FedEx'=>'FedEx',
'UPS'=>'Correios',
'USPS'=>'USPS',
'DHL'=>'DHL',
'BlueDart'=>'BlueDart',
'Sales Tax'=>'Imposto Vendas',   

'Hardware'=>'Hardware',
'Software'=>'Software',
'CRM Applications'=>'Aplicacões de CRM',

'300-Sales-Software'=>'300-Vendas-Software',
'301-Sales-Hardware'=>'301-Vendas-Hardware',
'302-Rental-Income'=>'302-Aluguel-Renda',
'303-Interest-Income'=>'303-Juros-Renda',
'304-Sales-Software-Support'=>'304-Vendas-Software-Suporte',
'305-Sales Other'=>'305-Outras Vendas',
'306-Internet Sales'=>'306-Internet Vendas',
'307-Service-Hardware Labor'=>'307-Serviço-Hardware Labor',
'308-Sales-Books'=>'308-Vendas-Livros',

'Box'=>'Caixa',
'Carton'=>'Caixa',
'Caton'=>'Caton',
'Dozen'=>'Dúzia',
'Each'=>'Cada',
'Hours'=>'Horas',
'Impressions'=>'Impressões',
'Lb'=>'Lb',
'M'=>'M',
'Pack'=>'Pacote',
'Pages'=>'Páginas',
'Pieces'=>'Itens',
'Quantity'=>'Quantidade',
'Reams'=>'Resma',
'Sheet'=>'Papel',
'Spiral Binder'=>'Recolhedor a Espiral',
'Sq Ft'=>'Sq Ft',

'Created'=>'Criado',
'Approved'=>'Aprovado',
'Sent'=>'Enviado',
'Credit Invoice'=>'Nota de Crédito',
'Paid'=>'Pagado',
//Added to Custom Invoice Number
'Invoice No'=>'Número Fatura',
'Adjustment'=>'Ajuste',

'Conference'=>'Conferência',
'Webinar'=>'Web Conferência',
'Trade Show'=>'Feira de Negócios',				    
'Public Relations'=>'Relações Públicas',
'Partners'=>'Parceiro',
'Referral Program'=>'Programa Referência',
'Advertisement'=>'Propaganda',
'Banner Ads'=>'Pôster',
'Direct Mail'=>'Mala Direta',
'Email'=>'Email',
'Telemarketing'=>'Telemarketing',
'Others'=>'Outros',

'Planning'=>'Planejamento',
'Active'=>'Ativo',	
'Inactive'=>'Inativo',
'Complete'=>'Completo',
'Cancelled'=>'Cancelado',

'Excellent'=>'Exelente',
'Good'=>'Bom',
'Average'=>'Médio',
'Poor'=>'Ruim',

'Big Problem'=>'Problema Grande',
'Small Problem'=>'Problema Pequeno',
'Other Problem'=>'Outro Problema',

'Low'=>'Baixo',
'Normal'=>'Normal',
'High'=>'Alto',
'Urgent'=>'Urgente',

'Minor'=>'Menor',
'Major'=>'Maior',
'Feature'=>'Característico',
'Critical'=>'Critíco',

'Open'=>'Aberto',
'In Progress'=>'Em Andamento',
'Wait For Response'=>'Aguardando uma Resposta',
'Closed'=>'Fechado',
 
'Created'=>'Criado',
'Approved'=>'Aprovado',
'Delivered'=>'Distribuído',
'Cancelled'=>'Cancelado',
'Received Shipment'=>'Entrega Recebida',

'Mobile'=>'Celular',

'Last Name'=>'Último Nome',

//crmv@8716
'LBL_ACTION_TYPE_PHP_FUNCTION'=> 'Função PHP Personalizada',
'LBL_PHP_FUNCTION'=>'Nome função PHP',
'LBL_CRITERIA_VALUE_HASCHANGED' => 'Foi mudado',
'LBL_CRITERIA_VALUE_NAME_FROM'=>'De',
'LBL_CRITERIA_VALUE_NAME_TO'=>'Para',
'LBL_CRITERIA_VALUE_IGNORE'=>'Qualquer valor',
'LBL_ERR_FUNCTION_VALUE'=>'Nome da função não foi especificada',
'LBL_ERR_FROM_VALUE'=>'Campo DE não foi especificado',
'LBL_ERR_TO_VALUE'=>'Campo PARA não foi especificado',
'LNK_RUN'=>'Executar manualmente',
'LBL_RUN_WORKFLOW_MSG' => ' Você tem certeza que quer executar este workflow em todos os registros presentes?',
//crmv@8716e

//crmv@8820
'LBL_RECORD_OWNER' => 'Responsável',
'LBL_OTHER_USER' => 'Definir outro Usuário',
'LBL_CURRENT_USER' => 'Usuário Atual',
//crmv@8820e

//crmv@8823
'LBL_TASK_DATE' => 'Data Tarefa:',
'LBL_EVENT_DATE' => 'Data Evento:',
'LBL_DUE_DATE' => 'Duração: ',
//crmv@8823e
);

?>
