<?php
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version 1.1.2
 * ("License"); You may not use this file except in compliance with the 
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an  "AS IS"  basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License.
 * The Original Code is:  SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 ********************************************************************************/
/*********************************************************************************
 * $Header: /advent/projects/wesat/vtiger_crm/sugarcrm/modules/Emails/Save.php,v 1.27 2005/04/29 08:54:38 rank Exp $
 * Description:  Saves an Account record and then redirects the browser to the 
 * defined return URL.
 * Portions created by SugarCRM are Copyright (C) SugarCRM, Inc.
 * Portions created by CRMVILLAGE.BIZ are Copyright (C) CRMVILLAGE.BIZ.
 * All Rights Reserved.
 * Contributor(s): ______________________________________..
 ********************************************************************************/
/* crmv@15309	crmv@25356	crmv@25351	crmv@31263	crmv@48501 */

global $adb, $table_prefix, $current_user;

//check for mail server configuration thro ajax
if (isset($_REQUEST['server_check']) && $_REQUEST['server_check'] == 'true') {
	$sql="select * from ".$table_prefix."_systems where server_type = ?";
	$records=$adb->num_rows($adb->pquery($sql, array('email')),0,"id");
	if($records != '')
		echo 'SUCCESS';
	else
		echo 'FAILURE';	
	die;
}

$focus = CRMEntity::getInstance('Emails');

//check for mail server configuration thro ajax
if (isset($_REQUEST['add2queue']) && $_REQUEST['add2queue'] == 'true') {
	$request = $_REQUEST;
	unset($request['add2queue']);
	(isset($request['save_in_draft']) && $request['save_in_draft'] != '') ? $method = 'draft' : $method = 'send';
	$focus->add2SendingQueue($current_user->id, $method, $request);
	if ($method == 'send') {
		echo '[#]SUCCESS[#]'.Zend_Json::encode(array('error'=>'','javascript'=>'window.opener.VtigerJS_DialogBox.notify("'.getTranslatedString('MESSAGE_MAIL_SENT_SUCCESSFULLY','Emails').'");')).'[#]';
	} else {
		echo vtlib_purify($_REQUEST['message']).'|##||##|';
	}
	exit;
}

require_once('include/logging.php');
require_once('include/database/PearDatabase.php');
require_once("modules/Emails/mail.php");

$local_log =& LoggerManager::getLogger('index');

global $mod_strings,$app_strings;

if (isset($_REQUEST['description']) && $_REQUEST['description'] !='') {
	$_REQUEST['description'] = fck_from_html($_REQUEST['description']);
}
$all_to_ids = $_REQUEST["hidden_toid"];
$all_to_ids .= $_REQUEST["saved_toid"];
$other_to_mails = explode(',',$_REQUEST["to_mail"]);
foreach ($other_to_mails as $other_to_mail) {
	if ($other_to_mail != '') {
		$all_to_ids .= ','.trim($other_to_mail);
	}
}
$_REQUEST["saved_toid"] = implode(',',array_filter(explode(',',$all_to_ids)));
$_REQUEST['email_flag'] = 'DRAFT';
setObjectValuesFromRequest($focus);

//assign the focus values
$focus->parent_id = $_REQUEST['parent_id'];
$focus->parent_type = $_REQUEST['parent_type'];
$focus->column_fields["assigned_user_id"]=$current_user->id;
$focus->column_fields["activitytype"]="Emails";
$focus->column_fields["date_start"]= date(getNewDisplayDate());//This will be converted to db date format in save

$error_message = '';
$skip_delete_drafts = false;

if (isset($_REQUEST['send_mail']) && $_REQUEST['send_mail']) {
	include("modules/Emails/mailsend.php");
}

if (isset($_REQUEST['save_in_draft']) && $_REQUEST['save_in_draft'] != '') {
	include("modules/Emails/maildraft.php");
} elseif (!$skip_delete_drafts && isset($_REQUEST['draft_id']) && $_REQUEST['draft_id'] != '') {
	delete_draft_mail($_REQUEST['draft_id']);
}

if (empty($skip_exit)) {
	echo '[#]SUCCESS[#]'.Zend_Json::encode(array('error'=>$error_message,'javascript'=>$javascript_code)).'[#]';
	exit;
}
?>