<?php
/* crmv@42752 */

require_once('Smarty_setup.php');

global $theme, $current_language, $app_strings;

$currentModule = 'Calendar';
$messageId = intval($_REQUEST['messageid']);

$mod_strings = return_module_language($current_language, $currentModule);


// retrieve email info
$focus = CRMEntity::getInstance('Messages');
$focus->retrieve_entity_info($messageId, 'Messages');

// now populate some values
$_REQUEST['subject'] = $focus->column_fields['subject'];

// contacts (directly linked or from email addresses)
$RM = RelationManager::getInstance();
$relConts = $RM->getRelatedIds('Messages', $messageId, array('Contacts'));
$email = $focus->column_fields['mfrom'];
$otherConts = $focus->getEntitiesFromEmail($email, false, false, array('Contacts'), true);
if ($otherConts['crmid'] > 0) $relConts[] = $otherConts['crmid'];

if (count($relConts) > 0) {
	$_REQUEST['contact_id'] = $relConts[0];
}

// altri campi?

$smarty = new vtigerCRM_Smarty();

$smarty->assign('APP', $app_strings);
$smarty->assign('MOD', $mod_strings);
$smarty->assign('MODULE', $currentModule);

$smarty->assign('THEME', $theme);

if ($_REQUEST['activity_mode'] == 'Events') {
	$smarty->assign('PAGE_TITLE', getTranslatedString('LBL_ADD', $currentModule));
} else {
	$smarty->assign('PAGE_TITLE', getTranslatedString('LBL_ADD_TODO', $currentModule));
}

$smarty->display('SmallHeader.tpl');

// trick to pretend we are in calendar
$_REQUEST['module'] = $currentModule;
$_REQUEST['hide_button_list'] = '1';
$smarty->display('Buttons_List_Edit.tpl');
$smarty->display('modules/SDK/src/Reference/Autocomplete.tpl');


// alcuni script (calendario e messaggi)
echo '<script type="text/javascript" src="modules/Calendar/script.js"></script>'."\n";
echo '<script type="text/javascript" src="modules/Messages/Messages.js"></script>'."\n";
echo '<input type="hidden" id="messageid" name="messageid" value="'.$messageId.'" />'."\n";


include('modules/Calendar/EditView.php');

// and now change a few things
?>
<script type="text/javascript">
	/* replace handlers */
	var empty_search_str = "<?php echo getTranslatedString('LBL_SEARCH_STRING'); ?>";
	var allBtns = jQuery('#Buttons_List_4 input'),
		btnSave = jQuery(allBtns[0]),
		btnCanc = jQuery(allBtns[1]);

	btnSave.attr('onclick', '');
	btnSave.click(messagesSaveEvent);

	btnCanc.attr('onclick', '');
	btnCanc.click(function() {
		closePopup();
	});
</script>