<?php
// start here VTE 4.5 patches

if (!function_exists('addColumnToTable')) {
	function addColumnToTable($tablename, $columnname, $type, $extra = '') {
		global $adb;
	
		// check if already present
		$cols = $adb->getColumnNames($tablename);
		if (in_array($columnname, $cols)) {
			return;
		}
	
		$col = $columnname.' '.$type.' '.$extra;
		$adb->alterTable($tablename, $col, 'Add_Column');
	}
}
	
if (isModuleInstalled('Messages')) {
	global $adb, $table_prefix;
	
	$adb->pquery("update {$table_prefix}_field set readonly = ? where tablename = ? and fieldname = ?",array(100,$table_prefix.'_messages','mvisibility'));
	
	$tablename = $table_prefix.'_messages_cron';
	if (Vtiger_Utils::CheckTable($tablename)) {
		// if already there, just add the missing column
		addColumnToTable($tablename, 'ctime', 'T', 'DEFAULT 0000-00-00 00:00:00');
	}
	$adb->pquery("update $tablename set ctime = ?",array(date('Y-m-d H:i:s')));
	
	$tablename = $table_prefix.'_messages_pop3';
	if (Vtiger_Utils::CheckTable($tablename)) {
		// if already there, just add the missing column
		addColumnToTable($tablename, 'accountid', 'I(10)');
	}
}

// traduzioni per revision
global $enterprise_current_version,$enterprise_mode;
SDK::setLanguageEntries('APP_STRINGS', 'LBL_BROWSER_TITLE', array(
	'it_it'=>"$enterprise_mode $enterprise_current_version",
	'en_us'=>"$enterprise_mode $enterprise_current_version",
	'pt_br'=>"$enterprise_mode $enterprise_current_version",
	'de_de'=>"$enterprise_mode $enterprise_current_version"
));
?>