<?php
$path = '../../../';
include_once($path.'config.inc.php');
chdir($root_directory);
include('vtigerversion.php');
require_once('include/utils/utils.php');
include_once('vtlib/Vtiger/Module.php');
require_once('Smarty_setup.php');
$Vtiger_Utils_Log = true;
global $adb, $table_prefix, $current_user, $current_language;
session_start();
SDK::getUtils();
if (empty($table_prefix)) $table_prefix = 'vtiger';
if (empty($current_user->id)) $current_user->id = 1;
if (empty($current_language)) $current_language = 'en_us';

//Update Configuration
$rev_to = '813';
$new_version = '45';
$old_versions = array(
	'40'=>'457',
	'41'=>'499',
	'42'=>'535',
	'43'=>'620',
	'431'=>'631',
	'432'=>'646',
	'44'=>'667',
	'441'=>'691'
);
$version_labels = array(
	'40'=>'4.0',
	'41'=>'4.1',
	'42'=>'4.2',
	'43'=>'4.3',
	'431'=>'4.3.1',
	'432'=>'4.3.2',
	'44'=>'4.4',
	'441'=>'4.4.1',
	'45'=>'4.5'
);
$filename = '45.php';
$folder = 'modules/Update/free_changes/';
//Update Configuration end

header('Content-Type: text/html; charset='. $default_charset);
$smarty = new vtigerCRM_Smarty;
$smarty->assign('PATH',$path);

$undo_button = true;

$description = '';
if (empty($_REQUEST['mode'])) {
	if (!in_array($enterprise_current_build,$old_versions) || !in_array($enterprise_current_version,$version_labels)) {
		$undo_button = false;
		$text = 'There aren\'t updates for this version of VTECRM.<br />Please contact Crmvillage.BIZ if you think that this version should be updated.';
	} else {
		$description = '
		<script language="JavaScript" type="text/javascript">
		function pleaseWait() {
		    if (!emptyCheck("username","Username",getObj("username").type))
				return false;
			if (!emptyCheck("password","Password",getObj("password").type))
				return false;
		    getObj("continue_button").hide();
		    getObj("continue_button_container").innerHTML = "<b>Please wait...</b>";
		}
		</script>
		<form action="'.$filename.'" method="post" name="form" id="form" onsubmit="return pleaseWait();">
			<input type="hidden" name="mode" value="update">
			<table border="0" cellpadding="20" cellspacing="0" width="100%" align="center" class="small">
				<tr>
					<td colspan="2" align="center">
						Insert username and password of an administrator user and<br />
						click Continue in order to update your <b>VTECRM '.$enterprise_current_version.'</b> to the last version <b>'.$version_labels[$new_version].'</b>
					</td>
				</tr>
				<tr>
					<td colspan="2" align="center">
						<table border="0" cellpadding="5" cellspacing="0" width="100%" align="center" class="small">
							<tr>
								<td align="right" width="40%">Username: </td>
								<td align="left" width="60%"><input id="username" name="username" class="small" value="" size="23" type="text" /></td>
							</tr>
							<tr>
								<td align="right">Password: </td>
								<td align="left"><input id="password" name="password" class="small" value="" size="23" type="password" /></td>
							</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td colspan="2" align="center" id="continue_button_container">
						<input type="submit" class="crmbutton small edit" id="continue_button" value="Continue" title="Continue" />
					</td>
				</tr>
			</table>
		</form>';
	}
} elseif($_POST['mode'] == 'update') {
	$focus = CRMEntity::getInstance('Users');
	$id = $focus->retrieve_user_id($_REQUEST['username']);
	if (empty($id)) {
		$text = 'You must specify a valid username and password.';
	} else {
		$focus->retrieve_entity_info($id,'Users');
		if (!$focus->doLogin($_REQUEST['password']) || !is_admin($focus)) {
			$text = 'You must specify a valid username and password.';
		} else {
			$rev_from = $enterprise_current_build;
			if (file_exists("{$root_directory}vtigerversion.php.txt")) {
				if (unlink("{$root_directory}vtigerversion.php")) {
					if (rename("{$root_directory}vtigerversion.php.txt","{$root_directory}vtigerversion.php")) {
						include('vtigerversion.php');
						require_once("modules/Update/Update.php");
						$focus = new Update('','','',$rev_from,$rev_to);
						$focus->use_script = true;
						ob_start();
						$focus->update_changes();
						$description = ob_get_contents();
						ob_end_clean();
						@rename($root_directory.$folder.$filename,$root_directory.$folder.$filename.".txt");
						//$adb->query('DELETE FROM tbl_s_morphsuit');
						unset($_SESSION['checkMorphsuit']);
						unset($_SESSION['checkUsersMorphsuit']);
						$description .= '
						<table border="0" cellpadding="20" cellspacing="0" width="100%" align="center" class="small">
							<tr>
								<td colspan="2" align="center">
									<form action="'.$path.'index.php" method="post" name="form" id="form">
									 	<input type="submit" class="crmbutton small edit" value="Finish" title="Finish" />
									</form>
								</td>
							</tr>
						</table>';
					}
				}
			}
		}
	}
}
if (empty($description)) {
	if (empty($text)) {
		$text = 'Some problems during update, did you hack something.<br />Please contact Crmvillage.BIZ or retry.';
	}
	$description = '
	<table border="0" cellpadding="20" cellspacing="0" width="100%" align="center" class="small">
		<tr>
			<td colspan="2" align="center">
				'.$text.'
			</td>
		</tr>';
	if ($undo_button) {
		$description .= '
		<tr>
			<td colspan="2" align="center" id="continue_button_container">
				<input type="button" class="crmbutton small delete" value="Undo" title="Undo" onclick="history.back();" />
			</td>
		</tr>';
	}
	$description .= '</table>';
}
$smarty->assign('CURRENT_LANGUAGE',$current_language);
$smarty->assign('BODY',$description);
$smarty->display('NoLoginMsg.tpl');
?>