<?php
$mod_strings = array (
  'LBL_MODULE_NAME' => 'Contas',
  'LBL_MODULE_TITLE' => 'Contas: Home',
  'LBL_SEARCH_FORM_TITLE' => 'Pesquisar Conta',
  'LBL_LIST_FORM_TITLE' => 'Listar Contas',
  'LBL_NEW_FORM_TITLE' => 'Nova Conta',
  'LBL_MEMBER_ORG_FORM_TITLE' => 'Organizaes Membros',
  'LBL_TOP_ACCOUNTS' => 'Minhas Principais Contas',
  'LBL_TOP_AMOUNT' => 'Quantidade',
  'LBL_LIST_ACCOUNT_NAME' => 'Nome Conta',
  'LBL_LIST_CITY' => 'Cidade',
  'LBL_LIST_WEBSITE' => 'Website',
  'LBL_LIST_STATE' => 'Estado',
  'LBL_LIST_PHONE' => ' Telefone',
  'LBL_LIST_EMAIL_ADDRESS' => 'Endereo Email',
  'LBL_LIST_CONTACT_NAME' => 'Nome Contato',
  'LBL_LIST_AMOUNT' => 'Oportunidades Totais',
  'db_name' => 'LBL_LIST_ACCOUNT_NAME',
  'db_website' => 'LBL_LIST_WEBSITE',
  'db_billing_address_city' => 'LBL_LIST_CITY',
  'LBL_ACCOUNT' => 'Conta:',
  'LBL_ACCOUNT_NAME' => 'Nome Conta:',
  'LBL_PHONE' => 'Telefone:',
  'LBL_WEBSITE' => 'Website:',
  'LBL_FAX' => 'Fax:',
  'LBL_TICKER_SYMBOL' => 'Cd. Bolsa:',
  'LBL_OTHER_PHONE' => 'Telefone Alternativo:',
  'LBL_ANY_PHONE' => ' Outro Telefone:',
  'LBL_MEMBER_OF' => 'Membro de:',
  'LBL_EMAIL' => 'Email:',
  'LBL_EMPLOYEES' => 'Empregados:',
  'LBL_OTHER_EMAIL_ADDRESS' => 'Email Alternativo:',
  'LBL_ANY_EMAIL' => 'Outro Email:',
  'LBL_OWNERSHIP' => 'Responsvel:',
  'LBL_RATING' => 'Avaliao:',
  'LBL_INDUSTRY' => 'Atividade:',
  'LBL_SIC_CODE' => 'Cod CNAE:',
  'LBL_TYPE' => 'Tipo:',
  'LBL_ANNUAL_REVENUE' => 'Receita Anual:',
  'LBL_ADDRESS_INFORMATION' => 'Informao Endereo',
  'LBL_ACCOUNT_INFORMATION' => 'Informao Conta',
  'LBL_CUSTOM_INFORMATION' => 'Informao Personalizada',
  'LBL_BILLING_ADDRESS' => 'Endereo (Faturamento):',
  'LBL_SHIPPING_ADDRESS' => 'Endereo (Entrega):',
  'LBL_ANY_ADDRESS' => 'Outro Endereo:',
  'LBL_CITY' => 'Cidade :',
  'LBL_STATE' => 'Estado:',
  'LBL_POSTAL_CODE' => 'CEP:',
  'LBL_COUNTRY' => 'Pas:',
  'LBL_DESCRIPTION_INFORMATION' => 'Informao Descrio',
  'LBL_DESCRIPTION' => 'Descrio:',
  'NTC_COPY_BILLING_ADDRESS' => 'Copiar o Endereo de Faturamento no Endereo de Entrega',
  'NTC_COPY_SHIPPING_ADDRESS' => 'Copiar o Endereo de Entrega no Endereo de Faturamento',
  'NTC_REMOVE_MEMBER_ORG_CONFIRMATION' => 'Voc tem certeza que deseja remover este registro come membro da organizao?',
  'LBL_DUPLICATE' => 'Contas com Possibilidade de Duplicao',
  'MSG_DUPLICATE' => 'Criando esta Conta voc potencialmente criar um duplicado. Voc pode selecionar uma Conta da lista abaixo ou cliquar em Criar Nova Conta para continuar criando uma nova Conta com os dados anteriormente inseridos.',
  'LBL_INVITEE' => 'Contatos',
  'ERR_DELETE_RECORD' => 'Um nmero de registro deve ser especificado para deletar a Conta',
  'LBL_SELECT_ACCOUNT' => 'Selecionar Conta',
  'LBL_GENERAL_INFORMATION' => 'Informao Geral',
  'LBL_NEW_POTENTIAL' => 'Nova Oportunidade',
  'LBL_POTENTIAL_TITLE' => 'Oportunidade',
  'LBL_NEW_TASK' => 'Nova Tarefa',
  'LBL_TASK_TITLE' => 'Tarefas',
  'LBL_NEW_CALL' => 'Nova Chamada',
  'LBL_CALL_TITLE' => 'Chamadas',
  'LBL_NEW_MEETING' => 'Nova Reunio',
  'LBL_MEETING_TITLE' => 'Reunies',
  'LBL_NEW_EMAIL' => 'Novo Email',
  'LBL_EMAIL_TITLE' => 'Email',
  'LBL_NEW_CONTACT' => 'Novo Contato',
  'LBL_CONTACT_TITLE' => 'Contatos',
  'LBL_ALL' => 'Todos',
  'LBL_PROSPECT' => 'Prospect',
  'LBL_INVESTOR' => 'Investidor',
  'LBL_RESELLER' => 'Revendedor',
  'LBL_PARTNER' => 'Parceiro',
  'LBL_TOOL_FORM_TITLE' => 'Ferramentas Conta',
  'Account Name' => 'Nome Conta',
  'Phone' => 'Telefone',
  'Website' => 'Site',
  'Fax' => 'Fax',
  'Ticker Symbol' => 'Cod. Bolsa',
  'Other Phone' => 'Telefone Alternativo',
  'Member Of' => 'Membro de',
  'Email' => 'Email',
  'Employees' => 'Empregados',
  'Other Email' => 'Email Alternativo',
  'Ownership' => 'Responsvel',
  'Rating' => 'Avaliao',
  'industry' => 'Atividade',
  'SIC Code' => 'Cod. CNAE',
  'Type' => 'Tipo',
  'Annual Revenue' => 'Receita Anual',
  'Assigned To' => 'Atribudo a',
  'Billing Address' => 'Endereo (Faturamento)',
  'Shipping Address' => 'Endereo (Entrega)',
  'Billing City' => 'Cidade (Faturamento)',
  'Shipping City' => 'Cidade (Entrega)',
  'Billing State' => 'Estado(Faturamento)',
  'Shipping State' => 'Estado(Entrega)',
  'Billing Code' => 'CEP (Faturamento)',
  'Shipping Code' => 'CEP (Entrega)',
  'Billing Country' => 'Pas (Faturamento)',
  'Shipping Country' => 'Pas (Entrega)',
  'Created Time' => 'Data e Hora de Criao',
  'Modified Time' => 'Data e Hora de Modificao',
  'Description' => 'Descrio',
  'Shipping Po Box' => 'Cx Postal (Entrega)',
  'Billing Po Box' => 'Cx Postal (Faturamento)',
  'Email Opt Out' => 'No enviar Email',
  'LBL_EMAIL_OPT_OUT' => 'No enviar Email',
  'Notify Owner' => 'Notificar Responsvel',
  '--None--' => '--Ningum--',
  'Acquired' => 'Adquirido',
  'Active' => 'Ativo',
  'Market Failed' => 'Venda no realizada',
  'Project Cancelled' => 'Projeto Anulado',
  'Shutdown' => 'Encerrado',
  'Apparel' => 'Vesturio',
  'Banking' => 'Bancrio',
  'Biotechnology' => 'Biotecnologia',
  'Chemicals' => 'Qumica',
  'Communications' => 'Comunicaes',
  'Construction' => 'Construo',
  'Consulting' => 'Consultoria',
  'Education' => 'Educao',
  'Electronics' => 'Eletrnica',
  'Energy' => 'Energia',
  'Engineering' => 'Engenharia',
  'Entertainment' => 'Entretenimento',
  'Environmental' => 'Meio Ambiente',
  'Finance' => 'Finanas',
  'Food & Beverage' => 'Alimentos e Bebidas',
  'Government' => 'Governo',
  'Healthcare' => 'Sade',
  'Hospitality' => 'Hotis',
  'Insurance' => 'Seguros',
  'Machinery' => 'Mquinas',
  'Manufacturing' => 'Artesanato',
  'Media' => 'Mdia',
  'Not For Profit' => 'ONG',
  'Recreation' => 'Recreao',
  'Retail' => 'Comrcio',
  'Shipping' => 'Transporte Martimo',
  'Technology' => 'Tecnologia',
  'Telecommunications' => 'Telecomunicaes',
  'Transportation' => 'Transportes',
  'Utilities' => 'Servio Pblico',
  'Other' => 'Outro',
  'Analyst' => 'Analista',
  'Competitor' => 'Concorrente',
  'Customer' => 'Cliente',
  'Integrator' => 'Integrador',
  'Investor' => 'Investidor',
  'Partner' => 'Parceiro',
  'Press' => 'Imprensa',
  'Prospect' => 'Potenciais',
  'Reseller' => 'Revendedor',
  'LBL_START_DATE' => 'Data Inicial',
  'LBL_END_DATE' => 'Data Final',
  'LBL_ACCOUNT_EXIST' => 'O Nome da Conta j existe!',
  'LBL_MAILER_EXPORT' => 'Exportar para Envio de Cartas',
  'LBL_MAILER_EXPORT_CONTACTS_TYPE' => 'Seleciona os Contatos:',
  'LBL_MAILER_EXPORT_CONTACTS_DESCR' => 'Os Contatos tambm podem ser selecionados a partir dos "Campos Personalizados" e atravs de qualquer campo padro.',
  'LBL_MAILER_EXPORT_RESULTS_TYPE' => 'Selecione o tipo de Exportao:',
  'LBL_MAILER_EXPORT_RESULTS_DESCR' => 'Os dados sero obtidos a partir das Contas e seus Contatos, que foram restitudos da pesquisa anterior.',
  'LBL_EXPORT_RESULTS_EMAIL' => 'Exportar Contato e Email',
  'LBL_EXPORT_RESULTS_EMAIL_CORP' => 'Exportar Contatos e Emails, utilizando o "Email da Empresa" se o "Email" do Contato estiver vazio',
  'LBL_EXPORT_RESULTS_FULL' => 'Exportar dados com Contatos, Email, Conta, Endereo, Telefone, etc.',
  'LBL_EXPORT_RESULTS_GO' => 'Executar Exportao',
  'LBL_MAILER_EXPORT_IGNORE' => '--ignora--',
  'LBL_MAILER_EXPORT_CHECKED' => 'Checado',
  'LBL_MAILER_EXPORT_NOTCHECKED' => 'No Checado',
//------------------crmvillage 504 release start----------------------
  'Prospect Accounts' => 'Contas Prospect',
  'New This Week'=> 'Novas da Semana',
  'Bank Details' => 'Conta Bancria',
  'VAT Registration Number' => 'ICMS',
  'Social Security number' => 'CPF',
//------------------crmvillage 504 release stop-----------------------
//ds@8 project tool
  'Internal Project Nummer' => 'Cdigo Projeto Interno',
  'External Project Nummer' => 'Cdigo Projeto Externo',
  'Total Hour' => 'Total horas',
  'Projectleader OSS' => 'Leader interno',
//ds@8e

//ds@10 duplicate create
'LBL_INSERT_ENTRIE' => 'como novo cliente',
'LBL_CLOSE_POPUP' => 'retornar',
//ds@10e

//ds@9 duplicate import
'importDate'=>'Data importao',
'importFile'=>'Arquivo de importao (nome do arquivo)',
//ds@9e

  'LBL_TimeCards' => 'Intervenes', // crmv@7214s

//crmv@7231
'External Code' => 'Cdigo Externo',
//crmv@7223
'Secondary Owner' => 'Responsvel Secundrio',
'Secondary Owner Permission' => 'Permisses Responsvel Secundrio',

//crmv@7227
'ERP Code' => 'Codigo ERP',
//crmv@7227e
'ShowHierarchy'=>'Visualizar Hierarquia',
'HideHierarchy'=>'Ocultar Hierarquia',
'AccountsHierarchy'=>'Hierarquia Contas',
'LBL_SOLD_QUANTITY'=>'Quantidade Vendida',	//crmv@16644
'Account No'=>'Nmero Conta',	//crmv@18564
'LBL_NO_PARENT_HIERARCHY'=>'Nenhum pai',	//crmv@35750
);
?>