<?php
$mod_strings = array(
	'LBL_MODULE_NAME'=>'Rechnungen',
	'LBL_SO_MODULE_NAME'=>'Rechnungen',
	'LBL_RELATED_PRODUCTS'=>'Artikelliste',
	'LBL_MODULE_TITLE'=>'Rechnungen: Home',
	'LBL_SEARCH_FORM_TITLE'=>'Rechnungen suchen',
	'LBL_LIST_FORM_TITLE'=>'Rechnungsliste',
	'LBL_LIST_SO_FORM_TITLE'=>'Liste der Kundenbestellungen',
	'LBL_NEW_FORM_TITLE'=>'Neue Rechnung',
	'LBL_NEW_FORM_SO_TITLE'=>'Neue Kundenbestellung',
	'LBL_LIST_ACCOUNT_NAME'=>'Organisation',
	'LBL_LIST_CITY'=>'Ort',
	'LBL_LIST_WEBSITE'=>'Webseite',
	'LBL_LIST_STATE'=>'Bundesland',
	'LBL_LIST_PHONE'=>'Telefon',
	'LBL_LIST_EMAIL_ADDRESS'=>'E-Mail',
	'LBL_LIST_CONTACT_NAME'=>'Person',
	'db_name'=>'LBL_LIST_ACCOUNT_NAME',
	'db_website'=>'LBL_LIST_WEBSITE',
	'db_billing_address_city'=>'LBL_LIST_CITY',
	'LBL_ACCOUNT'=>'Organisation:',
	'LBL_ACCOUNT_NAME'=>'Organisation:',
	'LBL_PHONE'=>'Telefon:',
	'LBL_FAX'=>'Fax:',
	'LBL_TICKER_SYMBOL'=>'Org. Namenszusatz:',
	'LBL_OTHER_PHONE'=>'anderes Telefon:',
	'LBL_ANY_PHONE'=>'Telefon (alternativ):',
	'LBL_MEMBER_OF'=>'gehört zu:',
	'LBL_EMAIL'=>'E-Mail:',
	'LBL_EMPLOYEES'=>'Mitarbeiter:',
	'LBL_OTHER_EMAIL_ADDRESS'=>'weitere E-Mail:',
	'LBL_ANY_EMAIL'=>'Email (alternativ):',
	'LBL_OWNERSHIP'=>'Besitzer:',
	'LBL_RATING'=>'Bewertung:',
	'LBL_INDUSTRY'=>'Branche:',
	'LBL_SIC_CODE'=>'Börsen Code:',
	'LBL_TYPE'=>'Typ:',
	'LBL_ANNUAL_REVENUE'=>'Jahresumsatz:',
	'LBL_ADDRESS_INFORMATION'=>'Adresse',
	'LBL_Quote_INFORMATION'=>'Organisation',
	'LBL_CUSTOM_INFORMATION'=>'Zusätzliche Informationen',
	'LBL_BILLING_ADDRESS'=>'Rechnungsadresse:',
	'LBL_SHIPPING_ADDRESS'=>'Lieferadresse:',
	'LBL_ANY_ADDRESS'=>'Adresse (alternativ):',
	'LBL_CITY'=>'Ort:',
	'LBL_STATE'=>'Bundesland:',
	'LBL_POSTAL_CODE'=>'PLZ:',
	'LBL_COUNTRY'=>'Land:',
	'LBL_DESCRIPTION_INFORMATION'=>'Zusatzinformationen',
	'LBL_DESCRIPTION'=>'Beschreibung:',
	'LBL_TERMS_INFORMATION'=>'Konditionen',
	'NTC_COPY_BILLING_ADDRESS'=>'Kopiere Rechnungsadresse zu Lieferadresse',
	'NTC_COPY_SHIPPING_ADDRESS'=>'Kopiere Lieferadresse zu Rechnungsadresse',
	'LBL_DUPLICATE'=>'Eventuell doppelte Organisation angelegt',
	'MSG_DUPLICATE'=>'Das Anlegen dieser Organisation führt möglicherweise zu einer doppelten Eintragung. Sie können entweder mit der Auswahl einer Organisation aus der untenstehenden Liste fortfahren oder einen neue Organisation anlegen.',
	'LBL_INVITEE'=>'Personen',
	'LBL_SELECT_ACCOUNT'=>'Organisation wählen',
	'LBL_GENERAL_INFORMATION'=>'Allgemeine Informationen',
	'LBL_NEW_POTENTIAL'=>'Neues Verkaufspotential',
	'LBL_POTENTIAL_TITLE'=>'Potentials',
	'LBL_NEW_TASK'=>'Neue Aufgabe',
	'LBL_TASK_TITLE'=>'Aufgaben',
	'LBL_NEW_CALL'=>'Neuer Anruf',
	'LBL_CALL_TITLE'=>'Anrufe',
	'LBL_NEW_MEETING'=>'Neues Meeting',
	'LBL_MEETING_TITLE'=>'Meetings',
	'LBL_NEW_EMAIL'=>'Neue E-Mail',
	'LBL_EMAIL_TITLE'=>'E-Mails',
	'LBL_NEW_CONTACT'=>'Neue Person',
	'LBL_CONTACT_TITLE'=>'Personen',
	'LBL_ALL'=>'Alle',
	'LBL_PROSPECT'=>'Potentieller Kunde',
	'LBL_INVESTOR'=>'Investor',
	'LBL_RESELLER'=>'Wiederverkäufer',
	'LBL_PARTNER'=>'Partner',
	'LBL_TOOL_FORM_TITLE'=>'Werkzeuge',
	'Subject'=>'Titel',
	'Quote Name'=>'Angebot',
	'Vendor Name'=>'Anbieter',
	'Invoice Terms'=>'Rechnungsbedingungen',
	'Contact Name'=>'Kontaktname',
	'Invoice Date'=>'Rechnungsdatum',
	'Currency'=>'Währung',
	'Sub Total'=>'Zwischensumme',
	'Due Date'=>'Stichtag',
	'Due date'=>'Stichtag',
	'Carrier'=>'Transporteur',
	'Type'=>'Typ',
	'Sales Tax'=>'Verkaufssteuer',
	'Sales Commission'=>'Provision',
	'Excise Duty'=>'Abgaben',
	'Total'=>'Total',
	'Product Name'=>'Produktname',
	'Assigned To'=>'zuständig',
	'Billing Address'=>'Rechnungsadresse Straße',
	'Shipping Address'=>'Lieferadresse Straße',
	'Billing City'=>'Rechnungsadresse Ort',
	'Billing State'=>'Rechnungsadresse Bundesland',
	'Billing Code'=>'Rechnungsadresse PLZ',
	'Billing Country'=>'Rechnungsadresse Land',
	'Billing Po Box'=>'Rechnungsadresse Postfachnr.',
	'Shipping Po Box'=>'Lieferadresse Postfachnr.',
	'Shipping City'=>'Lieferadresse Ort',
	'Shipping State'=>'Lieferadresse Bundesland',
	'Shipping Code'=>'Lieferadresse PLZ',
	'Shipping Country'=>'Lieferadresse Land',
	'City'=>'Ort',
	'State'=>'Bundesland',
	'Code'=>'Code',
	'Country'=>'Land',
	'Modified Time'=>'geändert',
	'Description'=>'Beschreibung',
	'Potential Name'=>'Verkaufspotential',
	'Customer No'=>'Kundenzeichen',
	'Sales Order'=>'Bestellung',
	'Pending'=>'hängig',
	'Account Name'=>'Organisation',
	'Terms & Conditions'=>'Geschäftsbedingungen',
	'LBL_INVOICE_INFORMATION'=>'Rechnungs Informationen',
	'LBL_INVOICE'=>'Rechnung:',
	'LBL_SO_INFORMATION'=>'Bestellungs Informationen',
	'LBL_SO'=>'Bestellung:',
	'LBL_SUBJECT'=>'Gegenstand:',
	'LBL_SALES_ORDER'=>'Bestellung:',
	'Invoice Id'=>'Rechnungsnummer',
	'LBL_MY_TOP_INVOICE'=>'meine top Rechnungen',
	'LBL_INVOICE_NAME'=>'Rechnung:',
	'Purchase Order'=>'Auftrag:',
	'Status'=>'Status',
	'Id'=>'Rechnungsnummer',
	'Invoice'=>'Rechnungen',
	'Created'=>'erzeugt',
	'Approved'=>'bestätigt',
	'Sent'=>'gesendet',
	'Credit Invoice'=>'Gutschrift',
	'Paid'=>'bezahlt',
	'AutoCreated'=>'automatisch erzeugt',
	'Invoice No'=>'Rechnungsnr.',
	'Adjustment'=>'Anpassung',
	'Tax Type'=>'Steuertyp',
	'Discount Amount'=>'Rabattbetrag',
	'No'=>'Nr.',
	'Date'=>'Datum',
	'Documents'=>'Dokumente',
	'SINGLE_Invoice'=>'Rechnung',
	'Invoice ID'=>'Rechnungs-ID',
	'Notes'=>'Bemerkungen',
	'Project'=>'Projekt',
	'Bulk'=>'Menge',
	'invoice_date'=>'Rechnungsdatum',
	'introduction'=>'Einleitung',
	'mwst'=>'hinzugefügte Mehrwertsteuer',
	'intro_text'=>'Wir werden folgende Artikeln abrechnen, nachdem die Dienstleistungen erbracht sind:',
	'LBL_DUPLICATE_INO_B'=>'Rechnungsnummer duplizieren. Klick',
	'LBL_DUPLICATE_INO_H'=>'HIER',
	'LBL_DUPLICATE_INO_E'=>'Rechnungsnummer Konfigurieren',
	'LBL_DUPLICATE_INO_NO_ADMIN'=>'Rechnungsnummer duplizieren, als Admistrator einloggen und das Rechnungsmodul im Panel konfigurieren.',
	'120 Days'=>'120 Tage',
	'30 Days'=>'30 Tage',
	'60 Days'=>'60 Tage',
	'90 Days'=>'90 Tage',
	'Active Invoice'=>'Aktive Rechnung',
	'Bancomat'=>'Bankautomat',
	'Bank Credit Transfer'=>'Banküberweisung',
	'Bank Draft'=>'Bankeinzug',
	'Cash On Delivery'=>'Barzahlung bei Lieferung',
	'Collection Order'=>'Inkassoauftrag',
	'Credit Card'=>'Kreditkarte',
	'Credit Note'=>'Gutschrift',
	'Direct Debit'=>'Einzugsermächtigung',
	'Document Type'=>'Dokumentenart',
	'Full Payment Of Invoice Date'=>'Direkte Überweisung nach Rechnung',
	'LBL_DATE_INVOICE'=>'Rechnungsdatum',
	'Open Invoices'=>'Offene Rechnungen',
	'Paid Invoices'=>'Gezahlte Rechnungen',
	'Payment Type'=>'Zahlungsart',
	'Paypal	Paypal'=>'Paypal',
	'Service Name'=>'Service Name',
	'List Price'=>'Listenpreis',
	'Quantity'=>'Menge',
	'Comments'=>'Anmerkungen',
	'Net Price'=>'Nettopreis',
	'LBL_MEMBER_ORG_FORM_TITLE'=>'Zugehörige Organisationen',
	'LBL_WEBSITE'=>'Website',
	'NTC_REMOVE_MEMBER_ORG_CONFIRMATION'=>'Sind Sie sicher, dass Sie diesen Datensatz als zugehörige Organisation löschen wollen?',
	'ERR_DELETE_RECORD'=>'Bitte wählen Sie eine Eintragsnummer um den VTE_account zu löschen.',
	'Created Time'=>'Erstellt am',
	'Discount Percent'=>'Diskontprozentsatz',
);
?>