<?php
$mod_strings = array (
  'LBL_MODULE_NAME' => 'Fatura',
  'LBL_SO_MODULE_NAME' => 'Fatura',
  'LBL_RELATED_PRODUCTS' => 'Detalhes do Produto',
  'LBL_MODULE_TITLE' => 'Faturas: Principal',
  'LBL_SEARCH_FORM_TITLE' => 'Fatura: Pesquisar',
  'LBL_LIST_FORM_TITLE' => 'Listar Faturas',
  'LBL_LIST_SO_FORM_TITLE' => 'Listar Pedidos de Venda',
  'LBL_NEW_FORM_TITLE' => 'Nova Fatura',
  'LBL_NEW_FORM_SO_TITLE' => 'Novo Pedido de Venda',
  'LBL_MEMBER_ORG_FORM_TITLE' => 'Organizaes Membros',
  'LBL_LIST_ACCOUNT_NAME' => 'Nome Conta',
  'LBL_LIST_CITY' => 'Cidade',
  'LBL_LIST_WEBSITE' => 'Website',
  'LBL_LIST_STATE' => 'Estado',
  'LBL_LIST_PHONE' => 'Telefone',
  'LBL_LIST_EMAIL_ADDRESS' => 'Endereo Email',
  'LBL_LIST_CONTACT_NAME' => 'Nome Contato',
  'db_name' => 'LBL_LIST_ACCOUNT_NAME',
  'db_website' => 'LBL_LIST_WEBSITE',
  'db_billing_address_city' => 'LBL_LIST_CITY',
  'LBL_ACCOUNT' => 'Conta:',
  'LBL_ACCOUNT_NAME' => 'Nome Conta:',
  'LBL_PHONE' => 'Telefone:',
  'LBL_WEBSITE' => 'Website:',
  'LBL_FAX' => 'Fax:',
  'LBL_TICKER_SYMBOL' => 'Cod. Bolsa:',
  'LBL_OTHER_PHONE' => 'Telefone Alternativo:',
  'LBL_ANY_PHONE' => 'Outro Telefone:',
  'LBL_MEMBER_OF' => 'Membro de:',
  'LBL_EMAIL' => 'Email:',
  'LBL_EMPLOYEES' => 'Empregados:',
  'LBL_OTHER_EMAIL_ADDRESS' => 'Email Alternativo:',
  'LBL_ANY_EMAIL' => 'Outro Email:',
  'LBL_OWNERSHIP' => 'Responsvel',
  'LBL_RATING' => 'Avaliao:',
  'LBL_INDUSTRY' => 'Setor',
  'LBL_SIC_CODE' => 'Cod CNAE:',
  'LBL_TYPE' => 'Tipo',
  'LBL_ANNUAL_REVENUE' => 'Receita Anual:',
  'LBL_ADDRESS_INFORMATION' => 'Informao Endereo:',
  'LBL_Quote_INFORMATION' => 'Informao Conta',
  'LBL_CUSTOM_INFORMATION'=>'Informao Personalizada',
  'LBL_BILLING_ADDRESS' => 'Endereo (Faturamento):',
  'LBL_SHIPPING_ADDRESS' => 'Endereo (Entrega):',
  'LBL_ANY_ADDRESS' => 'Outro Endereo:',
  'LBL_CITY' => 'Cidade',
  'LBL_STATE' => 'Estado:',
  'LBL_POSTAL_CODE' => 'CEP:',
  'LBL_COUNTRY' => 'Pas:',
  'LBL_DESCRIPTION_INFORMATION'=>'Informao Descrio',
  'LBL_DESCRIPTION' => 'Descrio:',
  'LBL_TERMS_INFORMATION' => 'Prazos e Condies',
  'NTC_COPY_BILLING_ADDRESS' => 'Copiar Endereo de Faturamento no Endereo de Entrega',
  'NTC_COPY_SHIPPING_ADDRESS' => 'Copiar Endereo de Entrega no Endereo de Faturamento',
  'NTC_REMOVE_MEMBER_ORG_CONFIRMATION' => 'Tem certeza que deseja remover este registro como um membro da organizao?',
  'LBL_DUPLICATE' => 'Possibilidade Duplicao de Contas',
  'MSG_DUPLICATE' => 'Criando esta Conta pode ser que a mesma seja duplicada. Voc pode selecionar tambm uma Conta da lista abaixo ou clicar sobre Criar Nova Conta para continuar criando uma nova Conta com os dados inseridos anteriormente ',
  'LBL_INVITEE' => 'Contatos',
  'ERR_DELETE_RECORD' => 'Defina um nmero de registro para deletar a Conta',
  'LBL_SELECT_ACCOUNT' => 'Selecionar Conta',
  'LBL_GENERAL_INFORMATION' => 'Informao Geral',
  'LBL_NEW_POTENTIAL' => 'Nova Oportunidade',
  'LBL_POTENTIAL_TITLE' => 'Oportunidade',
  'LBL_NEW_TASK' => 'Nova Tarefa',
  'LBL_TASK_TITLE' => 'Tarefas',
  'LBL_NEW_CALL' => 'Nova Chamada',
  'LBL_CALL_TITLE' => 'Chamadas',
  'LBL_NEW_MEETING' => 'Nova Reunio',
  'LBL_MEETING_TITLE' => 'Reunies',
  'LBL_NEW_EMAIL' => 'Novo Email',
  'LBL_EMAIL_TITLE' => 'Email',
  'LBL_NEW_CONTACT' => 'Novo Contato',
  'LBL_CONTACT_TITLE' => 'Contatos',
  'LBL_ALL' => 'Todos',
  'LBL_PROSPECT' => 'Prospect',
  'LBL_INVESTOR' => 'Investidor',
  'LBL_RESELLER' => 'Revendedor',
  'LBL_PARTNER' => 'Parceiro',
  'LBL_TOOL_FORM_TITLE' => 'Ferramentas Contas',
  'Subject' => 'Assunto',
  'Quote Name' => 'Nome Cotaes',
  'Vendor Name' => 'Nome Fornecedor',
  'Invoice Terms' => 'Condies Fatura',
  'Contact Name' => 'Nome Contato',
  'Invoice Date' => 'Data Fatura',
  'Sub Total' => 'Sub Total',
  'Due Date' => 'Data Vencimento',
  'Carrier' => 'Transportador',
  'Type' => 'Tipo',
  'Sales Tax' => 'ICMS',
  'Sales Commission' => 'Comisso Vendas',
  'Excise Duty' => 'IPI',
  'Total' => 'Total',
  'Product Name' => 'Nome Produto',
  'Assigned To' => 'Atribudo a',
  'Billing Address' => 'Endereo Faturamento',
  'Shipping Address' => 'Endereo Entrega',
  'Billing City' => 'Cidade (Faturamento)',
  'Billing State' => 'Estado (Faturamento)',
  'Billing Code' => 'CEP (Faturamento)',
  'Billing Country' => 'Pas (Faturamento)',
  'Billing Po Box' => 'Cx Postal (Faturamento)',
  'Shipping Po Box' => 'Cx Postal (Entrega)',
  'Shipping City' => 'Cidade  (Entrega)',
  'Shipping State' => 'Estado (Entrega)',
  'Shipping Code' => 'CEP (Entrega)',
  'Shipping Country' => 'Pas (Entrega)',
  'City' => 'Cidade',
  'State' => 'Estado',
  'Code' => 'CEP',
  'Country' => 'Pas',
  'Created Time' => 'Data e Hora de Criao',
  'Modified Time' => 'Data e Hora de Modificao',
  'Description' => 'Descrio',
  'Potential Name' => 'Nome Oportunidade',
  'Customer No' => 'Nmero Cliente',
  'Sales Order' => 'Pedido de Vendas',
  'Notes' => 'Documentos',
  'Pending' => 'Pendente',
  'Account Name' => 'Nome Conta',
  'Terms & Conditions' => 'Prazos e Condies',
  'LBL_INVOICE_INFORMATION' => 'Informao Fatura',
  'LBL_INVOICE' => 'Fatura:',
  'LBL_SO_INFORMATION' => 'Informao Pedido de Vendas:',
  'LBL_SO' => 'Pedido de Vendas:',
  'LBL_SUBJECT' => 'Assunto:',
  'LBL_SALES_ORDER' => 'Pedido de Vendas:',
  'Invoice Id' => 'Nmero Fatura',
  'LBL_MY_TOP_INVOICE' => 'Minhas principais Faturas Abertas',
  'LBL_INVOICE_NAME' => 'Nome Fatura:',
  'Purchase Order' => 'Pedido de Compras',
  'Status' => 'Status',
  'Id' => 'Nmero Fatura',
  'Invoice' => 'Fatura',
  'Created' => 'Criada',
  'Approved' => 'Aprovada',
  'Sent' => 'Enviada',
  'Credit Invoice' => 'Nota de Crdito',
  'Paid' => 'Pagado',
  'Invoice No' => 'Nmero Fatura',
  'Adjustment' => 'Ajuste',
  'Tax Type' => 'Tipo Imposto',
  'Discount Percent' => 'Percentual Desconto',
  'Discount Amount' => 'Total Desconto',
  'No' => 'Nmero',
  'Date' => 'Data',
//------------------crmvillage 504 release start----------------------
  'Open Invoices' => 'Faturas Abertas',
  'Paid Invoices' => 'Faturas Pagas',
  'Bank Credit Transfer'=>'Transferncia Bancria',
  'Bank Draft'=>'Cheque circolar',
  'Collection Order'=>'RIBA',
  'Full Payment Of Invoice Date'=>'Pagamento Fatura  Vista',
  'Credit Card'=>'Carto de Crdito',
  'Paypal'=>'Paypal',
  'Bancomat'=>'Carto de Dbito',
  'Direct Debit'=>'Adebitamento Bancrio Automtico',
  'Cash On Delivery'=>'Pagamento na Entrega',
  '30 Days'=>'30 Dias',
  '60 Days'=>'60 Dias',
  '90 Days'=>'90 Dias',
  '120 Days'=>'120 Dias',
  'Active Invoice'=>'Fatura Ativa',
  'Credit Note'=>'Nota de Crdito',
  'Payment Type'=>'Tipo Pagamento',
  'Due Date'=>'Vencimento Pagamento',
  'Document Type'=>'Tipo Documento',
  'LBL_DATE_INVOICE'=>'Data Fatura',
  'LBL_DUPLICATE_INO_B'=>'Nmero Fatura duplicado, Clique ',
  'LBL_DUPLICATE_INO_H'=>' AQUI ',
  'LBL_DUPLICATE_INO_E'=>'para Configurar o Nmero da Fatura',
  'LBL_DUPLICATE_INO_NO_ADMIN'=>'Nmero Fatura duplicado, entrar como Admministrador e configurar a Numerao do mdulo Cotaes no Menu indicado. ',
//------------------crmvillage 504 release stop-----------------------

//ds@4 generate numbers for quotes and sales
'Project'=>'Projeto',
'Bulk'=>'Massivo',
//ds@e

//ds@12
'invoice_date' => 'Data Fatura',
'introduction' => 'Introduo',
'mwst' => 'Valor de Imposto adicionado',
'intro_text' => ' Seram mudados os seguintes elementos, quando os servios seram reendereados:',
//ds@12e

//crmv@510translation start
'Documents' => 'Documentos',
//crmv@510translation end
'Service Name'=>'Nome Servio',
'List Price'=>'Lista de Preos',
'Quantity'=>'Quantidade',
'Comments'=>'Comentrios',
'Net Price'=>'Preo Lquido',
);
?>