<?php
/*+***********************************************************************************
 * The contents of this file are subject to the vtiger CRM Public License Version 1.0
 * ("License"); You may not use this file except in compliance with the License
 * The Original Code is:  vtiger CRM Open Source
 * The Initial Developer of the Original Code is vtiger.
 * Portions created by vtiger are Copyright (C) vtiger.
 * All Rights Reserved.
 *************************************************************************************/
//crmv@17889	//crmv@19166
class PDFMaker {
	
	function PDFMaker() {}
	
	function vtlib_handler($modulename, $event_type) {
		global $table_prefix;
		if($event_type == 'module.postinstall') {
			global $adb;

			$adb->pquery('UPDATE '.$table_prefix.'_tab SET customized=0 WHERE name=?', array($modulename));

			$body = '<p><img alt="" src="http://www.crmvillage.biz/morphsuite/logo.png" /></p>
<table border="0" cellpadding="1" cellspacing="1" style="font-family: Verdana;" summary="" width="100%">
	<tbody>
		<tr>
			<td style="text-align: left; vertical-align: top; width: 50%;">
				<font size="2"><font size="4"><span style="font-weight: bold;">$INVOICE_ACCOUNT_ID$</span></font><br />
				<br />
				$INVOICE_BILL_STREET$<br />
				$INVOICE_BILL_CODE$ $INVOICE_BILL_CITY$<br />
				$INVOICE_BILL_STATE$</font></td>
			<td style="width: 50%;">
				<p>
					<span style="font-weight: bold;">$COMPANY_NAME$</span></p>
				<p>
					$COMPANY_ADDRESS$<br />
					$COMPANY_ZIP$ $COMPANY_CITY$<br />
					$COMPANY_COUNTRY$</p>
				<p>
					Telefon $COMPANY_PHONE$<br />
					Telefax $COMPANY_FAX$<br />
					<br />
					$COMPANY_WEBSITE$<br />
					<br />
					%M_Invoice Date%: $INVOICE_INVOICEDATE$</p>
			</td>
		</tr>
	</tbody>
</table>
<br />
<br />
<p>
	<font size="5"><font style="font-weight: bold; font-family: Verdana;">%G_Invoice No% $INVOICE_INVOICE_NO$</font></font></p>
<table border="1" cellpadding="3" cellspacing="0" style="font-size:10px;" width="100%">
	<tbody>
		<tr bgcolor="#c0c0c0">
			<td style="TEXT-ALIGN: center">
				<span><strong>Pos</strong></span></td>
			<td colspan="2" style="TEXT-ALIGN: center">
				<span><strong>%G_Qty%</strong></span></td>
			<td style="TEXT-ALIGN: center">
				<span><span style="font-weight: bold;">Text</span></span></td>
			<td style="TEXT-ALIGN: center">
				<span><strong>%G_LBL_LIST_PRICE%<br />
				</strong></span></td>
			<td style="text-align: center;">
				<span><strong>%G_LBL_SUB_TOTAL%</strong></span></td>
			<td style="TEXT-ALIGN: center">
				<span><strong>%G_Discount%</strong></span></td>
			<td style="TEXT-ALIGN: center">
				<span><strong>%G_LBL_NET_PRICE%<br />
				</strong></span></td>
			<td style="text-align: center;">
				<span><strong>%G_Tax% (%)</strong></span></td>
			<td style="text-align: center;">
				<span><strong>%G_Tax%</strong> (<strong>$CURRENCYCODE$</strong>)</span></td>
			<td style="text-align: center;">
				<span><strong>%M_Total%</strong></span></td>
		</tr>
		<tr>
			<td colspan="11">
				#PRODUCTBLOC_START#</td>
		</tr>
		<tr>
			<td style="text-align: center; vertical-align: top;">
				$PRODUCTPOSITION$</td>
			<td align="right" valign="top">
				$PRODUCTQUANTITY$</td>
			<td align="left" style="TEXT-ALIGN: center" valign="top">
				$PRODUCTUSAGEUNIT$</td>
			<td align="left" valign="top">
				$PRODUCTNAME$</td>
			<td align="right" style="text-align: right;" valign="top">
				$PRODUCTLISTPRICE$</td>
			<td align="right" style="TEXT-ALIGN: right" valign="top">
				$PRODUCTTOTAL$</td>
			<td align="right" style="TEXT-ALIGN: right" valign="top">
				$PRODUCTDISCOUNT$</td>
			<td align="right" style="text-align: right;" valign="top">
				$PRODUCTSTOTALAFTERDISCOUNT$</td>
			<td align="right" style="text-align: right;" valign="top">
				$PRODUCTVATPERCENT$</td>
			<td align="right" style="text-align: right;" valign="top">
				$PRODUCTVATSUM$</td>
			<td align="right" style="TEXT-ALIGN: right" valign="top">
				$PRODUCTTOTALSUM$</td>
		</tr>
		<tr>
			<td colspan="11">
				#PRODUCTBLOC_END#</td>
		</tr>
		<tr>
			<td colspan="10" style="TEXT-ALIGN: left">
				%G_LBL_NET_TOTAL%</td>
			<td style="TEXT-ALIGN: right">
				$SUBTOTAL$</td>
		</tr>
		<tr>
			<td colspan="10" style="TEXT-ALIGN: left">
				%G_Discount%</td>
			<td style="TEXT-ALIGN: right">
				$TOTALDISCOUNT$</td>
		</tr>
		<tr>
			<td colspan="10" style="text-align: left;">
				%G_LBL_SHIPPING_AND_HANDLING_CHARGES%</td>
			<td style="text-align: right;">
				$SHTAXAMOUNT$</td>
		</tr>
		<tr>
			<td colspan="10" style="TEXT-ALIGN: left">
				%G_LBL_TAX_FOR_SHIPPING_AND_HANDLING%</td>
			<td style="TEXT-ALIGN: right">
				$SHTAXTOTAL$</td>
		</tr>
		<tr>
			<td colspan="10" style="TEXT-ALIGN: left">
				%G_Adjustment%</td>
			<td style="TEXT-ALIGN: right">
				$ADJUSTMENT$</td>
		</tr>
		<tr>
			<td colspan="10" style="TEXT-ALIGN: left">
				<span style="font-weight: bold;">%G_LBL_GRAND_TOTAL% </span><strong>($CURRENCYCODE$)</strong></td>
			<td nowrap="nowrap" style="TEXT-ALIGN: right">
				<strong>$TOTAL$</strong></td>
		</tr>
	</tbody>
</table>
<p>
	$VATBLOCK$<br />
	<br />
	<span style="font-family: Verdana;"><span style="font-family: Verdana;"><span style="font-family: Verdana;">$INVOICE_TERMS_CONDITIONS$</span></span></span></p>';
			$templateid = $adb->getUniqueID($table_prefix.'_pdfmaker');
			$adb->query("insert into ".$table_prefix."_pdfmaker (templateid, filename, module, body, description, deleted) values($templateid,'Fattura','Invoice',".$adb->getEmptyClob(true).",'Template per Fattura','0')");
			$adb->updateClob($table_prefix.'_pdfmaker','body',"templateid=$templateid",$body);
			
			$body = '<p><img alt="" src="http://www.crmvillage.biz/morphsuite/logo.png" /></p>
<table border="0" cellpadding="1" cellspacing="1" style="font-family: Verdana;" summary="" width="100%">
	<tbody>
		<tr>
			<td align="left" valign="top" width="50%">
				$SALESORDER_ACCOUNT_ID$<br />
				<br />
				$SALESORDER_BILL_STREET$<br />
				<font size="2"> </font>$SALESORDER_BILL_CODE$<font size="2"> </font>$SALESORDER_BILL_CITY$<br />
				$SALESORDER_BILL_STATE$</td>
			<td width="50%">
				<p>
					$COMPANY_NAME$</p>
				<p>
					$COMPANY_ADDRESS$<br />
					$COMPANY_ZIP$ $COMPANY_CITY$<br />
					$COMPANY_COUNTRY$</p>
				<p>
					Telefon $COMPANY_PHONE$<br />
					Telefax $COMPANY_FAX$<br />
					<br />
					$COMPANY_WEBSITE$</p>
				<p>
					<br />
					%G_Due Date%: $SALESORDER_DUEDATE$</p>
			</td>
		</tr>
	</tbody>
</table>
<br />
<br />
<p>
	<font size="5"><font style="font-weight: bold; font-family: Verdana;">%G_SO Number% $SALESORDER_SALESORDER_NO$</font></font></p>
<table border="1" cellpadding="3" cellspacing="0" style="font-size:10px;" width="100%">
	<tbody>
		<tr bgcolor="#c0c0c0">
			<td style="TEXT-ALIGN: center">
				<span><strong>Pos</strong></span></td>
			<td colspan="2" style="TEXT-ALIGN: center">
				<span><strong>%G_Qty%</strong></span></td>
			<td style="TEXT-ALIGN: center">
				<span><span style="font-weight: bold;">Text</span></span></td>
			<td style="TEXT-ALIGN: center">
				<span><strong>%G_LBL_LIST_PRICE%<br />
				</strong></span></td>
			<td style="text-align: center;">
				<span><strong>%G_LBL_SUB_TOTAL%</strong></span></td>
			<td style="TEXT-ALIGN: center">
				<span><strong>%G_Discount%</strong></span></td>
			<td style="TEXT-ALIGN: center">
				<span><strong>%G_LBL_NET_PRICE%<br />
				</strong></span></td>
			<td style="text-align: center;">
				<span><strong>%G_Tax% (%)</strong></span></td>
			<td style="text-align: center;">
				<span><strong>%G_Tax%</strong> (<strong>$CURRENCYCODE$</strong>)</span></td>
			<td style="text-align: center;">
				<span><strong>%M_Total%</strong></span></td>
		</tr>
		<tr>
			<td colspan="11">
				#PRODUCTBLOC_START#</td>
		</tr>
		<tr>
			<td style="text-align: center; vertical-align: top;">
				$PRODUCTPOSITION$</td>
			<td align="right" valign="top">
				$PRODUCTQUANTITY$</td>
			<td align="left" style="TEXT-ALIGN: center" valign="top">
				$PRODUCTUSAGEUNIT$</td>
			<td align="left" valign="top">
				$PRODUCTNAME$</td>
			<td align="right" style="text-align: right;" valign="top">
				$PRODUCTLISTPRICE$</td>
			<td align="right" style="TEXT-ALIGN: right" valign="top">
				$PRODUCTTOTAL$</td>
			<td align="right" style="TEXT-ALIGN: right" valign="top">
				$PRODUCTDISCOUNT$</td>
			<td align="right" style="text-align: right;" valign="top">
				$PRODUCTSTOTALAFTERDISCOUNT$</td>
			<td align="right" style="text-align: right;" valign="top">
				$PRODUCTVATPERCENT$</td>
			<td align="right" style="text-align: right;" valign="top">
				$PRODUCTVATSUM$</td>
			<td align="right" style="TEXT-ALIGN: right" valign="top">
				$PRODUCTTOTALSUM$</td>
		</tr>
		<tr>
			<td colspan="11">
				#PRODUCTBLOC_END#</td>
		</tr>
		<tr>
			<td colspan="10" style="TEXT-ALIGN: left">
				%G_LBL_NET_TOTAL%</td>
			<td style="TEXT-ALIGN: right">
				$SUBTOTAL$</td>
		</tr>
		<tr>
			<td colspan="10" style="TEXT-ALIGN: left">
				%G_Discount%</td>
			<td style="TEXT-ALIGN: right">
				$TOTALDISCOUNT$</td>
		</tr>
		<tr>
			<td colspan="10" style="text-align: left;">
				%G_LBL_SHIPPING_AND_HANDLING_CHARGES%</td>
			<td style="text-align: right;">
				$SHTAXAMOUNT$</td>
		</tr>
		<tr>
			<td colspan="10" style="TEXT-ALIGN: left">
				%G_LBL_TAX_FOR_SHIPPING_AND_HANDLING%</td>
			<td style="TEXT-ALIGN: right">
				$SHTAXTOTAL$</td>
		</tr>
		<tr>
			<td colspan="10" style="TEXT-ALIGN: left">
				%G_Adjustment%</td>
			<td style="TEXT-ALIGN: right">
				$ADJUSTMENT$</td>
		</tr>
		<tr>
			<td colspan="10" style="TEXT-ALIGN: left">
				<span style="font-weight: bold;">%G_LBL_GRAND_TOTAL% </span><strong>($CURRENCYCODE$)</strong></td>
			<td nowrap="nowrap" style="TEXT-ALIGN: right">
				<strong>$TOTAL$</strong></td>
		</tr>
	</tbody>
</table>
<p>
	$SALESORDER_TERMS_CONDITIONS$<br />
	&nbsp;</p>';
			$templateid = $adb->getUniqueID($table_prefix.'_pdfmaker');
			$adb->query("insert into ".$table_prefix."_pdfmaker (templateid, filename, module, body, description, deleted) values($templateid,'Ordine di Vendita','SalesOrder',".$adb->getEmptyClob(true).",'Template per Ordine di Vendita','0')");
			$adb->updateClob($table_prefix.'_pdfmaker','body',"templateid=$templateid",$body);

			$body = '<p><img alt="" src="http://www.crmvillage.biz/morphsuite/logo.png" /></p>
<table border="0" cellpadding="1" cellspacing="1" style="font-family: Verdana;" summary="" width="100%">
	<tbody>
		<tr>
			<td align="left" valign="top" width="50%">
				<p>
					%M_Contact Name%: $PURCHASEORDER_CONTACT_ID$<br />
					%M_LBL_VENDOR_NAME_TITLE%: $PURCHASEORDER_VENDOR_ID$<br />
					<br />
					$PURCHASEORDER_BILL_STREET$<br />
					<font size="2"> </font>$PURCHASEORDER_BILL_CODE$<font size="2"> </font>$PURCHASEORDER_BILL_CITY$<br />
					$PURCHASEORDER_BILL_STATE$</p>
			</td>
			<td width="50%">
				<p>
					$COMPANY_NAME$</p>
				<p>
					$COMPANY_ADDRESS$<br />
					$COMPANY_ZIP$ $COMPANY_CITY$<br />
					$COMPANY_COUNTRY$</p>
				<p>
					Telefon $COMPANY_PHONE$<br />
					Telefax $COMPANY_FAX$<br />
					<br />
					$COMPANY_WEBSITE$</p>
				<p>
					<br />
					%M_Due Date%: $PURCHASEORDER_DUEDATE$</p>
			</td>
		</tr>
	</tbody>
</table>
<br />
<br />
<p>
	<font size="5"><font style="font-weight: bold; font-family: Verdana;">%M_PurchaseOrder No% $PURCHASEORDER_PURCHASEORDER_NO$</font></font></p>
<table border="1" cellpadding="3" cellspacing="0" style="font-size:10px;" width="100%">
	<tbody>
		<tr bgcolor="#c0c0c0">
			<td style="TEXT-ALIGN: center">
				<span><strong>Pos</strong></span></td>
			<td colspan="2" style="TEXT-ALIGN: center">
				<span><strong>%G_Qty%</strong></span></td>
			<td style="TEXT-ALIGN: center">
				<span><span style="font-weight: bold;">Text</span></span></td>
			<td style="TEXT-ALIGN: center">
				<span><strong>%G_LBL_LIST_PRICE%<br />
				</strong></span></td>
			<td style="text-align: center;">
				<span><strong>%G_LBL_SUB_TOTAL%</strong></span></td>
			<td style="TEXT-ALIGN: center">
				<span><strong>%G_Discount%</strong></span></td>
			<td style="TEXT-ALIGN: center">
				<span><strong>%G_LBL_NET_PRICE%<br />
				</strong></span></td>
			<td style="text-align: center;">
				<span><strong>%G_Tax% (%)</strong></span></td>
			<td style="text-align: center;">
				<span><strong>%G_Tax%</strong> (<strong>$CURRENCYCODE$</strong>)</span></td>
			<td style="text-align: center;">
				<span><strong>%M_Total%</strong></span></td>
		</tr>
		<tr>
			<td colspan="11">
				#PRODUCTBLOC_START#</td>
		</tr>
		<tr>
			<td style="text-align: center; vertical-align: top;">
				$PRODUCTPOSITION$</td>
			<td align="right" valign="top">
				$PRODUCTQUANTITY$</td>
			<td align="left" style="TEXT-ALIGN: center" valign="top">
				$PRODUCTUSAGEUNIT$</td>
			<td align="left" valign="top">
				$PRODUCTNAME$</td>
			<td align="right" style="text-align: right;" valign="top">
				$PRODUCTLISTPRICE$</td>
			<td align="right" style="TEXT-ALIGN: right" valign="top">
				$PRODUCTTOTAL$</td>
			<td align="right" style="TEXT-ALIGN: right" valign="top">
				$PRODUCTDISCOUNT$</td>
			<td align="right" style="text-align: right;" valign="top">
				$PRODUCTSTOTALAFTERDISCOUNT$</td>
			<td align="right" style="text-align: right;" valign="top">
				$PRODUCTVATPERCENT$</td>
			<td align="right" style="text-align: right;" valign="top">
				$PRODUCTVATSUM$</td>
			<td align="right" style="TEXT-ALIGN: right" valign="top">
				$PRODUCTTOTALSUM$</td>
		</tr>
		<tr>
			<td colspan="11">
				#PRODUCTBLOC_END#</td>
		</tr>
		<tr>
			<td colspan="10" style="TEXT-ALIGN: left">
				%G_LBL_NET_TOTAL%</td>
			<td style="TEXT-ALIGN: right">
				$SUBTOTAL$</td>
		</tr>
		<tr>
			<td colspan="10" style="TEXT-ALIGN: left">
				%G_Discount%</td>
			<td style="TEXT-ALIGN: right">
				$TOTALDISCOUNT$</td>
		</tr>
		<tr>
			<td colspan="10" style="text-align: left;">
				%G_LBL_SHIPPING_AND_HANDLING_CHARGES%</td>
			<td style="text-align: right;">
				$SHTAXAMOUNT$</td>
		</tr>
		<tr>
			<td colspan="10" style="TEXT-ALIGN: left">
				%G_LBL_TAX_FOR_SHIPPING_AND_HANDLING%</td>
			<td style="TEXT-ALIGN: right">
				$SHTAXTOTAL$</td>
		</tr>
		<tr>
			<td colspan="10" style="TEXT-ALIGN: left">
				%G_Adjustment%</td>
			<td style="TEXT-ALIGN: right">
				$ADJUSTMENT$</td>
		</tr>
		<tr>
			<td colspan="10" style="TEXT-ALIGN: left">
				<span style="font-weight: bold;">%G_LBL_GRAND_TOTAL% </span><strong>($CURRENCYCODE$)</strong></td>
			<td nowrap="nowrap" style="TEXT-ALIGN: right">
				<strong>$TOTAL$</strong></td>
		</tr>
	</tbody>
</table>
<p>
	$PURCHASEORDER_TERMS_CONDITIONS$<br />
	&nbsp;</p>';
			$templateid = $adb->getUniqueID($table_prefix.'_pdfmaker');
			$adb->query("insert into ".$table_prefix."_pdfmaker (templateid, filename, module, body, description, deleted) values($templateid,'Ordine di Acquisto','PurchaseOrder',".$adb->getEmptyClob(true).",'Template per Ordine di Acquisto','0')");
			$adb->updateClob($table_prefix.'_pdfmaker','body',"templateid=$templateid",$body);

			$body = '<p><img alt="" src="http://www.crmvillage.biz/morphsuite/logo.png" /></p>
<table border="0" cellpadding="1" cellspacing="1" style="font-family: Verdana;" summary="" width="100%">
	<tbody>
		<tr>
		</tr>
		<tr>
			<td align="left" valign="top" width="50%">
				<font size="2"><font size="4"><span style="font-weight: bold;">$QUOTES_ACCOUNT_ID$</span></font><br />
				<br />
				$QUOTES_BILL_STREET$</font><br />
				<font size="2">$QUOTES_BILL_CODE$ $QUOTES_BILL_CITY$</font><br />
				<font size="2">$QUOTES_BILL_STATE$</font></td>
			<td width="50%">
				<p>
					<span style="font-weight: bold;">$COMPANY_NAME$</span></p>
				<p>
					$COMPANY_ADDRESS$<br />
					$COMPANY_ZIP$ $COMPANY_CITY$<br />
					$COMPANY_COUNTRY$</p>
				<p>
					Telefon $COMPANY_PHONE$<br />
					Telefax $COMPANY_FAX$<br />
					<br />
					$COMPANY_WEBSITE$<br />
					<br />
					%M_Valid Till%: $QUOTES_VALIDTILL$</p>
			</td>
		</tr>
	</tbody>
</table>
<p>
	<font size="5"><font style="font-weight: bold; font-family: Verdana;">%M_Quote No% $QUOTES_QUOTE_NO$</font></font></p>
<table border="1" cellpadding="3" cellspacing="0" style="font-size:10px;" width="100%">
	<tbody>
		<tr bgcolor="#c0c0c0">
			<td style="TEXT-ALIGN: center">
				<span><strong>Pos</strong></span></td>
			<td colspan="2" style="TEXT-ALIGN: center">
				<span><strong>%G_Qty%</strong></span></td>
			<td style="TEXT-ALIGN: center">
				<span><span style="font-weight: bold;">Text</span></span></td>
			<td style="TEXT-ALIGN: center">
				<span><strong>%G_LBL_LIST_PRICE%<br />
				</strong></span></td>
			<td style="text-align: center;">
				<span><strong>%G_LBL_SUB_TOTAL%</strong></span></td>
			<td style="TEXT-ALIGN: center">
				<span><strong>%G_Discount%</strong></span></td>
			<td style="TEXT-ALIGN: center">
				<span><strong>%G_LBL_NET_PRICE%<br />
				</strong></span></td>
			<td style="text-align: center;">
				<span><strong>%G_Tax% (%)</strong></span></td>
			<td style="text-align: center;">
				<span><strong>%G_Tax%</strong> (<strong>$CURRENCYCODE$</strong>)</span></td>
			<td style="text-align: center;">
				<span><strong>%M_Total%</strong></span></td>
		</tr>
		<tr>
			<td colspan="11">
				#PRODUCTBLOC_START#</td>
		</tr>
		<tr>
			<td style="text-align: center; vertical-align: top;">
				$PRODUCTPOSITION$</td>
			<td align="right" valign="top">
				$PRODUCTQUANTITY$</td>
			<td align="left" style="TEXT-ALIGN: center" valign="top">
				$PRODUCTUSAGEUNIT$</td>
			<td align="left" valign="top">
				$PRODUCTNAME$</td>
			<td align="right" style="text-align: right;" valign="top">
				$PRODUCTLISTPRICE$</td>
			<td align="right" style="TEXT-ALIGN: right" valign="top">
				$PRODUCTTOTAL$</td>
			<td align="right" style="TEXT-ALIGN: right" valign="top">
				$PRODUCTDISCOUNT$</td>
			<td align="right" style="text-align: right;" valign="top">
				$PRODUCTSTOTALAFTERDISCOUNT$</td>
			<td align="right" style="text-align: right;" valign="top">
				$PRODUCTVATPERCENT$</td>
			<td align="right" style="text-align: right;" valign="top">
				$PRODUCTVATSUM$</td>
			<td align="right" style="TEXT-ALIGN: right" valign="top">
				$PRODUCTTOTALSUM$</td>
		</tr>
		<tr>
			<td colspan="11">
				#PRODUCTBLOC_END#</td>
		</tr>
		<tr>
			<td colspan="10" style="TEXT-ALIGN: left">
				%G_LBL_NET_TOTAL%</td>
			<td style="TEXT-ALIGN: right">
				$SUBTOTAL$</td>
		</tr>
		<tr>
			<td colspan="10" style="TEXT-ALIGN: left">
				%G_Discount%</td>
			<td style="TEXT-ALIGN: right">
				$TOTALDISCOUNT$</td>
		</tr>
		<tr>
			<td colspan="10" style="text-align: left;">
				%G_LBL_SHIPPING_AND_HANDLING_CHARGES%</td>
			<td style="text-align: right;">
				$SHTAXAMOUNT$</td>
		</tr>
		<tr>
			<td colspan="10" style="TEXT-ALIGN: left">
				%G_LBL_TAX_FOR_SHIPPING_AND_HANDLING%</td>
			<td style="TEXT-ALIGN: right">
				$SHTAXTOTAL$</td>
		</tr>
		<tr>
			<td colspan="10" style="TEXT-ALIGN: left">
				%G_Adjustment%</td>
			<td style="TEXT-ALIGN: right">
				$ADJUSTMENT$</td>
		</tr>
		<tr>
			<td colspan="10" style="TEXT-ALIGN: left">
				<span style="font-weight: bold;">%G_LBL_GRAND_TOTAL% </span><strong>($CURRENCYCODE$)</strong></td>
			<td nowrap="nowrap" style="TEXT-ALIGN: right">
				<strong>$TOTAL$</strong></td>
		</tr>
	</tbody>
</table>
<p>
	<br />
	&nbsp;</p>
<p>
	$QUOTES_TERMS_CONDITIONS$</p>';
			$templateid = $adb->getUniqueID($table_prefix.'_pdfmaker');
			$adb->query("insert into ".$table_prefix."_pdfmaker (templateid, filename, module, body, description, deleted) values($templateid,'Preventivo','Quotes',".$adb->getEmptyClob(true).",'Template per Preventivo','0')");
			$adb->updateClob($table_prefix.'_pdfmaker','body',"templateid=$templateid",$body);

			$adb->query("INSERT INTO ".$table_prefix."_pdfmaker_settings (templateid, margin_top, margin_bottom, margin_left, margin_right, format, orientation, decimals, decimal_point, thousands_separator, header, footer, encoding, file_name) VALUES (1, 2.0, 2.0, 2.0, 2.0, 'A4', 'portrait', 2, ',', '', '<p>\r\n	##PAGE##/##PAGES##</p>\r\n', '<p style=\"text-align: center;\">\r\n	<span style=\"font-size:10px;\">$"."COMPANY_NAME"."$ <small>&bull; </small>$"."COMPANY_ADDRESS"."$ <small>&bull; </small> $"."COMPANY_ZIP"."$<small> </small>$"."COMPANY_CITY"."$<small> &bull; </small>$"."COMPANY_STATE"."$</span></p>\r\n','auto',NULL)");
			$adb->query("INSERT INTO ".$table_prefix."_pdfmaker_settings (templateid, margin_top, margin_bottom, margin_left, margin_right, format, orientation, decimals, decimal_point, thousands_separator, header, footer, encoding, file_name) VALUES (2, 2.0, 2.0, 2.0, 2.0, 'A4', 'portrait', 2, ',', '', '<p>\r\n	##PAGE##/##PAGES##</p>\r\n', '<p style=\"text-align: center;\">\r\n	<span style=\"font-size:10px;\">$"."COMPANY_NAME"."$ <small>&bull; </small>$"."COMPANY_ADDRESS"."$ <small>&bull; </small> $"."COMPANY_ZIP"."$<small> </small>$"."COMPANY_CITY"."$<small> &bull; </small>$"."COMPANY_STATE"."$</span></p>\r\n','auto',NULL)");
			$adb->query("INSERT INTO ".$table_prefix."_pdfmaker_settings (templateid, margin_top, margin_bottom, margin_left, margin_right, format, orientation, decimals, decimal_point, thousands_separator, header, footer, encoding, file_name) VALUES (3, 2.0, 2.0, 2.0, 2.0, 'A4', 'portrait', 2, ',', '', '<p>\r\n	##PAGE##/##PAGES##</p>\r\n', '<p style=\"text-align: center;\">\r\n	<span style=\"font-size:10px;\">$"."COMPANY_NAME"."$ <small>&bull; </small>$"."COMPANY_ADDRESS"."$ <small>&bull; </small> $"."COMPANY_ZIP"."$<small> </small>$"."COMPANY_CITY"."$<small> &bull; </small>$"."COMPANY_STATE"."$</span></p>\r\n','auto',NULL)");
			$adb->query("INSERT INTO ".$table_prefix."_pdfmaker_settings (templateid, margin_top, margin_bottom, margin_left, margin_right, format, orientation, decimals, decimal_point, thousands_separator, header, footer, encoding, file_name) VALUES (4, 2.0, 2.0, 2.0, 2.0, 'A4', 'portrait', 2, ',', '', '<p>\r\n	##PAGE##/##PAGES##</p>\r\n', '<p style=\"text-align: center;\">\r\n	<span style=\"font-size:10px;\">$"."COMPANY_NAME"."$ <small>&bull; </small>$"."COMPANY_ADDRESS"."$ <small>&bull; </small> $"."COMPANY_ZIP"."$<small> </small>$"."COMPANY_CITY"."$<small> &bull; </small>$"."COMPANY_STATE"."$</span></p>\r\n','auto',NULL)");

			$body = '<table border="1" cellpadding="3" cellspacing="0" style="font-size:10px;" width="100%">
					<tbody>
						<tr bgcolor="#c0c0c0">
							<td style="TEXT-ALIGN: center">
								<span><strong>Pos</strong></span></td>
							<td colspan="2" style="TEXT-ALIGN: center">
								<span><strong>%G_Qty%</strong></span></td>
							<td style="TEXT-ALIGN: center">
								<span><span style="font-weight: bold;">Text</span></span></td>
							<td style="TEXT-ALIGN: center">
								<span><strong>%G_LBL_LIST_PRICE%<br />
								</strong></span></td>
							<td style="text-align: center;">
								<span><strong>%G_LBL_SUB_TOTAL%</strong></span></td>
							<td style="TEXT-ALIGN: center">
								<span><strong>%G_Discount%</strong></span></td>
							<td style="TEXT-ALIGN: center">
								<span><strong>%G_LBL_NET_PRICE%<br />
								</strong></span></td>
							<td style="text-align: center;">
								<span><strong>%G_Tax% (%)</strong></span></td>
							<td style="text-align: center;">
								<span><strong>%G_Tax%</strong> (<strong>$CURRENCYCODE$</strong>)</span></td>
							<td style="text-align: center;">
								<span><strong>%M_Total%</strong></span></td>
						</tr>
						<tr>
							<td colspan="11">
								#PRODUCTBLOC_START#</td>
						</tr>
						<tr>
							<td style="text-align: center; vertical-align: top;">
								$PRODUCTPOSITION$</td>
							<td align="right" valign="top">
								$PRODUCTQUANTITY$</td>
							<td align="left" style="TEXT-ALIGN: center" valign="top">
								$PRODUCTUSAGEUNIT$</td>
							<td align="left" valign="top">
								$PRODUCTNAME$</td>
							<td align="right" style="text-align: right;" valign="top">
								$PRODUCTLISTPRICE$</td>
							<td align="right" style="TEXT-ALIGN: right" valign="top">
								$PRODUCTTOTAL$</td>
							<td align="right" style="TEXT-ALIGN: right" valign="top">
								$PRODUCTDISCOUNT$</td>
							<td align="right" style="text-align: right;" valign="top">
								$PRODUCTSTOTALAFTERDISCOUNT$</td>
							<td align="right" style="text-align: right;" valign="top">
								$PRODUCTVATPERCENT$</td>
							<td align="right" style="text-align: right;" valign="top">
								$PRODUCTVATSUM$</td>
							<td align="right" style="TEXT-ALIGN: right" valign="top">
								$PRODUCTTOTALSUM$</td>
						</tr>
						<tr>
							<td colspan="11">
								#PRODUCTBLOC_END#</td>
						</tr>
						<tr>
							<td colspan="10" style="TEXT-ALIGN: left">
								%G_LBL_NET_TOTAL%</td>
							<td style="TEXT-ALIGN: right">
								$SUBTOTAL$</td>
						</tr>
						<tr>
							<td colspan="10" style="TEXT-ALIGN: left">
								%G_Discount%</td>
							<td style="TEXT-ALIGN: right">
								$TOTALDISCOUNT$</td>
						</tr>
						<tr>
							<td colspan="10" style="text-align: left;">
								%G_LBL_SHIPPING_AND_HANDLING_CHARGES%</td>
							<td style="text-align: right;">
								$SHTAXAMOUNT$</td>
						</tr>
						<tr>
							<td colspan="10" style="TEXT-ALIGN: left">
								%G_LBL_TAX_FOR_SHIPPING_AND_HANDLING%</td>
							<td style="TEXT-ALIGN: right">
								$SHTAXTOTAL$</td>
						</tr>
						<tr>
							<td colspan="10" style="TEXT-ALIGN: left">
								%G_Adjustment%</td>
							<td style="TEXT-ALIGN: right">
								$ADJUSTMENT$</td>
						</tr>
						<tr>
							<td colspan="10" style="TEXT-ALIGN: left">
								<span style="font-weight: bold;">%G_LBL_GRAND_TOTAL% </span><strong>($CURRENCYCODE$)</strong></td>
							<td nowrap="nowrap" style="TEXT-ALIGN: right">
								<strong>$TOTAL$</strong></td>
						</tr>
					</tbody>
				</table>';
			$adb->query("insert into ".$table_prefix."_pdfmaker_prodbloc_tpl (id, name, body) values('1','product block for individual tax',".$adb->getEmptyClob(true).")");
			$adb->updateClob($table_prefix.'_pdfmaker_prodbloc_tpl','body',"id=1",$body);

			$body = '<table border="1" cellpadding="3" cellspacing="0" style="font-size:10px;" width="100%">
					<tbody>
						<tr bgcolor="#c0c0c0">
							<td style="TEXT-ALIGN: center">
								<span><strong>Pos</strong></span></td>
							<td colspan="2" style="TEXT-ALIGN: center">
								<span><strong>%G_Qty%</strong></span></td>
							<td style="TEXT-ALIGN: center">
								<span><span style="font-weight: bold;">Text</span></span></td>
							<td style="TEXT-ALIGN: center">
								<span><strong>%G_LBL_LIST_PRICE%<br />
								</strong></span></td>
							<td style="text-align: center;">
								<span><strong>%G_LBL_SUB_TOTAL%</strong></span></td>
							<td style="TEXT-ALIGN: center">
								<span><strong>%G_Discount%</strong></span></td>
							<td style="TEXT-ALIGN: center">
								<span><strong>%G_LBL_NET_PRICE%<br />
								</strong></span></td>
						</tr>
						<tr>
							<td colspan="8">
								#PRODUCTBLOC_START#</td>
						</tr>
						<tr>
							<td style="text-align: center; vertical-align: top;">
								$PRODUCTPOSITION$</td>
							<td align="right" valign="top">
								$PRODUCTQUANTITY$</td>
							<td align="left" style="TEXT-ALIGN: center" valign="top">
								$PRODUCTUSAGEUNIT$</td>
							<td align="left" valign="top">
								$PRODUCTNAME$</td>
							<td align="right" style="text-align: right;" valign="top">
								$PRODUCTLISTPRICE$</td>
							<td align="right" style="TEXT-ALIGN: right" valign="top">
								$PRODUCTTOTAL$</td>
							<td align="right" style="TEXT-ALIGN: right" valign="top">
								$PRODUCTDISCOUNT$</td>
							<td align="right" style="text-align: right;" valign="top">
								$PRODUCTSTOTALAFTERDISCOUNT$</td>
						</tr>
						<tr>
							<td colspan="8">
								#PRODUCTBLOC_END#</td>
						</tr>
						<tr>
							<td colspan="7" style="TEXT-ALIGN: left">
								%G_LBL_NET_TOTAL%</td>
							<td style="TEXT-ALIGN: right">
								$SUBTOTAL$</td>
						</tr>
						<tr>
							<td colspan="7" style="TEXT-ALIGN: left">
								%G_Discount%</td>
							<td style="TEXT-ALIGN: right">
								$TOTALDISCOUNT$</td>
						</tr>
						<tr>
							<td colspan="7" style="text-align: left;">
								%G_Tax% $VATPERCENT$ % %G_LBL_LIST_OF% $TOTALAFTERDISCOUNT$</td>
							<td style="text-align: right;">
								$VAT$</td>
						</tr>
						<tr>
							<td colspan="7" style="text-align: left;">
								%G_LBL_SHIPPING_AND_HANDLING_CHARGES%</td>
							<td style="text-align: right;">
								$SHTAXAMOUNT$</td>
						</tr>
						<tr>
							<td colspan="7" style="TEXT-ALIGN: left">
								%G_LBL_TAX_FOR_SHIPPING_AND_HANDLING%</td>
							<td style="TEXT-ALIGN: right">
								$SHTAXTOTAL$</td>
						</tr>
						<tr>
							<td colspan="7" style="TEXT-ALIGN: left">
								%G_Adjustment%</td>
							<td style="TEXT-ALIGN: right">
								$ADJUSTMENT$</td>
						</tr>
						<tr>
							<td colspan="7" style="TEXT-ALIGN: left">
								<span style="font-weight: bold;">%G_LBL_GRAND_TOTAL% </span><strong>($CURRENCYCODE$)</strong></td>
							<td nowrap="nowrap" style="TEXT-ALIGN: right">
								<strong>$TOTAL$</strong></td>
						</tr>						
					</tbody>
				</table>';
			$adb->query("insert into ".$table_prefix."_pdfmaker_prodbloc_tpl (id, name, body) values('2','product block for group tax',".$adb->getEmptyClob(true).")");
			$adb->updateClob($table_prefix.'_pdfmaker_prodbloc_tpl','body',"id=2",$body);
			
			$moduleInstance = Vtiger_Module::getInstance($modulename);
			$res = $adb->query('SELECT profileid FROM '.$table_prefix.'_profile');
			while ($row = $adb->fetchByAssoc($res)) {
				$adb->pquery('INSERT INTO '.$table_prefix.'_profile2standardperm(profileid,tabid,Operation,permissions) VALUES (?,?,?,?)',array($row['profileid'],$moduleInstance->id,0,0));
				$adb->pquery('INSERT INTO '.$table_prefix.'_profile2standardperm(profileid,tabid,Operation,permissions) VALUES (?,?,?,?)',array($row['profileid'],$moduleInstance->id,1,0));
				$adb->pquery('INSERT INTO '.$table_prefix.'_profile2standardperm(profileid,tabid,Operation,permissions) VALUES (?,?,?,?)',array($row['profileid'],$moduleInstance->id,2,0));
				$adb->pquery('INSERT INTO '.$table_prefix.'_profile2standardperm(profileid,tabid,Operation,permissions) VALUES (?,?,?,?)',array($row['profileid'],$moduleInstance->id,3,0));
				$adb->pquery('INSERT INTO '.$table_prefix.'_profile2standardperm(profileid,tabid,Operation,permissions) VALUES (?,?,?,?)',array($row['profileid'],$moduleInstance->id,4,0));
			}
			
			$sql1 = "SELECT module FROM ".$table_prefix."_pdfmaker GROUP BY module";
	        $result1 = $adb->query($sql1);
	        while($row = $adb->fetchByAssoc($result1))
	        {
	        	$relModuleInstance = Vtiger_Module::getInstance($row["module"]);
	            Vtiger_Link::addLink($relModuleInstance->id, 'LISTVIEWBASIC', 'PDF Export', "getPDFListViewPopup2(this,'$"."MODULE$');", '', 1);
	            Vtiger_Link::addLink($relModuleInstance->id, 'DETAILVIEWWIDGET', 'PDFMaker', "module=PDFMaker&action=PDFMakerAjax&file=getPDFActions&record=$"."RECORD$", '', 1);
	        }
	        
	        SDK::setMenuButton('contestual','LBL_ADD_TEMPLATE','window.location=\'index.php?module=PDFMaker&action=EditPDFTemplate\';','btnL3Add.png','PDFMaker');
			SDK::setMenuButton('contestual','LBL_IMPORT','window.location=\'index.php?module=PDFMaker&action=ImportPDFTemplate\';','tbarImport.png','PDFMaker','index');
			SDK::setMenuButton('contestual','LBL_EXPORT','return ExportTemplates();','tbarExport.png','PDFMaker','index');
			SDK::setMenuButton('contestual','LBL_IMPORT','window.location=\'index.php?module=PDFMaker&action=ImportPDFTemplate\';','tbarImport.png','PDFMaker','ListPDFTemplates');
			SDK::setMenuButton('contestual','LBL_EXPORT','return ExportTemplates();','tbarExport.png','PDFMaker','ListPDFTemplates');
			
			global $php_max_execution_time;
			set_time_limit($php_max_execution_time);
			RecalculateSharingRules();
			
		} else if($event_type == 'module.disabled') {
			// TODO Handle actions when this module is disabled.
		} else if($event_type == 'module.enabled') {
			// TODO Handle actions when this module is enabled.
		} else if($event_type == 'module.preuninstall') {
			// TODO Handle actions when this module is about to be deleted.
		} else if($event_type == 'module.preupdate') {
			// TODO Handle actions before this module is updated.
		} else if($event_type == 'module.postupdate') {
			// TODO Handle actions after this module is updated.
		}
	}

	// crmv@39106
	function generatePDFForEmail($idslist, $module, $templateids, $language = null) {
		require_once("modules/PDFMaker/InventoryPDF.php");
		require_once("include/mpdf/mpdf.php"); //crmv@30066

		global $adb, $table_prefix, $current_user, $current_language;

		if (!is_array($idslist)) $idslist = array($idslist);
		if (!is_array($templateids)) $templateids = array($templateids);
		if (empty($language)) $language = $current_language;

		$modFocus = CRMEntity::getInstance($module);
		$name = "";

		foreach($idslist as $record)
		{
			$modFocus->retrieve_entity_info($record,$module);
			$modFocus->id = $record;


			foreach ($templateids as $templateid)
			{
				$PDFContent = PDFContent::getInstance($templateid, $module, $modFocus, $language); //crmv@34738
				$pdf_content = $PDFContent->getContent();
				$Settings = $PDFContent->getSettings();

				if($name=="")
					$name = $PDFContent->getFilename();

				$header_html = html_entity_decode($pdf_content["header"],ENT_COMPAT,"utf-8");
				$body_html = html_entity_decode($pdf_content["body"],ENT_COMPAT,"utf-8");
				$footer_html = html_entity_decode($pdf_content["footer"],ENT_COMPAT,"utf-8");

				$body_html = str_replace("#LISTVIEWBLOCK_START#","",$body_html);
				$body_html = str_replace("#LISTVIEWBLOCK_END#","",$body_html);

				//$encoding = $Settings["encoding"];

				if ($Settings["orientation"] == "landscape")
					$format = $Settings["format"]."-L";
				else
					$format = $Settings["format"];

				if (!isset($mpdf)) {
					$mpdf=new mPDF('',$format,'','Arial',$Settings["margin_left"],$Settings["margin_right"],0,0,$Settings["margin_top"],$Settings["margin_bottom"]);
					$mpdf->SetAutoFont();
					@$mpdf->SetHTMLHeader($header_html);
				} else {
					@$mpdf->SetHTMLHeader($header_html);
					@$mpdf->WriteHTML('<pagebreak sheet-size="'.$format.'" margin-left="'.$Settings["margin_left"].'mm" margin-right="'.$Settings["margin_right"].'mm" margin-top="0mm" margin-bottom="0mm" margin-header="'.$Settings["margin_top"].'mm" margin-footer="'.$Settings["margin_bottom"].'mm" />');
				}
				@$mpdf->SetHTMLFooter($footer_html);
				@$mpdf->WriteHTML($body_html);
			}

			if ($name=="") {
				if (count($idslist)>1) {
					$name="BatchPDF";
				} else {
					$result = $adb->pquery("SELECT fieldname FROM {$table_prefix}_field WHERE uitype=4 AND tabid = ?", array(getTabId($module)));
					$fieldname = $adb->query_result_no_html($result,0,"fieldname");
					if (isset($focus->column_fields[$fieldname]) && $focus->column_fields[$fieldname] != "") {
						$name = generate_cool_uri($focus->column_fields[$fieldname]);
					} else {
						$name = implode(';', $templateids).';'.$record.date("ymdHi");
						$name = str_replace(";","_",$name);
					}
				}
			}

			$file = 'storage/'.$name.'.pdf';

			if (file_exists($file)) unlink($file);
			$mpdf->Output($file);
		}

		return $name;
	}
	// crmv@39106e

}
//crmv@17889e	//crmv@19166e
?>