<?php
/*+**********************************************************************************
 * The contents of this file are subject to the vtiger CRM Public License Version 1.0
 * ("License"); You may not use this file except in compliance with the License
 * The Original Code is:  vtiger CRM Open Source
 * The Initial Developer of the Original Code is vtiger.
 * Portions created by vtiger are Copyright (C) vtiger.
 * All Rights Reserved.
 ************************************************************************************/
global $current_user, $currentModule,$adb,$log;
global $table_prefix;
checkFileAccess("modules/$currentModule/$currentModule.php");
require_once("modules/$currentModule/$currentModule.php");

$focus = new $currentModule();
setObjectValuesFromRequest($focus);

// TODO: validate time format
// First we fix the time input as we can accept "#h #m" format
$wt = $_REQUEST['worktime'];
if (stripos($wt,'h') > 0) {
    $hr = substr($wt,0,stripos($wt,'h'));
    $rt = substr($wt,stripos($wt,'h')+1);
    if (stripos($rt,'m') > 0) {
        $min = intval(substr($rt,0,stripos($rt,'m')));
        if ($min > 59) {
            $hr  = $hr + intval($min / 60);
            $min = $min % 60;
            $wt  = $hr.':'.$min;
        } else {
            $wt = $hr.':'.$min;
        }
    } else {
        $wt = $hr.':00';
    }
}
if (stripos($wt,'m') > 0) {
    $min = intval(substr($wt,0,stripos($wt,'m')));
    if ($min > 59) {
        $hr  = intval($min / 60);
        $min = $min % 60;
        $wt  = $hr.':'.$min;
    } else {
        $wt = '0:'.$min;
    }
}
// From here on we have correct time format in variable $wt
$focus->column_fields['worktime']=$wt;

$mode = $_REQUEST['mode'];
$record=$_REQUEST['record'];
if($mode) $focus->mode = $mode;
if($record)$focus->id  = $record;

if($_REQUEST['assigntype'] == 'U') {
	$focus->column_fields['assigned_user_id'] = $_REQUEST['assigned_user_id'];
} elseif($_REQUEST['assigntype'] == 'T') {
	$focus->column_fields['assigned_user_id'] = $_REQUEST['assigned_group_id'];
}

$focus->save($currentModule);
$return_id = $focus->id;

// 'ticketstatus'!='Maintain' Change troubleticket status and add to update info
// $_REQUEST['reports_to_name'] Change troubleticket responsable and add to update info
if ($_REQUEST['ticketstatus']!='Maintain' || (isset($_REQUEST['reports_to_id']) && !in_array($_REQUEST['reports_to_id'],array('',0)))) {
    // Get all the orignal values
    $fHD = new HelpDesk();
    $fHD->id = $focus->column_fields['ticket_id'];
    $fHD->retrieve_entity_info_no_html($focus->column_fields['ticket_id'],"HelpDesk");
    $fHD->name=$fHD->column_fields['ticket_title'];
    $fHD->mode = 'edit';
    
    // Change those that we have been told to change     
    if ($_REQUEST['ticketstatus']!='Maintain') $fHD->column_fields['ticketstatus'] = $_REQUEST['ticketstatus'];
//    if (!empty($_REQUEST['reports_to_name'])) {
    if (isset($_REQUEST['reports_to_id']) && !in_array($_REQUEST['reports_to_id'],array('',0))) {
	    $fHD->column_fields['assigned_user_id'] = $_REQUEST['reports_to_id'];
	    $fHD->column_fields['assigntype']='U';
    }
    
    // Empty Comments
    $_REQUEST['comments']='';
    $fHD->column_fields['comments'] = '';
    
    //Added to construct the update log for Ticket history
    $fldvalue = $fHD->constructUpdateLog(&$fHD, $fHD->mode, '', 'U');
    $fldvalue = from_html($adb->formatString($table_prefix.'_troubletickets','update_log',$fldvalue),true);
    
    // Save changes
    $fHD->save("HelpDesk");
    
    //update the log information for ticket history
    $adb->query("update ".$table_prefix."_troubletickets set update_log=$fldvalue where ticketid=".$fHD->id);
}  // End Change TroubleTicket

$search = vtlib_purify($_REQUEST['search_url']);

$parenttab = getParentTab();
if($_REQUEST['return_module'] != '') {
	$return_module = vtlib_purify($_REQUEST['return_module']);
} else {
	$return_module = $currentModule;
}

if($_REQUEST['return_id'] != '') {
	$return_id = vtlib_purify($_REQUEST['return_id']);
}

if($_REQUEST['return_action'] != 'DetailView' and $_REQUEST['return_action'] != '') {
	$return_action = vtlib_purify($_REQUEST['return_action']);
} elseif (isset($_REQUEST['newtc'])) {
	$return_id = '';
	$ticketid='&ticket_id='.$focus->column_fields['ticket_id'];
    $return_action = "EditView";  // Create new TC
} else {
	$return_action = "DetailView";
}

header("Location: index.php?action=$return_action&module=$return_module&record=$return_id$ticketid&parenttab=$parenttab&start=".vtlib_purify($_REQUEST['pagenumber']).$search);

?>