<?php
/* crmv@31780 */
/* crmv@33097 */
require_once('data/Tracker.php');

global $login, $userId, $current_user;

$module = $_REQUEST['module'];

if (!$login || !$userId) {
	echo 'Login Failed';
} elseif (in_array($module, $touchInst->excluded_modules)) {
	echo "Module not permitted";
} else {

	$current_user = new Users();
	$current_user->id = $userId;

	$tracker = new Tracker();
	$rec = $tracker->get_recently_viewed($userId, $module);
	$rec2 = array();

	// filtro per tenere solo l'essenziale
	foreach ($rec as $row) {
		if (in_array($row['module_name'], $touchInst->excluded_modules)) continue; // crmv@33311
		// crmv@37370 fox for calendar events (events should not be retrieved)
		if ($row['module_name'] == 'Calendar') {
			$activitytype = getActivityType($row['item_id']);
			if ($activitytype != 'Task') continue;
		}
		// crmv@37370e
		$row2 = array(
			'crmid'=>$row['item_id'],
			'module'=>$row['module_name'],
			'tabid'=>getTabId($row['module_name']),
			'entityname'=>html_entity_decode($row['item_summary'], ENT_QUOTES, 'UTF-8'),
			'recent' => 1
		);
		$rec2[] = $row2;
	}

	echo Zend_Json::encode($rec2);
}
?>