<?php
/* crmv@31780 - fix vari */
/* crmv@33097 */
global $login, $userId, $current_user, $currentModule;

$module = $_REQUEST['module'];
$recordid = intval($_REQUEST['record']);
$prodblock = intval($_REQUEST['forproductblock']);
$updaterecent = intval($_REQUEST['set_recent']);

if (!$login || empty($userId)) {
	echo 'Login Failed';
} elseif (in_array($module, $touchInst->excluded_modules)) {
	echo "Module not permitted";
} else {

	// lettura record esistente
	if ($recordid > 0) {
		$record = touchGetRecord($module, $recordid, $prodblock);

		// aggiorno i recenti
		if ($updaterecent) {
			require_once('data/Tracker.php');

			$focus = CRMEntity::getInstance($module);
			$focus->track_view($current_user->id, $module, $recordid);
		}

	// creazione nuovo record
	// carico i campi precompilati (per related e personalizzazioni varie)
	// funziona parzialmente, solo i campi visibili vengono considerati
	} else {
		$currentModule = $module;

		if (!empty($_REQUEST['APP_DATA'])) {
			$appdata = Zend_Json::decode($_REQUEST['APP_DATA']);

			$parentid = intval($appdata['parent_id']);
			$parentmod = $appdata['parent_module'];

			if (!empty($parentid) && !empty($parentmod)) {

				// trovo il campo di collegamento e lo imposto
				$response = wsRequest($current_user->id, 'describe', array('elementType'=>$module));
				$fields = $response['result']['fields'];
				if (is_array($fields)) {
					foreach ($fields as $field) {
						$type = $field['type']['name'];
						if ($type == 'reference') {
							if (in_array($parentmod, $field['type']['refersTo'])) {
								$fieldname = $field['name'];
								// metto nella request
								$_REQUEST[$fieldname] = $parentid;
							}
						}
					}
				}

				// altri campi parent
				$_REQUEST['return_id'] = $parentid;
				$_REQUEST['parent_id'] = $parentid;
				$_REQUEST['RLparent_id'] = $parentid;
				$_REQUEST['return_module'] = $parentmod;
				$_REQUEST['RLreturn_module'] = $parentmod;
			}
			unset($_REQUEST['APP_DATA']);
		}

		unset($_REQUEST['password'], $_REQUEST['username']);

		// simulo una editview in creazione
		$_REQUEST['record'] = '';
		$_REQUEST['module'] = $module;
		$_REQUEST['mode'] = '';
		$_REQUEST['action'] = 'EditView';

		try {
			ob_start();
			include("modules/$module/EditView.php");
			$html = ob_get_clean();
			ob_end_clean();
		} catch (Exception $e) {
			$html = '';
		}

		// recupero i campi (INPUT)
		// TODO: fare anche picklist e textarea
		$lastp = -1;
		$record = array();
		while (($lastp = stripos($html, '<input ', $lastp+1)) !== false) {
			$endp = stripos($html, '>', $lastp+1);
			if ($endp !== false) {
				$input = substr($html, $lastp, $endp-$lastp+1);
				$fieldname = '';
				$fieldvalue = '';
				if (preg_match('/name=["\']([^"\']+)["\']/', $input, $matches)) {
					$fieldname = $matches[1];
				}
				if (preg_match('/value=["\']([^"\']+)["\']/', $input, $matches)) {
					$fieldvalue = $matches[1];
				}
				if (!empty($fieldname) && !empty($fieldvalue)) {
					$record[$fieldname] = $touchInst->field2Touch($module, $fieldname, $fieldvalue);
				}
			} else {
				break;
			}
		}

		// recupero i campi (TEXTAREA)
		$lastp = -1;
		while (($lastp = stripos($html, '<textarea ', $lastp+1)) !== false) {
			$endp = stripos($html, '>', $lastp+1);
			if ($endp !== false) {
				$input = substr($html, $lastp, $endp-$lastp+1);
				$fieldname = '';
				$fieldvalue = '';
				if (preg_match('/ name=["\']([^"\']+)["\']/', $input, $matches)) {
					$fieldname = $matches[1];
				}

				// trovo il contenuto
				$endp2 = stripos($html, '</textarea>', $endp+1);
				if ($endp2 !== false) {
					$fieldvalue = substr($html, $endp+1, $endp2-$endp-1);
					if (!empty($fieldname) && !empty($fieldvalue)) {
						$record[$fieldname] = $touchInst->field2Touch($module, $fieldname, $fieldvalue);
					}
					$lastp = $endp2 + 5;
				}
			} else {
				break;
			}
		}


		/*
		// questa strada, sebbene elegante, non è praticabile, le pagine sono piene di errori html
		if (class_exists('DOMDocument')) {
			$pageDom = new DOMDocument();
			$pageDom->recover = true;
			$pageDom->strictErrorChecking = false;
			$pageDom->loadHTML($html);
			$xpath = new DOMXpath($pageDom);

			// find inputs
			$nodelist = $xpath->query("//input");
			if ($nodelist->length > 0) {
				$input = $nodelist->item(0);
				$name = $input->nodeName;
				$value = $input->attributes->getNamedItem('value')->value;
				$record[$name] = $value;
			}
		}
		*/
	}

	echo Zend_Json::encode($record);
}
?>