<?php
/*
 * file principale per webservice Touch
 */

header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: X-Requested-With");


if (!isset($root_directory)) {
	require_once('../../config.inc.php');
	chdir($root_directory);
}

if (get_magic_quotes_gpc() == 1) {
	function stripslashes_gpc($value) {
		if (is_string($value)) {
			return stripslashes($value);
		}
		return $value;
	}
	$_REQUEST = array_map("stripslashes_gpc", $_REQUEST);
	$_POST = array_map("stripslashes_gpc", $_POST);
	$_GET = array_map("stripslashes_gpc", $_GET);
}


global $current_user;

require_once('modules/Touch/Touch.php');
require_once('modules/Touch/vtws/api/webservice.php');

// crmv@33311
// imposto parametri di risposta

// crmv@33311e


$wsname = $_REQUEST['wsname']; // l'azione da compiere

$touchInst = Touch::getInstance();
$filename = $touchInst->getWSFile($wsname);

if (!empty($filename) && is_readable($filename) && is_file($filename)) {
	if ($wsname != 'Login') {
		require('modules/Touch/vtws/api/wslogin.php');

		// metto in sessione una variabile utile
		$_SESSION["app_unique_key"] = 'WSMobile_'.time();

		// utente
		if ($userId > 0) {
			$current_user = CRMEntity::getInstance('Users');
			$current_user->id = $userId;
			$current_user->retrieveCurrentUserInfoFromFile($userId);

			// lingua
			if (!empty($current_user->column_fields['default_language'])) {
				$default_language = $current_language = $current_user->column_fields['default_language'];
			}
		}
	}

	// set global language vars
	global $app_strings;
	if (!empty($current_language)) {
		$app_strings = return_application_language($current_language);
	}


	// TODO: un po' alla volta, portare tutto in questo modo
	$classfile = $touchInst->getWSClassFile($wsname);
	if (is_readable($classfile) && is_file($classfile)) {
		require_once($classfile);
	}

	require($filename);
} else {
	echo "ERROR::Unknown webservice";
}
?>