{*+**********************************************************************************
 * The contents of this file are subject to the vtiger CRM Public License Version 1.0
 * ("License"); You may not use this file except in compliance with the License
 * The Original Code is:  vtiger CRM Open Source
 * The Initial Developer of the Original Code is vtiger.
 * Portions created by vtiger are Copyright (C) vtiger.
 * All Rights Reserved.
 ************************************************************************************}
{* crmv@start *}
{* crmv@43050 *}

{assign var=COMMENTID value=$COMMENTMODEL->id()}

{if $UNSEEN_IDS|is_array && $COMMENTID|in_array:$UNSEEN_IDS}
	{assign var="UNSEEN_CLASS" value=" ModCommUnseen"}
{else}
	{assign var="UNSEEN_CLASS" value=""}
{/if}
{if $NEWS_MODE eq 'yes'}
	{assign var="INDICATOR" value="parent.$('indicatorModCommentsNews')"}
{else}
	{assign var="INDICATOR" value="$('indicator"|cat:$UIKEY|cat:"')"}
{/if}

{if $COMMENTMODEL->getCurrentUser() eq $COMMENTMODEL->authorId()}
	{assign var=ISMINE value=true}
{else}
	{assign var=ISMINE value=false}
{/if}
{assign var=ISPUBLIC value=$COMMENTMODEL->isPublic()}

<table id="tbl{$UIKEY}_{$COMMENTID}" cellpadding="0" cellspacing="0" width="100%"  class="small" style="padding: 3px 0px;">
	<tr>
		<td class="dataImg">
			<img src="{$COMMENTMODEL->authorPhoto()}" alt="{$COMMENTMODEL->author()}" title="{$COMMENTMODEL->author()}" />
		</td>
		<td>
			<input type="hidden" id="listRecip_{$UIKEY}_{$COMMENTID}" name="listRecip_{$UIKEY}_{$COMMENTID}" value="{$COMMENTMODEL->getAllRecipients()|@implode:'|'}" />
			<div class="dataField{$UNSEEN_CLASS}" valign="top" style="position: relative;" onmouseover="{if $ISMINE}jQuery(this).find('.dataFieldReplyDel').show();{/if}">
				{if $COMMENTMODEL->getCurrentUser() eq $COMMENTMODEL->authorId()}
					<div class="dataFieldReplyDel" style="display: none; position: absolute; top: 3px; right: 3px;"><a href="javascript:ModCommentsCommon.deleteComment('{$UIKEY}_{$COMMENTID}','{$COMMENTID}',{$INDICATOR});"><img src="{'small_delete.png'|@vtiger_imageurl:$THEME}" title="{'LBL_DELETE'|getTranslatedString:$MODULE}" border=0 height="12px"/></a></div>
				{/if}
				<b>{$COMMENTMODEL->author()}</b>{$COMMENTMODEL->recipients()}{if !$ISPUBLIC} <span class="commentAddUserLink" ><a href="#" onclick="showUsersPopup(this, '{$COMMENTID}')"><img src="{'plus_turbolift.png'|vtiger_imageurl:$THEME}" border="0" height="12px" valign="bottom" title="{$APP.LBL_ADD_ITEM} {$APP.Users}" /></a></span>{/if}&nbsp;{$COMMENTMODEL->content()}
			</div>

			{assign var=relatedToStr value=$COMMENTMODEL->relatedToString()}
			<div class="dataLabel{$UNSEEN_CLASS}" valign="top">

				<a href="javascript:;" title="{$COMMENTMODEL->timestamp()}" style="color: gray; text-decoration: none;">{$COMMENTMODEL->timestampAgo()}</a>
				{if $NEWS_MODE eq 'yes'}
					{if $relatedToStr neq ''}
						{$relatedToStr}
					{else}
						&nbsp;&nbsp;<span class="commentAddLink"><a href="#" onclick="top.openLinkPopup('{$COMMENTID}', 'linkrecord', {ldelim}callback_link: 'commentsLinkModule', 'uikey': '{$UIKEY}' {rdelim}, window)">{"LBL_LINK_ACTION"|getTranslatedString:'Messages'}</a></span>
					{/if}
				{/if}
			</div>
			<div id="contentwrap_{$UIKEY}_{$COMMENTID}" class="ModCommReplies" valign="top">
				{assign var="already_show_all" value="no"}
				{foreach name=reply item=REPLYMODEL from=$COMMENTMODEL->replies}
					{if $already_show_all eq 'no' && $smarty.foreach.reply.total > $REPLYMODEL->getMaxRepliesForComment()}
						<table id="showAll{$UIKEY}_{$COMMENTID}" cellpadding="0" cellspacing="0" width="100%" style="padding: 3px 5px 0px 0px;" onmouseover="jQuery(this).find('.dataFieldReplyDel').show();" onmouseout="jQuery(this).find('.dataFieldReplyDel').hide();">
							<tr>
								<td class="small dataFieldReply" style="padding: 5px;">
									<a href="javascript:;" onclick="showAllReplies('{$UIKEY}_{$COMMENTID}');">{$MOD.LBL_SHOW_ALL_REPLIES_1} {$smarty.foreach.reply.total} {$MOD.LBL_SHOW_ALL_REPLIES_2}</a>
								</td>
							</tr>
						</table>
						{assign var="already_show_all" value="yes"}
					{/if}
					{assign var="reverse_iteration" value=$smarty.foreach.reply.total-$smarty.foreach.reply.iteration+1}
					{include file="modules/ModComments/widgets/DetailViewBlockReplyItem.tpl"}
				{/foreach}
			</div>
			<div class="ModCommAnswerBox" valign="top" style="padding: 3px 5px 5px 0px;">
				<table cellpadding="0" cellspacing="0" width="100%">
					<tr>
						<td align="right" width="100%">
							<textarea id="txtbox_{$UIKEY}_{$COMMENTID}" style="padding: 5px;" class="detailedViewTextBox detailedViewModCommTextBox" onFocus="onModCommTextBoxFocus('txtbox_{$UIKEY}_{$COMMENTID}','{$UIKEY}_{$COMMENTID}','reply');" onBlur="onModCommTextBoxBlur('txtbox_{$UIKEY}_{$COMMENTID}','{$UIKEY}_{$COMMENTID}','reply');" cols="90" rows="8">{$DEFAULT_REPLY_TEXT}</textarea>
							<br />
							<div id="saveButtonRow_{$UIKEY}_{$COMMENTID}" style="display: none;">
								{if $NEWS_MODE eq 'yes'}
									{assign var="RELATED_TO" value=$COMMENTMODEL->relatedTo()}
								{else}
									{assign var="RELATED_TO" value=$ID}
								{/if}
								<input type="button" class="crmbutton small save" value="{$MOD.LBL_PUBLISH}" onclick="ModCommentsCommon.addReply('{$UIKEY}_{$COMMENTID}', '{$RELATED_TO}', '{$COMMENTID}', {$INDICATOR});"/>
							</div>
						</td>
					</tr>
				</table>
			</div>
		</td>
	</tr>
</table>
{* crmv@end *}