<?php
/***************************************************************************************
 * The contents of this file are subject to the CRMVILLAGE.BIZ VTECRM License Agreement
 * ("licenza.txt"); You may not use this file except in compliance with the License
 * The Original Code is:  CRMVILLAGE.BIZ VTECRM
 * The Initial Developer of the Original Code is CRMVILLAGE.BIZ.
 * Portions created by CRMVILLAGE.BIZ are Copyright (C) CRMVILLAGE.BIZ.
 * All Rights Reserved.
 ***************************************************************************************/

require_once('config.inc.php');
/** Verify the script call is from trusted place. */
global $application_unique_key;
if($_REQUEST['app_key'] != $application_unique_key) {
	echo "Access denied!";
	exit;
}
ini_set('memory_limit','256M');

/**
 * Check if instance of this service is already running?
 */
$svcname = $_REQUEST['service'];
// We need to make sure the PIDfile name is unqique
$servicePIDFile = "logs/$svcname-service.pid";

if(file_exists($servicePIDFile)) {
	if (filemtime($servicePIDFile) <= strtotime('-40 minutes')) {
		/*
		$contents = 'Il file PID Messages e` vecchio di due ore. Ora e` stato cancellato e ricreato, verificare se la coda di invio e` bloccata o sta procedendo.';
		global $adb, $table_prefix;
		$result = $adb->pquery("SELECT * FROM {$table_prefix}_messages_cron WHERE status = 2");
		$cron_blocked = array();
		if ($result && $adb->num_rows($result) > 0) {
			$contents .= "<br /><br />Righe bloccate in {$table_prefix}_messages_cron:";
			while($row=$adb->fetchByAssoc($result)) {
				$contents .= "<br />- userid:{$row['userid']} accountid:{$row['accountid']} folder:{$row['folder']}";
			}
		}
		require_once("include/utils/utils.php");
		require_once("modules/Emails/mail.php");
		$mail = new PHPMailer();
		setMailerProperties($mail,'[VTE COMMERCIALE] Errore PID Messages',$contents,'vtecommerciale@crmvillage.biz','vtecommerciale@crmvillage.biz','supporto@crmvillage.biz');
		$mail->SMTPAuth = false;
		$mail->Host = 'mail.crmvillage.biz';
		$mail->Username = '';
		$mail->Password = '';
		$mail_status = MailSend($mail);
		*/
		$adb->pquery("UPDATE {$table_prefix}_messages_cron SET status = 1 WHERE status = 2");
		@unlink($servicePIDFile);
		$servicePIDFp = fopen($servicePIDFile, 'a');
	} else {
		echo "Service $svcname already running! Check $servicePIDFile";
		exit;
	}
} else {
	$servicePIDFp = fopen($servicePIDFile, 'a');
}

/**
 * Turn-off PHP error reporting.
 */
//try { error_reporting(0); } catch(Exception $e) { }

require_once('include/utils/utils.php');
require_once('include/logging.php');

// Get the list of Invoice for which Recurring is enabled.

global $adb, $log, $current_user,$table_prefix;
$log =& LoggerManager::getLogger('Messages');
$log->debug("invoked Messages");

$focus = CRMEntity::getInstance('Messages');
$focus->cronSync();

$log->debug("end Messages procedure");
/** Close and remove the PID file. */
if($servicePIDFp) {
	fclose($servicePIDFp);
	unlink($servicePIDFile);
}
?>