<?php
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version 1.1.2
 * ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an  "AS IS"  basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License.
 * The Original Code is:  SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) SugarCRM, Inc.;
 * Portions created by CRMVILLAGE.BIZ are Copyright (C) CRMVILLAGE.BIZ.
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 ********************************************************************************/
/*********************************************************************************
 * $Header: /advent/projects/wesat/vtiger_crm/sugarcrm/modules/Emails/EditView.php,v 1.25 2005/04/18 10:37:49 samk Exp $
 * Description: TODO:  To be written.
 * Portions created by SugarCRM are Copyright (C) SugarCRM, Inc.
 * All Rights Reserved.
 * Contributor(s): ______________________________________..
 ********************************************************************************/

//crmv@25356
require_once('Smarty_setup.php');
require_once('data/Tracker.php');
require_once('include/utils/utils.php');
require_once('include/utils/UserInfoUtil.php');
require_once("include/Zend/Json.php");

global $table_prefix;
global $log;
global $app_strings;
global $app_list_strings;
global $mod_strings;
global $current_user;
global $currentModule;
global $default_charset;

$focus = CRMEntity::getInstance($currentModule);
$smarty = new vtigerCRM_Smarty();
$json = new Zend_Json();

//crmv@26111
$result = $adb->pquery('select signature from '.$table_prefix.'_users where id = ?',array($current_user->id));
if ($result && $adb->num_rows($result) > 0) {
	$vte_signature = nl2br($adb->query_result($result,0,'signature'));
}
//crmv@26111e

$send_mode = 'single';	//crmv@26639
$send_action = $_REQUEST['message_mode'];	//crmv@2963m
$relation = $_REQUEST['relation'];
$account = $_REQUEST['account'];

if($_REQUEST['upload_error'] == true)
{
	echo '<br><b><font color="red"> The selected file has no data or a invalid file.</font></b><br>';
}

//Email Error handling
if($_REQUEST['mail_error'] != '') {
	require_once("modules/Emails/mail.php");
	echo parseEmailErrorString($_REQUEST['mail_error']);
}
//added to select the module in combobox of compose-popup
if(isset($_REQUEST['par_module']) && $_REQUEST['par_module']!='') {
	$smarty->assign('select_module',vtlib_purify($_REQUEST['par_module']));
}
elseif(isset($_REQUEST['pmodule']) && $_REQUEST['pmodule']!='') {
	$smarty->assign('select_module',vtlib_purify($_REQUEST['pmodule']));
}

// crmv@43147
if ($_REQUEST['mode'] == 'share' && !empty($_REQUEST['record'])) {
	$CU = CRMVUtils::getInstance();
	$data = $CU->getSharedEmailTemplate(intval($_REQUEST['record']));
	$focus->column_fields['subject'] = $data['subject'];
	$focus->column_fields['description'] = $data['body'];
	$smarty->assign('SUBJECT',$data['subject']);
	$smarty->assign('DESCRIPTION',$data['body']);
}
// crmv@43147e

//crmv@2963m
$focusMessages = CRMEntity::getInstance('Messages');
$message = $_REQUEST['message'];
if(isset($message) && $message != '') {
	$focusMessages->id = $message;
	$focusMessages->retrieve_entity_info($message,'Messages');
	$account = $focusMessages->column_fields['account'];
	$focusMessages->column_fields['mto'] = str_replace('undisclosed-recipients:;','',$focusMessages->column_fields['mto']);
	switch ($send_action) {
		case 'forward':
			$focus->mode = '';
			$focus->column_fields['subject'] = 'Fwd: '.$focusMessages->column_fields['subject'];
			$focus->column_fields['description'] = '<br /><br />'.$focus->getMessageForwardHeader($focusMessages).$focusMessages->column_fields['description'];

			$attachment_links = array();
			$att_ar = $focusMessages->getAttachments();
			foreach ($att_ar as $att) {
				if (!empty($att['target'])) {
					$target = "target='{$att['target']}'";
				}
				$attachment_links[] = "<a href='{$att['link']}' {$target}>{$att['name']}</a>";
			}
			$smarty->assign('webmail_attachments',$attachment_links);
			break;
		case 'reply_all':
			$smarty->assign('CC_MAIL', $focusMessages->column_fields['mcc']);
		case 'reply':
			$focus->mode = '';
			$focus->column_fields['subject'] = 'Re: '.$focusMessages->column_fields['subject'];
			$focus->column_fields['description'] = '<br /><br />'.$focus->getMessageReplyHeader($focusMessages).'<blockquote type="cite">'.$focusMessages->column_fields['description'].'</blockquote>';
			$specialFolders = $focusMessages->getSpecialFolders(false);
			if (!empty($specialFolders['Sent']) && $focusMessages->column_fields['folder'] == $specialFolders['Sent']) {
				$idlists = $focusMessages->getRecipients('string');
				$to_tmp = $focusMessages->column_fields['mto'];
				if (substr_count($focusMessages->column_fields['mto_f'],',') > substr_count($to_tmp,',')) {
					$to_tmp = trim($focusMessages->column_fields['mto_f']);
				}
				$addressInfo = setAddressInfo($idlists,explode(',',$to_tmp),true);
				$smarty->assign('AUTOSUGGEST',$addressInfo['autosuggest']);
				$smarty->assign('TO_MAIL',$addressInfo['to_mail']);
				$smarty->assign('OTHER_TO_MAIL',$addressInfo['other_to_mail']);
				$smarty->assign('IDLISTS',$idlists);
			} else {
				$smarty->assign('OTHER_TO_MAIL', $focusMessages->column_fields['mfrom']);
				if ($send_action == 'reply_all') {
					$cc_tmp = explode(',',$focusMessages->column_fields['mto']);
					$cc_tmp[] = $focusMessages->column_fields['mcc'];
					$from_email_tmp = $focus->getFromEmailList('',$account);
					foreach($from_email_tmp as $t) {
						if ($t['selected'] == 'selected') {
							$from_email_tmp = $t['email'];
						}
					}
					foreach($cc_tmp as $i => $t) {
						if (empty($t) || trim($t) == $from_email_tmp) {
							unset($cc_tmp[$i]);
						} else {
							trim($cc_tmp[$i]);
						}
					}
				}
				if (!empty($cc_tmp)) {
					$smarty->assign('CC_MAIL', trim(implode(', ',$cc_tmp)));
				}
			}
			//crmv@26111
			if ($vte_signature != '') {
				$focus->column_fields['description'] .= '<br />'.$vte_signature;
			}
			//crmv@26111e
			if (!empty($focusMessages->column_fields['send_mode'])) {
				$send_mode = $focusMessages->column_fields['send_mode'];
			}
			break;
		case 'draft':
			$focus->mode = '';
			$focus->column_fields['subject'] = $focusMessages->column_fields['subject'];
			$focus->column_fields['description'] = $focusMessages->column_fields['description'];

			$idlists = $focusMessages->getRecipients('string');
			$addressInfo = setAddressInfo($idlists,explode(',',$focusMessages->column_fields['mto']),true);
			$smarty->assign('AUTOSUGGEST',$addressInfo['autosuggest']);
			$smarty->assign('TO_MAIL',$addressInfo['to_mail']);
			$smarty->assign('OTHER_TO_MAIL',$addressInfo['other_to_mail']);
			$smarty->assign('IDLISTS',$idlists);

			$smarty->assign('CC_MAIL', $focusMessages->column_fields['mcc']);
			$smarty->assign('BCC_MAIL', $focusMessages->column_fields['mbcc']);

			$attachment_links = array();
			$att_ar = $focusMessages->getAttachments();
			foreach ($att_ar as $att) {
				if (!empty($att['target'])) {
					$target = "target='{$att['target']}'";
				}
				$attachment_links[] = "<a href='{$att['link']}' {$target}>{$att['name']}</a>";
			}
			$smarty->assign('webmail_attachments',$attachment_links);

			$result_draft = $adb->pquery("SELECT id FROM {$table_prefix}_messages_drafts WHERE userid = ? AND messagehash = ?",array($current_user->id,$focusMessages->column_fields['messagehash']));
			if ($result_draft && $adb->num_rows($result_draft) > 0) {
				$draftid = $adb->query_result($result_draft,0,'id');
			}

			// retrieve related entities
			$rm = RelationManager::getInstance();
			$excludeMods = array('ModComments', 'Campaigns');
			$ids = $rm->getRelatedIds('Messages', $focusMessages->id, null, $excludeMods);
			if (!empty($ids)) {
				$relation = implode('|',$ids);
			}
			if (!empty($focusMessages->column_fields['send_mode'])) {
				$send_mode = $focusMessages->column_fields['send_mode'];
			}

			break;
	}
//crmv@2963me
} elseif(isset($_REQUEST['sendmail']) && $_REQUEST['sendmail'] !='') {
	$mailids = get_to_emailids($_REQUEST['pmodule']);
	if($mailids['mailds'] != '') {
		$to_add = trim($mailids['mailds'],",").",";
	}
	$addressInfo = setAddressInfo($mailids['idlists'],explode(',',$to_add),true);
	$smarty->assign('AUTOSUGGEST',$addressInfo['autosuggest']);
	$smarty->assign('TO_MAIL',$addressInfo['to_mail']);
	$smarty->assign('OTHER_TO_MAIL',$addressInfo['other_to_mail']);
	$smarty->assign('IDLISTS',$mailids['idlists']);
	//crmv@26111
	if ($vte_signature != '') {
		$focus->column_fields['description'] .= '<br />'.$vte_signature;
	}
	//crmv@26111e
	$focus->mode = '';
	$relation = $_REQUEST['pid'];
//crmv@2043m
} elseif(isset($_REQUEST['reply_mail_converter']) && $_REQUEST['reply_mail_converter'] != '') {
	$HelpDeskFocus = CRMEntity::getInstance('HelpDesk');
	$HelpDeskFocus->retrieve_entity_info($_REQUEST['reply_mail_converter_record'],'HelpDesk');
	$_REQUEST["field_lists"] = implode(':',getFieldList(getSalesEntityType($HelpDeskFocus->column_fields['parent_id'])));
	saveListViewCheck(getSalesEntityType($HelpDeskFocus->column_fields['parent_id']),$HelpDeskFocus->column_fields['parent_id']);
	$mailids = get_to_emailids(getSalesEntityType($HelpDeskFocus->column_fields['parent_id']));
	$addressInfo = setAddressInfo($mailids['idlists'],array(),true);
	$smarty->assign('AUTOSUGGEST',$addressInfo['autosuggest']);
	if ($addressInfo['to_mail'] != '') {
		$smarty->assign('TO_MAIL',$addressInfo['to_mail']);
	} elseif ($mailids['idlists'] != '') {
		$tmp1 = explode('|',$mailids['idlists']);
		if ($tmp1[0] != '') {
			$tmp2 = explode('@',$tmp1[0]);
			if (!empty($tmp2)) {
				$smarty->assign('TO_MAIL',getFieldValue($tmp2[1], $tmp2[0]));
			}
		}
	}
	$smarty->assign('OTHER_TO_MAIL',$addressInfo['other_to_mail']);
	$smarty->assign('IDLISTS',$mailids['idlists']);
	$focus->mode = '';
	$focus->column_fields['subject'] = 'Re: '.$HelpDeskFocus->column_fields['ticket_title'].' - Ticket Id: '.$_REQUEST['reply_mail_converter_record'];
	//crmv@26111
	if ($_REQUEST['reply_mail_user'] != 'mailconverter' && $vte_signature != '') {
		$focus->column_fields['description'] .= '<br />'.$vte_signature;
	}
	//crmv@26111e
	if(isset($_REQUEST['reply_mail_converter']) && $_REQUEST['reply_mail_converter'] != '') {
		if ($_REQUEST['reply_mail_user'] == 'mailconverter') {
			$from_email = $HelpDeskFocus->column_fields['helpdesk_from'];
		} else {
			$from_email = $current_user->column_fields['email1'];
		}
	}
//crmv@2043me
} else {
	//crmv@26111
	if ($vte_signature != '') {
		$focus->column_fields['description'] .= '<br />'.$vte_signature;
	}
	//crmv@26111e
}

//crmv@2051m
if ($from_email == '') {
	$from_email = $focus->column_fields['from_email'];
}
if ($account === '') {
	$main_account = $focusMessages->getMainUserAccount();
	$account = $main_account['id'];
}
$smarty->assign('FROM_EMAIL_LIST',$focus->getFromEmailList($from_email,$account));
//crmv@2051me

// INTERNAL MAILER
if($_REQUEST["internal_mailer"] == "true") {

	$smarty->assign('INT_MAILER',"true");
	$rec_type = $_REQUEST["type"];
	$rec_id = $_REQUEST["rec_id"];
	$fieldname = $_REQUEST["fieldname"];

	//added for getting list-ids to compose email popup from list view(Accounts,Contacts,Leads)
	if(isset($_REQUEST['field_id']) && strlen($_REQUEST['field_id']) != 0) {
		if($_REQUEST['par_module'] == "Users")
			$id_list = $_REQUEST['rec_id'].'@'.'-1|';
		else
			$id_list = $_REQUEST['rec_id'].'@'.$_REQUEST['field_id'].'|';
		$smarty->assign("IDLISTS", $id_list);
	}
	if($rec_type == "record_id") {
		$type = $_REQUEST['par_module'];
		//check added for email link in user detail view
		$normal_tabs = Array('Users'=>$table_prefix.'_users', 'Leads'=>$table_prefix.'_leaddetails', 'Contacts'=>$table_prefix.'_contactdetails', 'Accounts'=>$table_prefix.'_account', 'Vendors'=>$table_prefix.'_vendor');
		$cf_tabs = Array('Accounts'=>$table_prefix.'_accountscf', 'Campaigns'=>$table_prefix.'_campaignscf', 'Contacts'=>$table_prefix.'_contactscf', 'Invoice'=>$table_prefix.'_invoicecf', 'Leads'=>$table_prefix.'_leadscf', 'Potentials'=>$table_prefix.'_potentialscf', 'Products'=>$table_prefix.'_productcf',  'PurchaseOrder'=>$table_prefix.'_purchaseordercf', 'Quotes'=>$table_prefix.'_quotescf', 'SalesOrder'=>$table_prefix.'_salesordercf', 'HelpDesk'=>$table_prefix.'_ticketcf', 'Vendors'=>$table_prefix.'_vendorcf');
		if(substr($fieldname,0,2)=="cf")
			$tablename = $cf_tabs[$type];
		else
			$tablename = $normal_tabs[$type];
		if($type == "Users")
			$q = "select $fieldname from $tablename where id=?";
		elseif($type == "Leads")
			$q = "select $fieldname from $tablename where leadid=?";
		elseif ($type == "Contacts")
			$q = "select $fieldname from $tablename where contactid=?";
		elseif ($type == "Accounts")
			$q = "select $fieldname from $tablename where accountid=?";
		elseif ($type == "Vendors")
			$q = "select $fieldname from $tablename where vendorid=?";
		else {
			// vtlib customization: Support for email-type custom field for other modules.
			//crmv@21474
			$module_focus = CRMEntity::getInstance($type);
			$tablename = getTableNameForField($type,$fieldname);
			$tablename_index = $module_focus->tab_name_index[$tablename];
			$q = "select $fieldname from $tablename where $tablename_index = ?";
			//crmv@21474e
			// END
		}
		$email1 = $adb->query_result($adb->pquery($q, array($rec_id)),0,$fieldname);
	} elseif ($rec_type == "email_addy") {
		$email1 = $_REQUEST["email_addy"];
	}
	$addressInfo = setAddressInfo($id_list,explode(',',$email1));
	$smarty->assign('AUTOSUGGEST',$addressInfo['autosuggest']);
	$smarty->assign('TO_MAIL',$addressInfo['to_mail']);
	$smarty->assign('OTHER_TO_MAIL',$addressInfo['other_to_mail']);
	//crmv@26111
	if ($vte_signature != '' && $focus->mode != '') {	//crmv@31315
		$focus->column_fields['description'] .= '<br />'.$vte_signature;
	}
	//crmv@26111e
}

//Added to set the cc when click reply all
if(isset($_REQUEST['msg_cc']) && $_REQUEST['msg_cc'] != '')
{
	$smarty->assign("MAIL_MSG_CC", $_REQUEST['msg_cc']);
}

if (!empty($relation)) {
	$links = array();
	if (strpos($relation,'|') !== false) {
		$ids = array_filter(explode('|', $relation));
		foreach ($ids as $relid) {
			list($elid, $fieldid) = explode('@', $relid, 2);
			if (strpos($elid,'x') !== false) {
				$elid = explode('x',$elid);
				$elid = $elid[1];
			}
			$l = $focusMessages->getEntityPreview($elid);
		if ($l) $links[$elid] = $l;
		}
	} else {
		$l = $focusMessages->getEntityPreview($relation);
		if ($l) $links[$relation] = $l;
	}
	$smarty->assign('LINKS_STR',implode('|',array_keys($links)));
	$smarty->assign('LINKS',$links);
}

//crmv@25391
$result = $adb->pquery('SELECT templateid,subject,body FROM '.$table_prefix.'_emailtemplates WHERE templatename = ?',array($_REQUEST['templatename']));
if ($result && $adb->num_rows($result)>0) {
	$subject = $adb->query_result_no_html($result,0,'subject');
	$body = $adb->query_result_no_html($result,0,'body');
	$focus->column_fields['subject'] = $subject;
	$focus->column_fields['description'] = $body;
	$smarty->assign('SUBJECT',$subject);
	$smarty->assign('DESCRIPTION',$body);
	$send_mode = 'multiple';
}
//crmv@25391e
//crmv@26639
if (isset($_REQUEST['send_mode']) && in_array($_REQUEST['send_mode'],array('single','multiple'))) {
	$send_mode = $_REQUEST['send_mode'];
}
$smarty->assign('SEND_MODE', $send_mode);
//crmv@26639e

global $theme;
$theme_path="themes/".$theme."/";
$image_path=$theme_path."images/";

$disp_view = getView($focus->mode);
//crmv@9434
$mode = $focus->mode;
//crmv@9434 end
$details = getBlocks($currentModule,$disp_view,$mode,$focus->column_fields);
//changed this below line to view description in all language - bharath
$smarty->assign("BLOCKS",$details[$mod_strings['LBL_EMAIL_INFORMATION']]);
$smarty->assign("MODULE",$currentModule);
$smarty->assign("SINGLE_MOD",$app_strings['Email']);
//id list of attachments while forwarding
$smarty->assign("ATT_ID_LIST",$att_id_list);

//needed when creating a new email with default values passed in
if (isset($_REQUEST['contact_name']) && is_null($focus->contact_name))
{
	$focus->contact_name = $_REQUEST['contact_name'];
}
if (isset($_REQUEST['contact_id']) && is_null($focus->contact_id))
{
	$focus->contact_id = $_REQUEST['contact_id'];
}
if (isset($_REQUEST['parent_name']) && is_null($focus->parent_name))
{
	$focus->parent_name = $_REQUEST['parent_name'];
}
if (isset($_REQUEST['parent_id']) && is_null($focus->parent_id))
{
	$focus->parent_id = $_REQUEST['parent_id'];
	//crmv@22512
	$smarty->assign("IDLISTS",$focus->parent_id);
	//crmv@22512e
}
if (isset($_REQUEST['parent_type']))
{
	$focus->parent_type = $_REQUEST['parent_type'];
}
elseif (is_null($focus->parent_type))
{
	$focus->parent_type = $app_list_strings['record_type_default_key'];
}

$log->info("Email detail view");

$smarty->assign("MOD", $mod_strings);
$smarty->assign("APP", $app_strings);
if (isset($focus->name)) $smarty->assign("NAME", $focus->name);
else $smarty->assign("NAME", "");

if($focus->mode == 'edit')
{
	$smarty->assign("UPDATEINFO",updateInfo($focus->id));
	$smarty->assign("MODE", $focus->mode);
}

// Unimplemented until jscalendar language vtiger_files are fixed

$smarty->assign("CALENDAR_LANG", $app_strings['LBL_JSCALENDAR_LANG']);
$smarty->assign("CALENDAR_DATEFORMAT", parse_calendardate($app_strings['NTC_DATE_FORMAT']));

if(isset($_REQUEST['return_module'])) $smarty->assign("RETURN_MODULE", vtlib_purify($_REQUEST['return_module']));
else $smarty->assign("RETURN_MODULE",'Emails');
if(isset($_REQUEST['return_action'])) $smarty->assign("RETURN_ACTION", vtlib_purify($_REQUEST['return_action']));
else $smarty->assign("RETURN_ACTION",'index');
if(isset($_REQUEST['return_id'])) $smarty->assign("RETURN_ID", vtlib_purify($_REQUEST['return_id']));
if (isset($_REQUEST['return_viewname'])) $smarty->assign("RETURN_VIEWNAME", vtlib_purify($_REQUEST['return_viewname']));

$smarty->assign("THEME", $theme);
$smarty->assign("IMAGE_PATH", $image_path);
$smarty->assign("PRINT_URL", "phprint.php?jt=".session_id().$GLOBALS['request_string']);
$smarty->assign("ID", $focus->id);
$smarty->assign("ENTITY_ID", vtlib_purify($_REQUEST["record"]));
$smarty->assign("ENTITY_TYPE",vtlib_purify($_REQUEST["email_directing_module"]));
$smarty->assign("OLD_ID", $old_id );
//Display the FCKEditor or not? -- configure $FCKEDITOR_DISPLAY in config.php
$smarty->assign("FCKEDITOR_DISPLAY",$FCKEDITOR_DISPLAY);

$check_button = Button_Check($module);
$smarty->assign("CHECK", $check_button);

//crmv@sdk-18501
include_once('vtlib/Vtiger/Link.php');
$hdrcustomlink_params = Array('MODULE'=>$currentModule);
$COMMONHDRLINKS = Vtiger_Link::getAllByType(Vtiger_Link::IGNORE_MODULE, Array('HEADERLINK','HEADERSCRIPT', 'HEADERCSS'), $hdrcustomlink_params);
$smarty->assign('HEADERLINKS', $COMMONHDRLINKS['HEADERLINK']);
$smarty->assign('HEADERSCRIPTS', $COMMONHDRLINKS['HEADERSCRIPT']);
$smarty->assign('HEADERCSS', $COMMONHDRLINKS['HEADERCSS']);
//crmv@sdk-18501 e

// Gather the custom link information to display
$customlink_params = Array('MODULE'=>$currentModule);
$smarty->assign('CUSTOM_LINKS', Vtiger_Link::getAllByType(getTabid('Messages'), Array('DETAILVIEWWIDGET'), $customlink_params));
// END

//crmv@2963m
$uploaddir = $current_user->id.'_'.date("YmdHis");
$smarty->assign('UPLOADIR', $uploaddir);
if (empty($draftid)) {
	$draftid = md5(uniqid($current_user->id));
}
$smarty->assign('DRAFTID', $draftid);
//crmv@2963me

$smarty->display("ComposeEmail.tpl");
//crmv@25356e
?>