<?php
/***************************************************************************************
 * The contents of this file are subject to the CRMVILLAGE.BIZ VTECRM License Agreement
 * ("licenza.txt"); You may not use this file except in compliance with the License
 * The Original Code is:  CRMVILLAGE.BIZ VTECRM
 * The Initial Developer of the Original Code is CRMVILLAGE.BIZ.
 * Portions created by CRMVILLAGE.BIZ are Copyright (C) CRMVILLAGE.BIZ.
 * All Rights Reserved.
 ***************************************************************************************/
$success = false;
$error_message = array();
$error_addr = array();
$to = array();
if ($message_mode == 'forward') {	// || $message_mode == 'draft' (crmv@48501*1)
	$attach_messageid = $messageid;
} else {
	$attach_messageid = '';
}
if(isset($to_mail) && $to_mail != '') {
	$Exploded_Mail = explode(',',$to_mail);
	$Exploded_Mail = array_map('trim', $Exploded_Mail);
	$Exploded_Mail = array_filter($Exploded_Mail);
	foreach($Exploded_Mail as $mailadd) {
		$to[] = $mailadd;
		$subject_send = $subject;
		$description_send = $description;
		if ($mail_tmp == '') {
			$send_mail_status = send_mail('Emails',$mailadd,$from_name,$from_address,$subject_send,$description_send,$cc,$bcc,'all',$attach_messageid,$logo,'',$mail_tmp,$messageid,$message_mode);
		} else {
			$mail_tmp_empty = '';
			$send_mail_status = send_mail('Emails',$mailadd,$from_name,$from_address,$subject_send,$description_send,$cc,$bcc,'all',$attach_messageid,$logo,'',$mail_tmp_empty,$messageid,$message_mode);
		}
		if($send_mail_status != 1) {
			$error_message[] = $send_mail_status;
			$error_addr[] = $mailadd;
		}
	}
}
if (!empty($myids)) {
	if (!is_array($myids)) {
		$myids = explode('|',$myids);
	}
	foreach($myids as $myid) {
		$subject_send = $subject;
		$description_send = $description;
		$realid = explode("@",$myid);
		$nemail = count($realid);
		$mycrmid = $realid[0];
		if($realid[1] == -1) {
			//handle the mail send to vtiger_users
			$emailadd = $adb->query_result($adb->pquery("select email1 from ".$table_prefix."_users where id=?", array($mycrmid)),0,'email1');
			$pmodule = 'Users';
			$description_send = getMergedDescription($description_send,$mycrmid,$pmodule);
			$subject_send = getMergedDescription($subject_send,$mycrmid,$pmodule);
			if ($mail_tmp == '') {
				$send_mail_status = send_mail('Emails',$emailadd,$from_name,$from_address,$subject_send,$description_send,$cc,$bcc,'all',$attach_messageid,$logo,'',$mail_tmp,$messageid,$message_mode);
			} else {
				$mail_tmp_empty = '';
				$send_mail_status = send_mail('Emails',$emailadd,$from_name,$from_address,$subject_send,$description_send,$cc,$bcc,'all',$attach_messageid,$logo,'',$mail_tmp_empty,$messageid,$message_mode);
			}
			$to[] = $emailadd;
			if($send_mail_status != 1) {
				$error_message[] = $send_mail_status;
				$error_addr[] = $emailadd;
			}
		} else {
			//Send mail to vtiger_account or lead or contact based on their ids
			$pmodule = getSalesEntityType($mycrmid);
			if ($pmodule == '') {
				$res = $adb->query('SELECT * FROM '.$table_prefix.'_users WHERE id = '.$mycrmid);
				if ($res && $adb->num_rows($res)>0) {
					$pmodule = 'Users';
				}
			}
			for ($j=1;$j<$nemail;$j++) {
				$temp = $realid[$j];
				$myquery = 'Select fieldname from '.$table_prefix.'_field where fieldid = ? and '.$table_prefix.'_field.presence in (0,2)';
				$fresult = $adb->pquery($myquery, array($temp));
				if ($pmodule == 'Users') {
					$myfocus = CRMEntity::getInstance('Users');
					$myfocus->retrieve_entity_info($mycrmid,"Users");
				} else {
					// vtlib customization: Enabling mail send from other modules
					$myfocus = CRMEntity::getInstance($pmodule);
					$myfocus->retrieve_entity_info($mycrmid, $pmodule);
					// END
				}
				$fldname = $adb->query_result($fresult,0,'fieldname');
				$emailadd = br2nl($myfocus->column_fields[$fldname]);
				if($emailadd != '') {
					$description_send = getMergedDescription($description_send,$mycrmid,$pmodule);
					$subject_send = getMergedDescription($subject_send,$mycrmid,$pmodule);
					//Email Open Tracking
					global $site_URL, $application_unique_key;
					$track_URL = "$site_URL/modules/Emails/TrackAccess.php?record=$mycrmid&mailid={$focus->id}&app_key=$application_unique_key";
					$description_send = "<img src='$track_URL' alt='' width='1' height='1'>$description_send";
					// END
					$pos = strpos($description_send, '$logo$');
					if ($pos !== false) {
						$description_send = str_replace('$logo$','<img src="cid:logo" />', $description_send);
						$logo = 1;
					}
					//if(isPermitted($pmodule,'DetailView',$mycrmid) == 'yes' || $pmodule == 'Users') {
					if ($mail_tmp == '') {
						$send_mail_status = send_mail('Emails',$emailadd,$from_name,$from_address,$subject_send,$description_send,$cc,$bcc,'all',$attach_messageid,$logo,'',$mail_tmp,$messageid,$message_mode);
					} else {
						$mail_tmp_empty = '';
						$send_mail_status = send_mail('Emails',$emailadd,$from_name,$from_address,$subject_send,$description_send,$cc,$bcc,'all',$attach_messageid,$logo,'',$mail_tmp_empty,$messageid,$message_mode);
					}
					//}
					$to[] = $emailadd;
					if($send_mail_status != 1) {
						$error_message[] = $send_mail_status;
						$error_addr[] = $emailadd;
					}
				}
			}
		}
	}
}
if (!empty($error_message)) {
	$error_message = implode("\n",$error_message);
	$to = array_diff($to,$error_addr);
	if (!empty($to)) {
		$error_message .= "\n\n".getTranslatedString('LBL_SMTP_ERROR_MULTIPLE','Emails');
	}
} else {
	if (!empty($_REQUEST['sending_queue_currentid'])) $adb->pquery("update {$table_prefix}_emails_send_queue set s_send = ? where id = ?",array(1,$_REQUEST['sending_queue_currentid']));	//crmv@48501
	$success = true;
}
if (!empty($to)) {
	append_mail($mail_tmp,$account,$parentid,$to,$from_name,$from_address,$subject,$description,'','',$send_mode);
}
if ($success) {
	if (!empty($_REQUEST['sending_queue_currentid'])) $adb->pquery("update {$table_prefix}_emails_send_queue set s_append = ? where id = ?",array(1,$_REQUEST['sending_queue_currentid']));	//crmv@48501
	
	cleanPuploadAttachments($_REQUEST['uploaddir']);
	
	if (!empty($_REQUEST['sending_queue_currentid'])) $adb->pquery("update {$table_prefix}_emails_send_queue set s_clean_pupload_attach = ? where id = ?",array(1,$_REQUEST['sending_queue_currentid']));	//crmv@48501
	
	/*
	 * TODO: eliminare cartelle tmp di allegati di bozze
	 * 
	 * quando viene salvata una bozza con allegati non posso svuotare la cartella perch se poi clicco Salva non troverebbe pi l'allegato da inviare
	 * per nel momento in cui chiudo la finestra di composizione e si  salvata la bozza la cartella con i file diventa inutile perch se riapro la bozza faccio riferimento agli allegati che sono nel server
	 * quindi si potrebbe fare uno script che cancella le cartelle pi vecchie di X giorni
	 */
	if (!empty($messageid) && !empty($message_mode)) {
		$javascript_code .= setflag_mail($messageid, $message_mode);
	}
} else {
	$skip_delete_drafts = true;
}
?>