<?php
/***************************************************************************************
 * The contents of this file are subject to the CRMVILLAGE.BIZ VTECRM License Agreement
 * ("licenza.txt"); You may not use this file except in compliance with the License
 * The Original Code is:  CRMVILLAGE.BIZ VTECRM
 * The Initial Developer of the Original Code is CRMVILLAGE.BIZ.
 * Portions created by CRMVILLAGE.BIZ are Copyright (C) CRMVILLAGE.BIZ.
 * All Rights Reserved.
 ***************************************************************************************/

global $currentModule;
$record = vtlib_purify($_REQUEST['record']);
$contentid = vtlib_purify($_REQUEST['contentid']);

//crmv@46760
global $adb,$table_prefix;
$sql = "select s.attachmentsid,n.notesid from {$table_prefix}_messages_attach a 
inner join {$table_prefix}_seattachmentsrel s on s.crmid = a.document
inner join {$table_prefix}_notes n on n.notesid = a.document
where messagesid = ? and contentid = ? and coalesce(a.document,'') <> ''";
$params = Array($record,$contentid);
$res = $adb->pquery($sql,$params);
if ($res && $adb->num_rows($res)>0){
	$_REQUEST['fileid'] = $adb->query_result_no_html($res,0,'attachmentsid');
	$_REQUEST['entityid'] = $adb->query_result_no_html($res,0,'notesid');
	include('modules/uploads/downloadfile.php');
	exit;
}
//crmv@46760e

$focus = CRMEntity::getInstance($currentModule);
$focus->retrieve_entity_info($record,$currentModule);
$uid = $focus->column_fields['xuid'];
$folder = $focus->column_fields['folder'];

$focus->setAccount($focus->column_fields['account']);
$focus->getZendMailStorageImap($focus->column_fields['assigned_user_id']);
$focus->getZendMailStorageImap();
$focus->selectFolder($folder);

$messageId = $focus->getMailResource()->getNumberByUniqueId($uid);
$message = $focus->getMailResource()->getMessage($messageId);
$parts = $focus->getMessageContentParts($message,$id);
if (!empty($parts['other'][$contentid])) {
	$content = $parts['other'][$contentid];
	$str = $content['content'];
	$str = $focus->decodeAttachment($str,$content['parameters']['encoding'],$content['parameters']['charset']);
	
	$parameters = $content['parameters'];
	header('Content-Type: '.$parameters['contenttype']);
	header("Content-Disposition: {$parameters['contentdisposition']}; filename=\"{$parameters['name']}\"");
	echo $str;
}
?>