/***************************************************************************************
 * The contents of this file are subject to the CRMVILLAGE.BIZ VTECRM License Agreement
 * ("licenza.txt"); You may not use this file except in compliance with the License
 * The Original Code is:  CRMVILLAGE.BIZ VTECRM
 * The Initial Developer of the Original Code is CRMVILLAGE.BIZ.
 * Portions created by CRMVILLAGE.BIZ are Copyright (C) CRMVILLAGE.BIZ.
 * All Rights Reserved.
 ***************************************************************************************/

//crmv@48159	//crmv@48471
function fetch(timeout) {
	if (timeout == undefined) timeout = 0;
	setTimeout(function(){
	
		if (ajax_enable == false) return false;
		ajax_enable = false;
	
		jQuery('#fetchImg').attr('_src',jQuery('#fetchImg').attr('src'));
		jQuery('#fetchImg').attr('src','themes/images/vtbusy.gif');
		
		if (current_folder == specialFolders['INBOX']) {
			getListViewEntries_js('Messages','start=1&account='+current_account+'&folder='+current_folder,true,callbackListViewEntriesFetch);
			$("status").style.display="none";	// in order to see only the vtbusy image
		} else {
			jQuery.ajax({
				url: 'index.php?module=Messages&action=MessagesAjax&file=Fetch&account='+current_account+'&folder='+current_folder+'&only_news=yes',
				type: 'post',
				success: function(data) {
					//TODO RELOAD_AND_FETCH
					if (data.indexOf('RELOAD')>=0) {
						getListViewEntries_js('Messages','start=1&account='+current_account+'&folder='+current_folder,true,callbackListViewEntriesFetch);
						$("status").style.display="none";	// in order to see only the vtbusy image
					} else if (typeof(jQuery('#fetchImg').attr('_src')) != 'undefined') {
						ajax_enable = true;
						jQuery('#fetchImg').attr('src',jQuery('#fetchImg').attr('_src'));
						jQuery('#fetchImg').removeAttr('_src');
					}
				}
			});
		}
	},timeout);
	
	fninvsh('mode2Folder');
}
//crmv@48159e	//crmv@48471e

//crmv@48471
function callbackListViewEntriesFetch(module,result) {
	setmCustomScrollbar('#ListViewContents');
	update_navigation_values(window.location.href+'&account='+current_account+'&folder='+current_folder+'&reload_counts=yes','Messages',true,updateCounts);
	$("status").style.display="none";	// in order to see only the vtbusy image
	ajax_enable = true;
}

function updateCounts(module,result) {
	if (result[2] != '') {
		jQuery('#Folders').html(result[2]);
	}
	if (result[3] != '') {
		jQuery('#Accounts').html(result[3]);
	}
	if (typeof(jQuery('#fetchImg').attr('_src')) != 'undefined') {
		jQuery('#fetchImg').attr('src',jQuery('#fetchImg').attr('_src'));
		jQuery('#fetchImg').removeAttr('_src');
	}
}
//crmv@48471e

function reloadFolders() {
	$("status").style.display="inline";
	jQuery.ajax({
		url: 'index.php?module=Messages&action=MessagesAjax&file=Folders&account='+current_account,
		dataType: 'html',
		async: false,
		success: function(data){
			jQuery('#Folders').html(data);
			$("status").style.display="none";
		}
	});
}

function changeButtons(view,mode,fastinbox,skip_eval_buttons) {

	if (mode == undefined) var mode = '';
	if (fastinbox == undefined || fastinbox == '') var fastinbox = false;
	if (skip_eval_buttons == undefined || skip_eval_buttons == '') var skip_eval_buttons = false;
	
	jQuery('#Messages_Buttons_List').children().hide();
	
	if (skip_eval_buttons == false) {
		if (view == 'ListView') {
			if (current_account == 'all') jQuery('#Buttons_List_3_ListView #editfolder').hide();
			else jQuery('#Buttons_List_3_ListView #editfolder').show();
			
			jQuery('#Buttons_List_3_ListView #go2accounts').hide();
			jQuery('#Buttons_List_3_ListView #go2folders').hide();
			if (isMultiAccount && fastinbox) {
				jQuery('#Buttons_List_3_ListView #go2accounts').show();
			} else {
				jQuery('#Buttons_List_3_ListView #go2folders').show();
			}
		} else if (view == 'Thread') {
			if (current_account == 'all') jQuery('#Buttons_List_3_Thread #editthread').hide();
			else jQuery('#Buttons_List_3_Thread #editthread').show();
		
			jQuery('#Buttons_List_3_Thread #go2inbox').hide();
			jQuery('#Buttons_List_3_Thread #go2folder').hide();
			if (isMultiAccount && fastinbox) {
				jQuery('#Buttons_List_3_Thread #go2inbox').show();
			} else {
				jQuery('#Buttons_List_3_Thread #go2folder').show();
			}
		}
	}
	if (mode != '') mode = '_'+mode;
	jQuery('#Buttons_List_3_'+view+mode).show();
}


function changeLeftView(view,dim_folder,dim_list,name,label) {
	if (view == 'accounts') {
		//basic_search_submitted = false;
		//jQuery('#basic_search_icn_canc').click();
		jQuery('#Accounts').show();
		jQuery('#Folders').hide();
		jQuery('#ListViewContents').hide();
		jQuery('#Accounts').parent().css('width',dim_list);
		jQuery('#Folders').parent().css('width',dim_folder);
		jQuery('#ListViewContents').css('width',dim_folder);
		jQ191('#Accounts').slimScroll({ scrollTo: '0px' });
		
		changeButtons('Accounts');
		
	} else if (view == 'folders') {
		//crmv@42846
		if (jQuery('#basic_search_icn_canc').css('display') != 'none') current_folder = '';	//forzo per ricaricare la lista
		basic_search_submitted = false;
		jQuery('#basic_search_icn_canc').click();
		//crmv@42846e
		jQuery('#Accounts').hide();
		jQuery('#ListViewContents').hide();
		jQuery('#Accounts').parent().css('width',dim_folder);
		jQuery('#Folders').parent().css('width',dim_list);
		jQuery('#ListViewContents').css('width',dim_folder);
		jQ191('#Folders').slimScroll({ scrollTo: '0px' });
		
		changeButtons('Folders');
		
		if (name != undefined && current_account != name) {
			jQuery('#Folders').html('');
			jQuery('#Folders').show();
			current_account = name;
			current_folder = '';	//forzo per ricaricare la lista
			reloadFolders();
		} else {
			jQuery('#Folders').show();
		}
	} else if (view == 'list') {
		jQuery('#Accounts').hide();
		jQuery('#Folders').hide();
		jQuery('#Accounts').parent().css('width',dim_folder);
		jQuery('#Folders').parent().css('width',dim_folder);
		jQuery('#ListViewContents').css('width',dim_list);
		
		if (iAmInThread)
			changeButtons('ListView','','',true);
		else
			changeButtons('ListView');
		
		if (current_folder != name) {
			jQuery('#ListViewContents').html('');
			jQuery('#ListViewContents').show();
			current_folder = name;
			//crmv@48159
			if (current_folder == specialFolders['INBOX'] || current_folder == specialFolders['Sent']) {
				jQuery('#empty_button').hide();
			} else {
				jQuery('#empty_button').show();
			}
			//crmv@48159e
			jQuery('#ListViewContents').css('visibility','hidden');	//non svuotare il contenuto perch� viene letto l'input search_url
			if (iAmInThread == false)
				jQuery('#rec_string').parent().html('<span class="listMessageTitle">'+label+'</span><span id="rec_string" style="display:none"></span><span id="rec_string3"></span>');
			var search = '';
			if (jQuery('#basic_search_icn_canc').css('display') != 'none') {
				search = '&query=true&search_field=&searchtype=BasicSearch&search_text='+encodeURIComponent(jQuery('#basic_search_text').val());
			}
			getListViewEntries_js('Messages','start=1&account='+current_account+'&folder='+name+search,false);
			jQuery('#ListViewContents').css('visibility','visible');
			setmCustomScrollbar('#ListViewContents');
			update_navigation_values(window.location.href+'&account='+current_account+'&folder='+name,'Messages',false);
		} else {
			jQuery('#ListViewContents').show();
		}
	}
	fninvsh('mode2Folder');
}

function editViewList(show,skip_update_flag,force_reload) {
	if (show) {
		resetDetailViewButtons();
		list_status = 'edit';
		jQuery('.lvtColDataHoverMessage').removeClass('lvtColDataHoverMessage');	//crmv@48159
		jQuery('#Buttons_List_3_ListView_Edit .listMessageTitle').html(jQuery('#Buttons_List_3_ListView .listMessageTitle').html());
		changeButtons('ListView','Edit','',true);
		jQuery('input:checkbox[name="selected_id"]').show();
	} else {
		unselectAllIds();
		list_status = 'view';
		selectRecord(current_record,skip_update_flag,force_reload);
		if (jQuery('#Button_List_Detail').html() == '') {
			reloadDetailViewButtons(current_record);
		}
		changeButtons('ListView','','',true);
		jQuery('input:checkbox[name="selected_id"]').hide();
	}
	fninvsh('mode2Folder');
}

function populateTurbolift(recordid) {
	jQuery.ajax({
		url: 'index.php?module=Messages&action=MessagesAjax&file=Turbolift&record='+recordid,
		dataType: 'html',
		success: function(data) {
			jQuery('#TurboliftContents').html(data);
		},
		error: function() {
			jQuery('#TurboliftContents').html('Network error');
		}
	});
}

function selectRecord(id,skip_update_flag,force_reload,skip_reload_turbolift,async) {
	if (id == '') return false;
	if (skip_update_flag != true) skip_update_flag = false;
	if (force_reload != true) force_reload = false;
	if (skip_reload_turbolift != true) skip_reload_turbolift = false;
	if (async == undefined) async = true;

	if (list_status == 'edit') {

		if (jQuery("input:checkbox#"+id).attr('checked')) {
			jQuery('#row_'+id).removeClass('lvtColDataHoverMessage');
			jQuery("input:checkbox#"+id).attr('checked',false);
		} else {
			jQuery('#row_'+id).addClass('lvtColDataHoverMessage');
			jQuery("input:checkbox#"+id).attr('checked',true);
		}
		jQuery("input:checkbox#"+id).triggerHandler('click');

	} else {
		if (ajax_enable == false) return false;
		ajax_enable = false;

		jQuery('#ListViewContents [id^="row_"]').removeClass('lvtColDataHoverMessage');
		jQuery('#row_'+id).addClass('lvtColDataHoverMessage');

		if (force_reload || current_record != id) {
			var params = "&account="+current_account+"&folder="+current_folder;
			current_record = id;
			$("status").style.display = "inline";
			jQuery.ajax({
				url: 'index.php?module=Messages&action=MessagesAjax&file=DetailView&mode=ListView&record='+id+params,
				dataType: 'html',
				async: async,
				success: function(data){
					$("status").style.display = "none";
					jQ191('#DetailViewContents').slimScroll({ scrollTo: '0px' });
					jQuery('#DetailViewContents').html('');
					var width = jQuery('#DetailViewContents').width()-20;
					jQuery('#DetailViewContents').html(data);
					jQuery('#DetailViewContentDescr').width(width);
					if (skip_reload_turbolift == false) {
						populateTurbolift(id);
					}
					if (skip_update_flag == false && jQuery('#flag_'+id+'_unseen').css('display') == 'block') {
						//flag(id,'seen',1);
						jQuery('#flag_'+id+'_unseen').hide();
						update_navigation_values("module=Messages&action=MessagesAjax&file=ListView&ajax=true&account="+current_account+"&folder="+current_folder+'&reload_counts=yes','Messages',true,updateCounts);	//crmv@48471
					}
					ajax_enable = true;
				}
			});
			fninvsh('mode2Folder');
		} else {
			ajax_enable = true;
		}
	}
}

function getLuckyMessage(folder,id) {
	return getFile('index.php?module=Messages&action=MessagesAjax&file=LuckyMessage&account='+current_account+'&folder='+folder+'&record='+id);
}

function selectLuckyMessage(folder,id) {
	$("status").style.display = "inline";
	var record = getLuckyMessage(folder,id);
	$("status").style.display = "none";
	if (record != '') selectRecord(record);
}

function showHeaderDetails(type) {
	if (type == 'small') {
		jQuery('#header_detail_large').hide();
		jQuery('#header_detail_small').show();
		jQuery('#header_detail_large_link').show();
		jQuery('#header_detail_small_link').hide();
	} else if (type == 'large') {
		jQuery('#header_detail_small').hide();
		jQuery('#header_detail_large').show();
		jQuery('#header_detail_large_link').hide();
		jQuery('#header_detail_small_link').show();
	}
}

function resetDetailViewButtons() {
	jQuery('#Button_List_Detail').html('');
}

function resetDetailView() {
	jQuery('#DetailViewContents').html('');
	resetDetailViewButtons();
}

function flag(id,flag,value) {
	$("status").style.display = "inline";
	var postbody = "module=Messages&action=MessagesAjax&file=Flag&record="+id+"&flag="+flag+"&value="+value;
	new Ajax.Request(
		'index.php',
		{queue: {position: 'end', scope: 'command'},
		method : 'post',
		postBody : postbody,
		onComplete : function(response) {
			$("status").style.display = "none";
			result = response.responseText;
			if (response.responseText == 'SUCCESS') {
				if (flag == 'delete') {
					jQuery('#row_'+id).remove();
					resetDetailView();
					selectLuckyMessage(current_folder,id);
				} else {
					if (flag == 'seen') {
						if (value == 0) {
							jQuery('#flag_'+id+'_unseen').show();
						} else {
							jQuery('#flag_'+id+'_unseen').hide();
						}
					} else if (flag == 'flagged') {
						if (value == 1) {
							jQuery('#flag_'+id+'_flagged').show();
						} else {
							jQuery('#flag_'+id+'_flagged').hide();
						}
					}
					reloadDetailViewButtons(id);
				}
				update_navigation_values("module=Messages&action=MessagesAjax&file=ListView&ajax=true&account="+current_account+"&folder="+current_folder+'&reload_counts=yes','Messages',true,updateCounts);	//crmv@48471
			}
		}
	});
}

function reloadDetailViewButtons(id) {
	var postbody = "module=Messages&action=MessagesAjax&file=DetailViewButtons&record="+id;
	new Ajax.Request(
		'index.php',
		{queue: {position: 'end', scope: 'command'},
		method : 'post',
		postBody : postbody,
		onComplete : function(response) {
			jQuery('#Button_List_Detail').html(response.responseText);
		}
	});
}

function massFlag(action) {
	var module = 'Messages';
	var idstring = get_real_selected_ids(module);
	if (idstring.substr('0', '1') == ";")
		idstring = idstring.substr('1');
	var idarr = idstring.split(';');
	var count = idarr.length;
	var xx = count - 1;
	var viewid = getviewId();
	if (idstring == "" || idstring == ";" || idstring == 'null') {
		alert(alert_arr.SELECT);
		return false;
	} else {
		if (action == 'Delete') {
			var postbody = "module=Users&action=massdelete&return_module="+module+"&"+gstart+"&viewname="+viewid;
		} else {
			var postbody = "module="+module+"&action="+module+"Ajax&file=MassFlag&massaction="+action+"&"+gstart+"&viewname="+viewid;
		}
		postbody += "&account="+current_account+"&folder="+current_folder+"&thread="+getObj('thread').value;

		var postbody2 = "module="+module+"&action="+module+"Ajax&file=ListView&ajax=true&"+gstart+"&viewname="+viewid;
		postbody2 += "&account="+current_account+"&folder="+current_folder+"&thread="+getObj('thread').value;

		VtigerJS_DialogBox.block();
		$("status").style.display = "inline";
		new Ajax.Request(
			'index.php',
			{queue: {position: 'end', scope: 'command'},
			method : 'post',
			postBody : postbody,
			onComplete : function(response) {
				VtigerJS_DialogBox.unblock();
				$("status").style.display = "none";

				result = response.responseText.split('&#&#&#');
				$("ListViewContents").innerHTML = result[2];
				if (result[1] != '')
					alert(result[1]);
				$('basicsearchcolumns').innerHTML = '';
				setmCustomScrollbar('#ListViewContents');

				if (action == 'Delete') {
					current_record = getLuckyMessage(current_folder,'');
				}

				if (iAmInThread)
					editViewThread(false,true,true);
				else
					editViewList(false,true,true);
				
				update_navigation_values(postbody2+'&reload_counts=yes','Messages',true,updateCounts);	//crmv@48471
			}
		});
	}
}

function preView(module,id) {
	if (ajax_enable == false) return false;
	ajax_enable = false;

	if (id == preview_id && preview_current_record != '') {
		ajax_enable = true;

		var preViewTbl = jQuery('#preView'+id+' .previewEntitySelected');
		preViewTbl.removeClass('previewEntitySelected');
		preViewTbl.addClass('previewEntity');
		selectRecord(preview_current_record,false,true,true);
		preview_current_record = '';
	} else {
		jQuery('.previewEntitySelected').addClass('previewEntity');
		jQuery('.previewEntitySelected').removeClass('previewEntitySelected');
		var preViewTbl = jQuery('#preView'+id+' .previewEntity');
		preViewTbl.removeClass('previewEntity');
		preViewTbl.addClass('previewEntitySelected');

		$("status").style.display = "inline";
		jQuery.ajax({
			url: 'index.php?module='+module+'&action='+module+'Ajax&file=PreView&record='+id+'&return_module=Messages&return_id='+current_record,
			dataType: 'html',
			success: function(data){
				$("status").style.display = "none";
				preview_id = id;
				if (current_record != '') {
					preview_current_record = current_record;
					current_record = '';
				}
				resetDetailViewButtons();
				jQ191('#DetailViewContents').slimScroll({ scrollTo: '0px' });
				jQuery('#DetailViewContents').html(data);

				ajax_enable = true;
			}
		});
	}
}

function MoveDisplay(obj,mode,id,folder) {
	if (folder == '' || folder == 'undefined' || folder == undefined) {
		var folder = current_folder;
	}
	if (mode == 'mass') {
		var idstring = get_real_selected_ids('Messages');
		if (idstring.substr('0', '1') == ";")
			idstring = idstring.substr('1');
		var idarr = idstring.split(';');
		var count = idarr.length;
		var xx = count - 1;
		if (idstring == "" || idstring == ";" || idstring == 'null') {
			alert(alert_arr.SELECT);
			return false;
		}
	}
	jQuery('#mode2Folder_list').html('');
	fnvshobj(obj,'mode2Folder');
	jQuery('#indicatorMode2Folder').show();
	var url = 'index.php?module=Messages&action=MessagesAjax&file=Move&mode='+mode+'&view=display&account='+current_account+'&current_folder='+folder;
	if (mode == 'single') {
		url += '&record='+id;
	}
	jQuery.ajax({
		url: url,
		dataType: 'html',
		success: function(data){
			jQuery('#indicatorMode2Folder').hide();
			jQuery('#mode2Folder_list').html(data);
		}
	});
}

function Move(folder,id) {
	$("status").style.display = "inline";
	jQuery.ajax({
		url: 'index.php?module=Messages&action=MessagesAjax&file=Move&folder='+folder+'&mode=single&record='+id+'&account='+current_account+'&current_folder='+current_folder+'&thread='+getObj('thread').value,
		dataType: 'html',
		success: function(data){
			$("status").style.display = "none";
			jQuery('#TurboliftContents').html('');
			current_record = '';
			jQuery('#row_'+id).remove();
			resetDetailView();
			selectLuckyMessage(current_folder,id);

			var viewid = getviewId();
			var postbody2 = "module=Messages&action=MessagesAjax&file=ListView&ajax=true&"+gstart+"&viewname="+viewid;
			mainPage.update_navigation_values(postbody2+'&reload_counts=yes','Messages',false,updateCounts);	//crmv@48471
			fninvsh('mode2Folder');
		}
	});
}

function massMove(folder) {
	VtigerJS_DialogBox.block();
	jQuery.ajax({
		url: 'index.php?module=Messages&action=MessagesAjax&file=Move&folder='+folder+'&mode=mass&account='+current_account+'&current_folder='+current_folder+'&thread='+getObj('thread').value,
		dataType: 'html',
		success: function(data){
			VtigerJS_DialogBox.unblock();
			jQuery('#TurboliftContents').html('');
			resetDetailView();
			current_record = getLuckyMessage(current_folder,'');

			result = data.split('&#&#&#');
			$("ListViewContents").innerHTML = result[2];
			if (result[1] != '')
				alert(result[1]);
			$('basicsearchcolumns').innerHTML = '';
			setmCustomScrollbar('#ListViewContents');

			if (iAmInThread)
				editViewThread(false,true,true);
			else
				editViewList(false,true,true);

			var viewid = getviewId();
			var postbody2 = "module=Messages&action=MessagesAjax&file=ListView&ajax=true&"+gstart+"&viewname="+viewid;
			update_navigation_values(postbody2+'&reload_counts=yes','Messages',true,updateCounts);	//crmv@48471
			fninvsh('mode2Folder');
		}
	});
}

function selectThread(id,father,count,label) {
	if (list_status == 'edit') {
		return false;
	}
	if (ajax_enable == false) return false;
	ajax_enable = false;

	iAmInThread = true;
	last_thread_clicked = id;
	jQuery('#ListViewContents [id^="row_"]').removeClass('lvtColDataHoverMessage');
	jQuery('#row_'+id).addClass('lvtColDataHoverMessage');

	var folder_label = jQuery('#Buttons_List_3_ListView .listMessageTitle').html();
	//jQuery('#ListViewContents').hide();	//non svuotare il contenuto perch viene letto l'input search_url
	changeButtons('Thread');
	jQuery('#Buttons_List_3_Thread .threadMessageTitle').html(count+' '+label);
	jQuery('#Buttons_List_3_Thread #go2folder').val('< '+folder_label);
	jQuery('#Buttons_List_3_Thread #go2inbox').val('< '+folder_label);
	getListViewEntries_js('Messages','start=1&account='+current_account+'&folder='+current_folder+'&thread='+father,false);
	jQuery('#ListViewContents').show();
	setmCustomScrollbar('#ListViewContents');
	//update_navigation_values(window.location.href+'&account='+current_account+'&folder='+current_folder+'&thread='+father,'Messages');

	ajax_enable = true;

	selectRecord(id);
}

function returnToFolder(dim_folder,dim_list) {
	var folder = current_folder;
	current_folder = '';	//forzo per ricaricare la lista
	changeLeftView('list',dim_folder,dim_list,folder,jQuery('#go2folder').val().replace('< ',''));
	jQuery('#go2folders').show();
	jQuery('#go2folder').hide();
	jQuery('#Buttons_List_3_Lx #go2accounts').show();
	jQuery('#Buttons_List_3_Lx #go2inbox').hide();
	jQuery('#ListViewContents [id^="row_"]').removeClass('lvtColDataHoverMessage');
	jQuery('#row_'+last_thread_clicked).addClass('lvtColDataHoverMessage');
	current_record = last_thread_clicked;
	iAmInThread = false;
}

function returnToINBOXFolder(dim_folder,dim_list) {
	var folder = current_folder;
	current_folder = '';	//forzo per ricaricare la lista
	changeLeftView('list',dim_folder,dim_list,folder,jQuery('#Buttons_List_3_Lx #go2inbox').val().replace('< ',''));
	jQuery('#ListViewContents [id^="row_"]').removeClass('lvtColDataHoverMessage');
	jQuery('#row_'+last_thread_clicked).addClass('lvtColDataHoverMessage');
	current_record = last_thread_clicked;
	iAmInThread = false;
}

function emptyFolder() {
	VtigerJS_DialogBox.block();
	jQuery.ajax({
		url: 'index.php?module=Messages&action=MessagesAjax&file=EmptyFolder&account='+current_account+'&folder='+current_folder,
		dataType: 'html',
		success: function(data){
			VtigerJS_DialogBox.unblock();
			editViewList(false);
			resetDetailView();
			jQuery('#TurboliftContents').html('');
			jQuery('#ListViewContents').html('');
			current_record = '';
			current_folder = '';
			reloadFolders();
			fninvsh('mode2Folder');
			jQuery('#go2folders').click();
		}
	});
}

//crmv@42752 crmv@43050
function openMessagesPopup(id,mode, extraParams) {

	if (!extraParams) extraParams = {};

	if (mode == 'addsender' || mode == 'addrecipient') {
		extraParams['show_only'] = 'create';
		extraParams['onlypeople'] = 'true';

	} else if (mode == 'onlycreate') {
		extraParams['show_only'] = 'create';

	} else if (mode == 'compose') {
		// get ids of recipients
		var idlist = [];
		jQuery('#autosuggest_to .addrBubble').each(function(index, item) {
			var parts = item.id.split('_');
			idlist.push(parts[1]);
		});
		extraParams['idlist'] = idlist.join(';');

	}

	openLinkPopup(id, mode, extraParams);
	}
// crmv@43050e

function openEventCreate(id, type) {
	if (type === undefined || type === null) type = 'Events';

	var cont = jQuery('#messageCalendarCont');

	var url = 'index.php?module=Messages&action=MessagesAjax&file=CreateEvent&activity_mode='+type+'&messageid='+id;
	openPopup(url,"","width=750,height=602,menubar=no,toolbar=no,location=no,status=no,resizable=no,scrollbars=yes");
}

function popupShowActivity() {
	VtigerJS_DialogBox.block();
	jQuery('#status').show();

}

function popupHideActivity() {
	jQuery('#status').hide();
	VtigerJS_DialogBox.unblock();
}

function messagesSaveEvent() {
	var activityType = document.EditView.activity_mode.value,
		messageid = jQuery('#messageid').val();

	document.EditView.action.value='Save';

	//set some global vars
	userDateFormat = parent.userDateFormat;
	SDKValidate = parent.SDKValidate;
	alert_arr = parent.alert_arr;

	if (activityType == 'Task') {
		maintask_check_form();
		var validForm = formValidate();
	} else {
		var validForm = check_form();
	}

	if (validForm) {
		popupShowActivity();
		jQuery.ajax({
			url: jQuery(document.EditView).attr('action'),
			data: jQuery(document.EditView).serialize()+'&ajaxCalendar=messagesAdd&messageid='+messageid,
			type: 'POST',
			complete: function() {
				popupHideActivity();
			},
			success: function(data) {
				if (!data) return alert(alert_arr.ERROR+': '+data);
				try {
					var ret = jQuery.parseJSON(data);
				} catch (e) {
					return alert(alert_arr.ERROR+': '+data);
				}

				var activityid = ret.activityid;
				if (!activityid) return alert(alert_arr.ERROR+': '+data);

				// now link
				popupClickLinkModule('Calendar', activityid);
			},
			error: function() {
				alert(alert_arr.ERROR);
			}
		});
	}
}

function messagesPopClickMod(module, viewid, searchstr, page) {
	var mode = jQuery('#popup_mode').val(),
		messageid = jQuery('#messageid').val(),
		parent_mod = jQuery('#parent_module').val(),
		data = jQuery('#relevant_ids').val(),
		action = jQuery('#default_link_action').val(),
		listCont = jQuery('#linkMsgListCont'),
		editCont = jQuery('#linkMsgEditCont');

	gVTModule = module;
	if (!viewid) viewid = '';
	if (!searchstr) searchstr = '';
	if (!page) page = 1;

	if (action == 'create') {
		return popupShowCreatePanel(module);
	}

	popupShowActivity();
	jQuery.ajax({
		url: 'index.php?module=Messages&action=MessagesAjax&file=PopupLinkList',
		type: 'POST',
		data: 'popup_mode='+mode+'&mod='+module+'&parentid='+messageid+'&related_ids='+encodeURIComponent(data)+'&viewid='+viewid+'&search='+encodeURIComponent(searchstr)+'&page='+page+'&parent_module='+encodeURIComponent(parent_mod), // crmv@43050
		complete: function() {
			popupHideActivity();
		},
		success: function(data) {
			listCont.hide();
			jQuery('#linkMsgDescrCont').hide();
			jQuery('#linkMsgDetailCont').hide();
			editCont.hide();
			listCont.html(data).fadeIn('fast');
		}
	});
}

function popupChangeFilter(module) {
	var viewid = jQuery('#viewname').val(),
		search = jQuery('#basic_search_text').val();
	return messagesPopClickMod(module, viewid);
}

function popupCallSearch(module) {
	var search = jQuery('#basic_search_text').val(),
		viewid = jQuery('#viewname').val();

	messagesPopClickMod(module, viewid, search);
	basic_search_submitted = true;
	return false;
}

function popupCallPagination(module) {
	var page = jQuery('#navigationPage').val();

	return popupGotoPage(page);
}

function popupGotoPage(page) {
	var module = jQuery('#popupModule').val(),
		search_plc = jQuery('#search_placeholder').val(),
		search = jQuery('#basic_search_text').val(),
		viewid = jQuery('#viewname').val(),
		currPage = jQuery('#navigationPageOrig').val(),
		totPages = jQuery('#navigationPageTotal').val();

	page = Math.max(1, Math.min(parseInt(page), totPages));
	if (page == currPage) return false;

	if (search == search_plc) search = '';

	messagesPopClickMod(module, viewid, search, page);
	return false;
}

function popupGotoNextPage() {
	var currPage = jQuery('#navigationPageOrig').val();
	return popupGotoPage(currPage+1);
}

function popupGotoPrevPage() {
	var currPage = jQuery('#navigationPageOrig').val();
	return popupGotoPage(currPage-1);
}

function popupOpenDetail(module, crmid) {
	var messageid = jQuery('#messageid').val(),
		parent_mod = jQuery('#parent_module').val(),
		callback_link = jQuery('#callback_link').val(),
		descrCont = jQuery('#linkMsgDescrCont'),
		listCont = jQuery('#linkMsgListCont'),
		detailCont = jQuery('#linkMsgDetailCont'),
		editCont = jQuery('#linkMsgEditCont'),
		attachCont = jQuery('#linkMsgAttachCont');

	popupShowActivity();
	descrCont.hide();
	listCont.hide();
	jQuery.ajax({
		url: 'index.php?module=Messages&action=MessagesAjax&file=PopupDetailForm',
		type: 'POST',
		data: 'mod='+module+'&parentid='+messageid+'&record='+crmid+'&parent_module='+encodeURIComponent(parent_mod) + '&callback_link='+encodeURIComponent(callback_link), // crmv@43050
		success: function(data) {
			detailCont.html(data);

			// set magic scrolling
			jQ191('#linkMsgDetailCont').slimScroll({
				wheelStep: 10,
				height: msgRightTopHeight+'px',
				width: '100%'
			});
			detailCont.fadeIn('fast');
			attachCont.fadeIn('fast');
		},
		complete: function() {
			popupHideActivity();
		}
	});
}

// get list of contentids to attach
function getAttachmentsToLink() {
	var globalCheck = jQuery('#popupMsgAttachMainCheck').is(':checked'),
		list = [];
	if (globalCheck) {
		jQuery('#popupAttachDiv input[id^=msgattach_]:checked').each(function(index, item) {
			list.push(item.id.replace('msgattach_', ''));
		});
	}
	return list;
}

function popupClickLinkModule(module, crmid) {
	var parentid = jQuery('#messageid').val();
	var mode = jQuery('#popup_mode').val();

	popupShowActivity();
	if (mode == 'compose') {
		jQuery.ajax({
			url: 'index.php?module=Messages&action=MessagesAjax&file=Card',
			data: '&idlist='+crmid,
			type: 'POST',
			success: function(data, status, xhr) {
				if (!data.match(/error/i)) {
					//alert(alert_arr.LBL_MESSAGE_LINKED);
					window.top.jQuery('#ComposeLinks').append(data);
					window.top.jQuery('#relation').val(window.top.jQuery('#relation').val()+'|'+crmid);

					// close popup
					closePopup();
				}
			},
			complete: function() {
				popupHideActivity();
			}
		});
	} else {
		// crmv@43050
		linkModules('Messages', parentid, module, crmid,
			{
				'mode' : mode
			},
			function(data) {
				if (!data.match(/error/i)) {
					//alert(alert_arr.LBL_MESSAGE_LINKED);
					var attList = getAttachmentsToLink();

					window.top.jQuery('#flag_'+parentid+'_relations').show();
					if (mode == 'linkdocument') {
						window.top.saveDocument(parentid,jQuery('#contentid').val(),crmid,module);
					} else if (attList.length > 0) {
						for (var i=0; i<attList.length; ++i) {
							window.top.saveDocument(parentid,attList[i],crmid,module);
						}
					}
					window.top.selectRecord(parentid,false,true);
					popupHideActivity();
					// close popup
					closePopup();
				} else {
					//alert(alert_arr.LBL_RECORD_SAVE_ERROR);
				}
			}
		);
		// crmv@43050e

		/*jQuery.ajax({
			url: 'index.php?module=Messages&action=MessagesAjax&file=updateRelations',
			data: 'no_redirect=1&mode='+mode+'&destination_module='+module+'&idlist='+crmid+'&parentid='+parentid,
			type: 'POST',
			success: function(data, status, xhr) {

			},
		});*/
	}
}

function popupShowCreatePanel(module) {
	var messageid = jQuery('#messageid').val(),
		mode = jQuery('#popup_mode').val(), // crmv@43050
		descrCont = jQuery('#linkMsgDescrCont'),
		listCont = jQuery('#linkMsgListCont'),
		editCont = jQuery('#linkMsgEditCont'),
		attachCont = jQuery('#linkMsgAttachCont'),
		original_email = jQuery('#original_email').val(),
		original_name = jQuery('#original_name').val(),
		data = jQuery('#relevant_ids').val();

	popupShowActivity();
	descrCont.hide();
	listCont.hide();
	jQuery.ajax({
		url: 'index.php?module=Messages&action=MessagesAjax&file=PopupCreateForm',
		type: 'POST',
		data: 'mod='+module+'&parentid='+messageid+'&related_ids='+encodeURIComponent(data)+'&original_email='+encodeURIComponent(original_email)+'&original_name='+encodeURIComponent(original_name)+'&popup_mode='+encodeURIComponent(mode), //crmv@43050
		success: function(data) {
			editCont.html(data);

			// set magic scrolling
			jQ191('#linkMsgEditCont').slimScroll({
				wheelStep: 10,
				height: msgRightTopHeight+'px',
				width: '100%'
			});
			editCont.fadeIn('fast');
			attachCont.fadeIn('fast');
		},
		complete: function() {
			popupHideActivity();
		}
	});

}

function destroySlimscroll(objectId) {
	jQuery("#"+objectId).parent('.slimScrollDiv').replaceWith(jQuery("#"+objectId));
}

function popupCreateCancel() {
	var messageid = jQuery('#messageid').val(),
		action = jQuery('#default_link_action').val(),
		descrCont = jQuery('#linkMsgDescrCont'),
		listCont = jQuery('#linkMsgListCont'),
		detailCont = jQuery('#linkMsgDetailCont'),
		editCont = jQuery('#linkMsgEditCont'),
		attachCont = jQuery('#linkMsgAttachCont');

	editCont.html('').hide();
	attachCont.hide();
	if (action == 'create') {
		//descrCont.show();
		closePopup();
	} else {
		destroySlimscroll('linkMsgDetailCont');
		destroySlimscroll('linkMsgEditCont');
		detailCont.html('').hide();
		listCont.height(msgRightTopHeight+'px').show();
	}
}

function popupCreateSave(module) {
	var messageid = jQuery('#messageid').val(),
		descrCont = jQuery('#linkMsgDescrCont'),
		listCont = jQuery('#linkMsgListCont'),
		editCont = jQuery('#linkMsgEditCont');

	// get global vars
	userDateFormat = parent.userDateFormat;
	SDKValidate = parent.SDKValidate;
	alert_arr = parent.alert_arr;

	document.EditView.action.value = 'Save';

	var valid = formValidate(document.EditView);

	if (module == 'Accounts'){
	 	if (isdefined('external_code')){
	 		var ext = getObj('external_code').value;
	 		var exttype = getObj('external_code').type;
	 		if ( (trim(ext) != '') && (exttype != "hidden") ) {
	 			if (!AjaxDuplicateValidateEXT_CODE(module,'external_code','','editview'))
	 				valid = false;
	 		}
	 	}
	 }

	if (!valid) return;

	popupShowActivity();
	jQuery.ajax({
		url: jQuery(document.EditView).attr('action'),
		data: jQuery(document.EditView).serialize()+'&ajaxCalendar=messagesAdd&messageid='+messageid,
		type: 'POST',
		complete: function() {
			popupHideActivity();
		},
		success: function(data, status, xhr) {
			if (!data) return alert(alert_arr.ERROR+': '+data);

			// AARRRGHH! the only way to get the recordid is to parse all the response
			var searchStr = '<input type="hidden" name="record" value="',
				ipos = data.indexOf(searchStr);

			if (ipos > -1) {
				var recordInput = data.substr(ipos+searchStr.length, 10),
					matches = recordInput.match(/^[0-9]+/),
					recordid = matches ? matches[0] : 0;

				if (recordid > 0) {
					// linka e fa documenti
					popupClickLinkModule(module, recordid);
				}
			}

		},
		error: function() {
			alert(alert_arr.ERROR);
		}
	});

}

function messagesChangeAttach() {
	var checked = jQuery('#popupMsgAttachMainCheck').is(':checked');
	jQuery('#popupAttachDiv .popupMsgAttachCheck').attr('checked', (checked ? "checked" : false));
}

function messagesChangeSingleAtt(item) {
	if (item.checked) {
		jQuery('#popupMsgAttachMainCheck').attr('checked', 'checked');
	}
}
//crmv@42752e

// REMOVED CODE

//crmv@48159
function appendFetch() {
	if (ajax_enable == false) return false;
	ajax_enable = false;
	$("status").style.display="inline";
	jQ191("#ListViewContents").mCustomScrollbar("disable");

	update_navigation_values(window.location.href+'&account='+current_account+'&folder='+current_folder,'Messages',false);	// ricarico navigation
	if (jQ191("#appendNextListViewEntries").length > 0) {							// se c'� un'altra pagina scorro
		jQ191('#appendNextListViewEntries').click();
	} else {																		// altrimenti resto fermo in fondo pagina
		jQ191('#indicatorAppend').hide();
		jQ191("#ListViewContents").mCustomScrollbar("update");
		jQ191("#ListViewContents").mCustomScrollbar("scrollTo",'-10');
	}
	reloadFolders();
	$("status").style.display="none";

	ajax_enable = true;
	fninvsh('mode2Folder');
}
//crmv@48159e

function appendListViewEntries_js(module,url,async)
{
	jQuery('#indicatorAppend').show();
	jQuery('#appendNextListViewEntries').remove();
	jQ191("#ListViewContents").mCustomScrollbar("disable");

	if (ajaxcall_list){
		ajaxcall_list.abort();
	}
	if (ajaxcall_count){
		ajaxcall_count.abort();
	}
    var viewid =getviewId();
    if(isdefined('search_url'))
		urlstring = $('search_url').value;
    else
		urlstring = '';
    if (isdefined('selected_ids'))
    	urlstring += "&selected_ids=" + document.getElementById('selected_ids').value;
    if (isdefined('all_ids'))
    	urlstring += "&all_ids=" + document.getElementById('all_ids').value;
    if (isdefined('modulename'))
    	var modulename=document.getElementById('modulename').value;
    else
    	modulename = '';
    gstart = url;
    postbody = "module="+module+"&modulename="+modulename+"&action="+module+"Ajax&file=ListView&ajax=true&appendlist=yes&"+url+urlstring;
    if (async == undefined) {
    	async = true;
    }
    jQuery.ajax({
		url: 'index.php',
		type: 'POST',
		dataType: 'html',
		data: postbody,
		async: async,
		success: function(data){
			result = data.split('@#@#@#');
			jQuery("#nav_buttons").html(result[1]);
            jQuery("#MessagesRowList").append(result[2]);
            jQ191("#ListViewContents").mCustomScrollbar("update");
           	jQuery('#indicatorAppend').hide();
		}
	});
}

function saveDocument(record,contentid,linkto,linkto_module,reload_record) {
	$("status").style.display="inline";
	VtigerJS_DialogBox.block();
	var params = 'module=Messages&action=MessagesAjax&file=SaveDocument&record='+record+'&contentid='+contentid;
	if (linkto != '' && linkto != 'undefined' && linkto != undefined) {
		params += '&linkto='+linkto+'&linkto_module='+linkto_module;
	}
	jQuery.ajax({
		url: 'index.php',
		type: 'POST',
		//async: false,	// crmv@42752 why??
		data: params,
		success: function(data, status, xhr) {
			if (data.indexOf('SUCCESS')>=0) {
				jQuery('#flag_'+record+'_relations').show();
				if (reload_record == 'yes') {
					selectRecord(record,false,true);
				}
			} else {
				//alert(alert_arr.LBL_RECORD_SAVE_ERROR);
			}
		},
		error: function() {
			//alert(alert_arr.LBL_RECORD_SAVE_ERROR);
		},
		complete: function() {
			$("status").style.display="none";
			VtigerJS_DialogBox.unblock();
		},
	});
}

// crmv@42752
function saveDocumentAndLink(record,contentid) {
	openMessagesPopup(record, 'linkdocument', {'contentid':contentid});
}
//crmv@42752e

function editViewFolders(show) {
	jQuery('input:radio[name="selected_folder"]:checked').attr('checked',false);
	if (show) {
		folders_status = 'edit';
		changeButtons('Folders','Edit','',true);
		jQuery('input:radio[name="selected_folder"]').show();
	} else {
		folders_status = 'view';
		changeButtons('Folders','','',true);
		jQuery('input:radio[name="selected_folder"]').hide();
	}
}

function folderAction(obj,action) {
	var selected_folder = jQuery('input:radio[name="selected_folder"]:checked').val();
	if (action != 'create') {
		if (selected_folder == '' || selected_folder == 'undefined' || selected_folder == undefined) {
			alert(alert_arr.LBL_SELECT_DEL_FOLDER);
			return false;
		}
	}
	switch(action) {
		case 'seen':
	  		var value = 0;
	  	case 'unseen':
	  		$("status").style.display = "inline";
		  	var value = 1;
		    jQuery.ajax({
				url: 'index.php?module=Messages&action=MessagesAjax&file=FolderFlag&faction='+action+'&account='+current_account+'&folder='+selected_folder,
				dataType: 'html',
				success: function(data) {
					$("status").style.display = "none";
					current_folder = '';	//forzo per ricaricare la lista
					editViewFolders(false);
					reloadFolders();
				}
			});
	  	break;
		case 'move':
	    	MoveDisplay(obj,'folders','',selected_folder);
	  	break;
	  	case 'create':
	    	CreateFolderDisplay(obj,selected_folder);
	  	break;
	}
}

function selectFolder(dim_folder,dim_list,foldername,folderlabel) {
	if (folders_status == 'edit') {
		fninvsh('mode2Folder');
		var selector = encodeURIComponent(foldername).replace(/\%/g,'\\%');
		if (jQuery("input:radio#check_"+selector).attr('checked')) {
			jQuery("input:radio#check_"+selector).attr('checked',false);
		} else {
			jQuery("input:radio#check_"+selector).attr('checked',true);
		}
	} else {
		changeLeftView('list',dim_folder,dim_list,foldername,folderlabel);
		if (foldername != specialFolders['INBOX']) fetch(5000);	//crmv@48471
	}
}

function selectINBOXFolder(dim_folder,dim_list,account,foldername,folderlabel) {
	if (current_account != account){
		current_folder = '';
		current_account = account;
	}
	selectFolder(dim_folder,dim_list,foldername,folderlabel);
	changeButtons('ListView','',true);
}

function selectAccount(view,dim_folder,dim_list,name,label) {
	changeLeftView(view,dim_folder,dim_list,name,label);
}

function folderMove(folder) {
	$("status").style.display = "inline";
	var selected_folder = jQuery('input:radio[name="selected_folder"]:checked').val();
	jQuery.ajax({
		url: 'index.php?module=Messages&action=MessagesAjax&file=Move&folder='+folder+'&mode=folders&account='+current_account+'&current_folder='+selected_folder,
		dataType: 'html',
		success: function(data){
			$("status").style.display = "none";
			if (data.indexOf('FAILED')>=0) {
				alert(alert_arr.NOT_PERMITTED);
			} else if (data.indexOf('SUCCESS')>=0) {
				current_folder = '';	//forzo per ricaricare la lista
				editViewFolders(false);
				reloadFolders();
				fninvsh('mode2Folder');
			}
		}
	});
}

function CreateFolderDisplay(obj,selected_folder) {
	jQuery('#createFolder_list').html('');
	fnvshobj(obj,'createFolder');
	jQuery('#indicatorcreateFolder').show();
	var url = 'index.php?module=Messages&action=MessagesAjax&file=Move&view=create&mode=folders&account='+current_account+'&current_folder='+selected_folder;
	jQuery.ajax({
		url: url,
		dataType: 'html',
		success: function(data){
			jQuery('#indicatorcreateFolder').hide();
			jQuery('#createFolder_list').html(data);
			jQuery('#createFolder_list #foldername').focus();
			if (jQuery('input:radio[name="selected_folder_create"]:checked').length  == 0) {
				var selector = encodeURIComponent('/').replace(/\%/g,'\\%');
				jQuery("input:radio#check_create_"+selector).attr('checked',true);
			}
		}
	});
}

function selectCreateFolder(foldername) {
	var selector = encodeURIComponent(foldername).replace(/\%/g,'\\%');
	if (jQuery("input:radio#check_create_"+selector).attr('checked')) {
		jQuery("input:radio#check_create_"+selector).attr('checked',false);
	} else {
		jQuery("input:radio#check_create_"+selector).attr('checked',true);
	}
}

function CreateFolder() {
	if (!emptyCheck('foldername',jQuery.trim(alert_arr.LBL_FOLDER),getObj('foldername').type)) {
		return false;
	}
	var foldername = jQuery('#createFolder_list #foldername').val();
	var selected_folder = jQuery('input:radio[name="selected_folder_create"]:checked').val();
	if (selected_folder == '' || selected_folder == 'undefined' || selected_folder == undefined) {
		alert(alert_arr.LBL_SELECT_DEL_FOLDER);
		return false;
	}
	$("status").style.display = "inline";
	jQuery.ajax({
		url: 'index.php?module=Messages&action=MessagesAjax&file=Move&folder='+foldername+'&mode=create&account='+current_account+'&current_folder='+selected_folder,
		dataType: 'html',
		success: function(data){
			$("status").style.display = "none";
			if (data.indexOf('FAILED')>=0) {
				alert(alert_arr.NOT_PERMITTED);
			} else if (data.indexOf('SUCCESS')>=0) {
				current_folder = '';	//forzo per ricaricare la lista
				editViewFolders(false);
				reloadFolders();
				fninvsh('createFolder');
			}
		}
	});
}

//crmv@42801
function printPreview(id) {
	openPopup('index.php?module=Messages&action=MessagesAjax&file=Print&record='+id,document.title,"width=800,height=600","auto",800,600,"top",'nospinner');
}

function printMessage(id) {
	parent.frames[1].focus();
	parent.frames[1].print();
}

function downloadMessage(id) {
	location.href = 'index.php?module=Messages&action=MessagesAjax&file=DetailView&mode=Download&record='+id;
}
//crmv@42801e