<?php
/***************************************************************************************
 * The contents of this file are subject to the CRMVILLAGE.BIZ VTECRM License Agreement
 * ("licenza.txt"); You may not use this file except in compliance with the License
 * The Original Code is:  CRMVILLAGE.BIZ VTECRM
 * The Initial Developer of the Original Code is CRMVILLAGE.BIZ.
 * Portions created by CRMVILLAGE.BIZ are Copyright (C) CRMVILLAGE.BIZ.
 * All Rights Reserved.
 ***************************************************************************************/
/* crmv@42752 crmv@43050 */

require_once('Smarty_setup.php');

global $adb, $table_prefix;
global $mod_strings, $app_strings, $theme;
global $currentModule, $current_user;

$qmod = str_replace('.', '', vtlib_purify($_REQUEST['mod']));
$messageid = intval($_REQUEST['parentid']);
$linktomessage = ($_REQUEST['linktomessage'] == 1);

if (isPermitted($qmod, 'EditView') != 'yes') die('<p>Not authorized</p>');

// related ids
try {
	$relatedIds = Zend_Json::decode($_REQUEST['related_ids']);
} catch (Exception $e) {
	$relatedIds = array();
}

$email = trim($_REQUEST['original_email']);
$name = trim($_REQUEST['original_name']);
$focusMessages = CRMEntity::getInstance('Messages');

$presetFields = $focusMessages->getPopupQCreateValues($qmod, $relatedIds, $email, $name);
// put values into request
foreach ($presetFields as $k=>$v) {
	$_REQUEST[$k] = $v;
}

//crmv@41906
$focusMessages->retrieve_entity_info_no_html($messageid, 'Messages');
$entity_fields = getEntityFieldNames($qmod);
if (is_array($entity_fields['fieldname'])) {
	$entity_fieldname = $entity_fields['fieldname'][0];
} else {
	$entity_fieldname = $entity_fields['fieldname'];
}
if (!empty($entity_fieldname)) {
	$_REQUEST[$entity_fieldname] = $focusMessages->column_fields['subject'];
}
$_REQUEST['description'] = strip_tags($focusMessages->column_fields['description']);
//crmv@41906e

unset($_REQUEST['record']);
$_REQUEST['module'] = $currentModule = $qmod;
$_REQUEST['action'] = 'EditView';
$_REQUEST['hide_button_list'] = 1;

$label_back = ($_REQUEST['popup_mode'] == 'onlycreate' ? getTranslatedString('LBL_CANCEL_BUTTON_LABEL') : getTranslatedString('LBL_BACK'));
// fake top buttons
?>
<table border="0" cellspacing="0" cellpadding="0" width=100%"><tr>
	<td align="right">
		<input class="crmbutton small save" onclick="popupCreateSave('<?php echo $qmod; ?>')" type="button" title="<?php echo getTranslatedString('LBL_SAVE_BUTTON_TITLE'); ?>" value="  <?php echo getTranslatedString('LBL_SAVE_BUTTON_LABEL'); ?>  " style="width:70px" >
		<input class="crmbutton small cancel" onclick="popupCreateCancel()" type="button" title="<?php echo $label_back ?>" value="  <?php echo $label_back ?>  " style="width:70px" >
	</td>
</tr></table>
<?php

require("modules/$currentModule/EditView.php");
?>