/************************************************************************************
 * The contents of this file are subject to the vtiger CRM Public License Version 1.0
 * ("License"); You may not use this file except in compliance with the License
 * The Original Code is:  vtiger CRM Open Source
 * The Initial Developer of the Original Code is vtiger.
 * Portions created by vtiger are Copyright (C) vtiger.
 * Portions created by CRMVILLAGE.BIZ are Copyright (C) CRMVILLAGE.BIZ.
 * All Rights Reserved.
 ************************************************************************************/

loadFileJs('modules/Products/multifile.js');
loadFileJs('include/js/Merge.js');

function updateListPrice(unitprice,fieldname, oSelect)
{
	if(oSelect.checked == true)
	{
		document.getElementById(fieldname).style.visibility = 'visible';
		document.getElementById(fieldname).value = unitprice;
	}else
	{
		document.getElementById(fieldname).style.visibility = 'hidden';
	}
}

function check4null(form)
{
	var isError = false;
	var errorMessage = "";
	if (trim(form.productname.value) =='') {
		isError = true;
		errorMessage += "\n Product Name";
		form.productname.focus();
	}
	if (isError == true) {
		alert(alert_arr.MISSING_REQUIRED_FIELDS + errorMessage);
		return false;
	}
	return true;
}

function set_return(product_id, product_name) {
	//crmv@29190
	var formName = getReturnFormName();
	var form = getReturnForm(formName);
	//crmv@29190e
	form.parent_name.value = product_name;
	form.parent_id.value = product_id;
	disableReferenceField(form.parent_name,form.parent_id,form.parent_id_mass_edit_check);	//crmv@29190
}

function set_return_specific(product_id, product_name) {
	//crmv@29190
	var formName = getReturnFormName();
	var form = getReturnForm(formName);
	//crmv@29190e
	form.product_name.value = product_name;
	form.product_id.value = product_id;
	disableReferenceField(form.product_name,form.product_id,form.product_id_mass_edit_check);	//crmv@29190
}

function add_data_to_relatedlist(entity_id,recordid) {
	opener.document.location.href="index.php?module={RETURN_MODULE}&action=updateRelations&smodule={SMODULE}&destination_module=Products&entityid="+entity_id+"&parentid="+recordid;
}

function set_return_inventory(product_id,product_name,unitprice,qtyinstock,taxstr,curr_row,desc,subprod_id,product_code) {	//crmv@16267
	var subprod = subprod_id.split("::");
	//crmv@48407
	var jQuery_obj = jQuery;
	if (jQuery("form[name=EditView] input#subproduct_ids"+curr_row).length <= 0){
		jQuery_obj = parent.jQuery;
	}
	jQuery_obj("form[name=EditView] input#subproduct_ids"+curr_row).val(subprod[0]);
	jQuery_obj("form[name=EditView] input#subprod_names"+curr_row).val(subprod[1]);
	jQuery_obj("form[name=EditView] input#productName"+curr_row).val(product_name);
	jQuery_obj("form[name=EditView] input#hdnProductId"+curr_row).val(product_id);
	disableReferenceField(jQuery_obj("form[name=EditView] input#hdnProductId"+curr_row));
	jQuery_obj("form[name=EditView] input#listPrice"+curr_row).val(unitprice);
	jQuery_obj("form[name=EditView] input#productDescription"+curr_row).val(desc);
	jQuery_obj("form[name=EditView] input#hdnProductcode"+curr_row).val(product_code);
	jQuery_obj("form[name=EditView] #qtyInStock"+curr_row).html(qtyinstock);
	var tax_array = new Array();
	var tax_details = new Array();
	tax_array = taxstr.split(',');
	for(var i=0;i<tax_array.length;i++)
	{
		tax_details = tax_array[i].split('=');
	}
	jQuery_obj("form[name=EditView] input#qty"+curr_row).focus();
	//crmv@48407 e
	/*	
	//crmv@21048m
	parent.document.EditView.elements["subproduct_ids"+curr_row].value = subprod[0];
	parent.document.getElementById("subprod_names"+curr_row).innerHTML = subprod[1];

	parent.document.EditView.elements["productName"+curr_row].value = product_name;
	parent.document.EditView.elements["hdnProductId"+curr_row].value = product_id;
	disableReferenceField(parent.document.EditView.elements["productName"+curr_row]);	//crmv@29190

	parent.document.EditView.elements["listPrice"+curr_row].value = unitprice;
	//crmv@16267
	//parent.document.EditView.elements["comment"+curr_row].value = desc;
	parent.document.EditView.elements["productDescription"+curr_row].value = desc;
	parent.document.EditView.elements["hdnProductcode"+curr_row].value = product_code;
	//crmv@16267e
	//getOpenerObj("unitPrice"+curr_row).innerHTML = unitprice;
	getOpenerObj("qtyInStock"+curr_row).innerHTML = qtyinstock;

	var tax_array = new Array();
	var tax_details = new Array();
	tax_array = taxstr.split(',');
	for(var i=0;i<tax_array.length;i++)
	{
		tax_details = tax_array[i].split('=');
	}

	parent.document.EditView.elements["qty"+curr_row].focus();
	//crmv@21048me
	*/
}

function set_return_inventory_po(product_id,product_name,unitprice,taxstr,curr_row,desc,subprod_id,product_code) {	//crmv@26660
	var subprod = subprod_id.split("::");
	//crmv@48407
	var jQuery_obj = jQuery;
	if (jQuery("form[name=EditView] input#subproduct_ids"+curr_row).length <= 0){
		jQuery_obj = parent.jQuery;
	}
	jQuery_obj("form[name=EditView] input#subproduct_ids"+curr_row).val(subprod[0]);
	jQuery_obj("form[name=EditView] input#subprod_names"+curr_row).val(subprod[1]);
	jQuery_obj("form[name=EditView] input#productName"+curr_row).val(product_name);
	jQuery_obj("form[name=EditView] input#hdnProductId"+curr_row).val(product_id);
	disableReferenceField(jQuery_obj("form[name=EditView] input#productName"+curr_row));
	jQuery_obj("form[name=EditView] input#listPrice"+curr_row).val(unitprice);
	jQuery_obj("form[name=EditView] input#productDescription"+curr_row).val(desc);
	jQuery_obj("form[name=EditView] input#hdnProductcode"+curr_row).val(product_code);
	var tax_array = new Array();
	var tax_details = new Array();
	tax_array = taxstr.split(',');
	for(var i=0;i<tax_array.length;i++)
	{
		tax_details = tax_array[i].split('=');
	}
	jQuery_obj("form[name=EditView] input#qty"+curr_row).focus();
	//crmv@48407 e	
	/*	
	//crmv@21048m
	parent.document.EditView.elements["subproduct_ids"+curr_row].value = subprod[0];
	parent.document.getElementById("subprod_names"+curr_row).innerHTML = subprod[1];

	parent.document.EditView.elements["productName"+curr_row].value = product_name;
	parent.document.EditView.elements["hdnProductId"+curr_row].value = product_id;
	disableReferenceField(parent.document.EditView.elements["productName"+curr_row]);	//crmv@29190
	parent.document.EditView.elements["listPrice"+curr_row].value = unitprice;
	parent.document.EditView.elements["productDescription"+curr_row].value = desc;		//crmv@26660
	parent.document.EditView.elements["hdnProductcode"+curr_row].value = product_code;	//crmv@26660

	var tax_array = new Array();
	var tax_details = new Array();
	tax_array = taxstr.split(',');
	for(var i=0;i<tax_array.length;i++)
	{
		tax_details = tax_array[i].split('=');
	}

	parent.document.EditView.elements["qty"+curr_row].focus();
	//crmv@21048me
	*/
}

function getImageListBody() {
	if (browser_ie) {
		var ImageListBody=getObj("ImageList")
	} else if (browser_nn4 || browser_nn6) {
		if (getObj("ImageList").childNodes.item(0).tagName=="TABLE") {
			var ImageListBody=getObj("ImageList")
		} else {
			var ImageListBody=getObj("ImageList")
		}
	}
	return ImageListBody;
}