<?php
$_SESSION['modules_to_update']['Morphsuit'] = 'packages/vte/mandatory/Morphsuit.zip';

SDK::setLanguageEntries('Morphsuit', 'LBL_MORPHSUIT_USER_NUMBER_5', array('it_it'=>'5','en_us'=>'5'));
SDK::setLanguageEntries('Morphsuit', 'LBL_MORPHSUIT_USER_NUMBER_200', array('it_it'=>'200','en_us'=>'200'));
SDK::setLanguageEntries('Morphsuit','LBL_MORPHSUIT_BUSINESS_ACTIVATION',array('it_it'=>'E` necessario attivare una versione Business On Site.','en_us'=>'You have to activate a Business On Site version.'));

$new_en_us_translations = array(
	array('module'=>'Morphsuit','label'=>'LBL_MORPHSUIT_INSTALLATION_LENGTH','trans_label'=>'Installation duration'),
	array('module'=>'Morphsuit','label'=>'LBL_MORPHSUIT_CODE_WRONG','trans_label'=>'Invalid activation key'),
	array('module'=>'Morphsuit','label'=>'LBL_MORPHSUIT_CODE_WRONG_TIME_EXPIRED','trans_label'=>'Obsolete activation key'),
	array('module'=>'Morphsuit','label'=>'LBL_MORPHSUIT_ACTIVATION_MAIL_OK','trans_label'=>'Mail has been sent to VTECRM Network service, check your inbox for the activation key.'),
	array('module'=>'Morphsuit','label'=>'LBL_MORPHSUIT_USER_NUMBER_EXCEEDED','trans_label'=>'Number of users exceeded the limit. Request a new license at your administrator.'),
	array('module'=>'Morphsuit','label'=>'LBL_MORPHSUIT_NEW_LICENSE_REGISTRATION','trans_label'=>'Do you want to save the new license now?'),
	array('module'=>'Morphsuit','label'=>'LBL_ERROR_VTE_FREE_CHECK','trans_label'=>'Error key. Verify number of  active users.'),
	array('module'=>'Morphsuit','label'=>'LBL_MORPHSUIT_USER_NUMBER_EXCEEDED_FREE','trans_label'=>'Number of users exceeded the Free version. Click \'OK\' if you want to upgrade to the Standard version of VTE.'),
	array('module'=>'Morphsuit','label'=>'LBL_ERROR_VTE_REGISTRATION','trans_label'=>'You have to sign up to www.crmvillage.biz'),
	array('module'=>'Morphsuit','label'=>'LBL_FUNCTION_BLOCKED','trans_label'=>'This function is only available in VTE ONSITE BUSINESS. If you want to continue and upgrade, please contact CRMVILLAGE at %s. Please specify how many users you want to enable.'),
	array('module'=>'Morphsuit','label'=>'LBL_MORPHSUIT_ROLE_NUMBER_EXCEEDED','trans_label'=>'You have exceeded the number of roles available in the FREE version.'),
	array('module'=>'Morphsuit','label'=>'LBL_MORPHSUIT_PROFILE_NUMBER_EXCEEDED','trans_label'=>'You have exceeded the number of profiles available in the FREE version.'),
	array('module'=>'Morphsuit','label'=>'LBL_MORPHSUIT_PDF_NUMBER_EXCEEDED','trans_label'=>'You have exceeded the number of pdf\'s available in the FREE version.'),
	array('module'=>'Morphsuit','label'=>'LBL_MORPHSUIT_ADV_SHARING_RULE_NUMBER_EXCEEDED','trans_label'=>'You have exceeded the number of advanced sharing rules available in the FREE version.'),
	array('module'=>'Morphsuit','label'=>'LBL_MORPHSUIT_SHARING_RULE_USER_NUMBER_EXCEEDED','trans_label'=>'You have exceeded the number of sharing rules owner based available in the FREE version.'),
	array('module'=>'Morphsuit','label'=>'LBL_ERROR_VTE_FREE_NOT_ACTIVABLE','trans_label'=>'This version is no valid. Install/Update to the latest version.'),
	array('module'=>'Morphsuit','label'=>'LBL_CONNECT_TO_ENABLE_VTE','trans_label'=>'Check the internet connection and login again to unlock VTECRM'),
	array('module'=>'Morphsuit','label'=>'LBL_OTHER_FREE_VERSION','trans_label'=>'Probably you have moved your VTE installation. Some functionality of this old installation is limited.'),
	array('module'=>'Morphsuit','label'=>'LBL_MORPHSUIT_ADMIN_CONFIG','trans_label'=>'Set the administrator'),
	array('module'=>'Morphsuit','label'=>'LBL_MORPHSUIT_OVERWRITE_CREDENTIALS','trans_label'=>'Admin user credentials will be overwritten by vtecrm.com credentials'),
);
foreach($new_en_us_translations as $t) {
	SDK::setLanguageEntry($t['module'], 'en_us', $t['label'], $t['trans_label_new']);
}
?>